/* ================================================================================================ /
*
*	Diablo Mod: 
*	------------------
*
*	Need:		This compiled and items files
*	Works with:	AMXX ? Cs 1.6
*
*	Installation:
*	-------------------
*	Copy script into plugins and edit plugins.ini
*	Copy item diablo directory into addons/amxmodx
*	If you amx directory is not called addons/amxmodx/.. just create a new path
*
*	Credits:
*	-----------------
*	Spacedude
*	Some others back when amx mod started :]	
*	twistedeuphoria
*
*	diablo_xpbonus = Xp on each kill (without bonus)
*	diablo_durability = Will your item loose durability on damage? And how much each time
*	diablo_saveitems = Save items when map changes
*	diablo_spawnchance = 1/x chance to spawn powerup on each roundstart
*
*	Contact:
*	-----------------
*	email: mortengryning@gmail.com
*
/ ================================================================================================= */

new Basepath[50] = "addons/amxmodx/diablo/"	//Path from Cstrike base directory

#include <amxmodx>
#include <engine>
#include <fakemeta> 
#include <fakemeta_util>
#include <fun>
#include <cstrike>
#include <amxmisc>
#include <nvault>
#include <hamsandwich>
#include <xs>

#define RESTORETIME 30.0	 //How long from server start can players still get their item trasferred (s)
#define MAX 32			 //Max number of valid player entities
#define CHEAT 0			 //Cheat for testing purposes
#define CS_PLAYER_HEIGHT 72.0
#define GLOBAL_COOLDOWN 0.5
#define TASK_GREET 240
#define TASK_HUD 120
#define TASK_HOOK 360

#define TASK_ID 128000

#define SPEED 800.0
#define FALL_VELOCITY 350.0
#define is_valid_player(%1) (1 <= %1 <= 32)

#define is_player(%0)    (1 <= %0 <= giMaxplayers)
#define TASK_BARTIME 16000

#define TASK_SHADOW -736

#define x 0
#define y 1
#define z 2

#define SetUserReversed(%1)		g_bMigraineux |= 1<<(%1 & 31)
#define ClearUserReversed(%1)		g_bMigraineux &= ~( 1<<(%1 & 31) )

#define m_pPlayer 41
#define m_iId 43
#define m_iClip 51
#define m_flNextPrimaryAttack   46
#define m_flNextSecondaryAttack 47


#define PALLET_MINS Float:{ -27.260000, -22.280001, -22.290001 }
#define PALLET_MAXS Float:{  27.340000,  26.629999,  29.020000 }

#define	TASK_ENTANGLEWAIT	928

#define BALL_CLASSNAME "displacer_ball"
#define BEAM_CLASSNAME "dispball_beam"

new m_Plasma,m_DispRing

new SPRITE_PLASMA[] = "sprites/plasma.spr"
new SPRITE_RING[] = "sprites/displacer_ring.spr"

#define pev_zorigin	pev_fuser4
#define seconds(%1) ((1<<12) * (%1))

new SOUND_START[] 	= "items/medshot4.wav"
new SOUND_FINISHED[] 	= "items/smallmedkit2.wav"
new SOUND_FAILED[] 	= "items/medshotno1.wav"

enum
{
TASKID_REVIVE = 1337,
TASKID_RESPAWN,
TASKID_CHECKRE,
TASKID_CHECKST,
TASKID_ORIGIN,
TASKID_SETUSER
}

new Float:g_revive_delay[33]
new Float:g_body_origin[33][3]
new bool:g_wasducking[33]

static const v_knife[] = "models/knife/v_dragontail.mdl"
static const p_knife[] = "models/knife/p_dragontail.mdl"
new const dragon_knife_effect[] = "models/knife/ef_dragontail.mdl"

static const SoundList[][] =
{
	"dragontail/dragontail_deploy1.wav",	// 0
	"dragontail/dragontail_hwall.wav",	// 1
	"dragontail/dragontail_slash1.wav",	// 2
	"dragontail/dragontail_stab.wav",	// 3
	"dragontail/dragontail1.wav",	// 4
	"dragontail/dragontail2.wav"	// 5
}

//Version of the mod
new Float:version = 9.0

// Save Nvalult
new g_vault

new gmsgFade
new gmsgDeathMsg
new gmsgStatusText
new gmsgBartimer
new gmsgScoreInfo

new bool:freeze_ended
new c4state[33]
new c4bombc[33][3] 
new c4fake[33]
new fired[33]
new bool:ghost_check
new ghosttime[33]
new ghoststate[33]
new sversion[16]

new sprite_blood_drop = 0
new sprite_blood_spray = 0
new sprite_gibs = 0
new sprite_white = 0
new sprite_fire = 0
new sprite_beam = 0
new sprite_boom = 0
new sprite_line = 0
new sprite_lgt = 0
new sprite_laser = 0
new sprite_ignite = 0
new sprite_smoke = 0
new g_Explosion

new player_xp[33] = 0		//Holds players experience
new player_lvl[33] = 1		//Holds players level
new player_point[33] = 0		//Holds players level points
new player_item_id[33] = 0	//Items id
new player_item_name[33][128] 	  //The items name
new player_intelligence[33]
new player_powerint[33]
new player_strength[33]
new player_agility[33]
new Float:player_damreduction[33]
new player_dextery[33]
new player_class[33]		
new Float:player_huddelay[33]

//Item attributes
new player_b_vampire[33] = 0	//Vampyric damage
new player_b_damage[33] = 0	//Bonus damage
new player_b_money[33] = 0	//Money bonus
new player_b_gravity[33] = 0	//Gravity bonus : 1 = best
new player_b_inv[33] = 0		//Invisibility bonus
new player_b_grenade[33] = 0	//Grenade bonus = 1/chance to kill
new player_b_reduceH[33] = 0	//Reduces player health each round start
new player_b_theif[33] = 0	//Amount of money to steal
new player_b_respawn[33] = 0	//Chance to respawn upon death
new player_b_explode[33] = 0	//Radius to explode upon death
new player_b_heal[33] = 0	//Ammount of hp to heal each 5 second
new player_b_gamble[33] = 0	//Random skill each round : value = vararity
new player_b_blind[33] = 0	//Chance 1/Value to blind the enemy
new player_b_fireshield[33] = 0	//Protects against explode and grenade bonus 
new player_b_meekstone[33] = 0	//Ability to lay a fake c4 and detonate 
new player_b_teamheal[33] = 0	//How many hp to heal when shooting a teammate 
new player_b_redirect[33] = 0	//How much damage will the player redirect 
new player_b_fireball[33] = 0	//Ability to shot off a fireball value = radius
new player_b_ghost[33] = 0	//Ability to walk through stuff
new player_b_eye[33] = 0		//Ability to place camera
new player_b_blink[33] = 0	//Ability to get a railgun
new player_b_windwalk[33] = 0	//Ability to windwalk away
new player_b_usingwind[33] = 0	//Is player using windwalk
new player_b_reverse[33] = 0	//Ability to reverse other players controls on hit
new player_b_froglegs[33] = 0	//Ability to hold down duck for 4 sec to frog-jump
new player_b_silent[33]	= 0	//Is player silent
new player_b_dagon[33] = 0	//Ability to nuke an opponent
new player_b_sniper[33] = 0	//Ability to kill in 1/sniper with scout
new player_b_jumpx[33] = 0	//Ability to double jump
new player_b_smokehit[33] = 0	//Ability to hit and kill with smoke :]
new player_b_extrastats[33] = 0	//Ability to gain extra stats
new player_b_firetotem[33] = 0	//Ability to put down a fire totem that explodes after 7 seconds
new player_b_hook[33] = 0	//Ability to grap a player a hook him towards you
new player_b_darksteel[33] = 0	//Ability to damage double from behind the target 	
new player_b_illusionist[33] = 0	//Ability to use the illusionist escape
new player_b_mine[33] = 0	//Ability to lay down mines
new player_b_hsprotection[33] = 0//Protection to kill HeadShoot
new player_b_refleksja[33] = 0 	 //Give 16000$
new player_b_polimorf[33] = 0	//Give HE, SMOKE, 2xFLASH
new player_b_chance_spawn[33] = 0//chance to enemy spawn
new player_b_drop[33] = 0     	//Drop weapon enemy
new player_b_bunnyhop[33] = 0	//bunnyhop item
new player_b_jumphe[33] = 0	//Jump for hE
new player_b_stone[33] = 0	//none
new player_b_feeblemind[33] = 0	//slap to attack enemy
new player_powerslap[33] = 0	//power slap
new player_b_aspeed[33] = 0	//Improved speed
new player_b_c4[33] = 0		//You have c4 to plant
new player_b_crosshair[33] = 0	//cros to all snipers
new player_b_grav[33] = 0	//Change gravity ra\num
new player_b_shake[33] = 0	//Shake your screen
new player_b_radar[33] = 0	//radar
new player_b_pozornosc[33] = 0	//Change Skin
new player_b_course[33] = 0	//Course HE
new player_b_nightsight[33] = 0	//No flash
new player_b_celnosc[33] = 0	//No recoil
new player_b_air[33] = 0		//Jump+Jump+Jump+Jump+Jump infinitely many
new player_b_awp[33] = 0		//Instant Kill with AWP
new player_b_fasthand[33] = 0	//Fast reolad weapon
new player_b_unlimited[33] = 0	//nielimitowana amunicja
new player_b_ak47m4[33] = 0	//Give ak47m4
new player_b_falling[33] = 0	//Fallllllll
new player_b_deagle[33] = 0	//1\x z Deagla
new player_b_giveawp[33] = 0	//Give awp round
new player_b_book[33] = 0	//Book expirence
new player_b_person[33] = 0	//3D Person
new player_b_glock[33] = 0	//Ability to kill in 1/(this) to instant kill with glock\usp
new player_b_revea[33] = 0	//Invisible in duck
new player_b_spawnuse[33] = 0	//+USE to spawn
new player_b_hpplus[33] = 0	//+35 hp
new player_b_zonk[33] = 0	//Lost weapon bad item :( 
new player_b_knife[33] = 0	//Ability to kill in 1/knifed with knife
new player_b_conjurg[33] = 0	//Lighting Scout
new player_b_commemorative[33] = 0//Looooong knifeee ;d and damage ;)
new player_b_altar[33] = 0	//Speed on knife
new player_b_hatched[33] = 0	//Off attack
new player_b_invknife[33] = 0	//Invisible on knife
new player_b_lake[33] = 0	//Lake Shit 
new player_b_autoshoot[33] = 0	//auto shooting
new player_b_whitep[33] = 0	//Lighting
new player_b_shift[33] = 0	//Ree
new player_b_harpsichord[33] = 0	//See mines, +hp
new player_b_sack[33] = 0	//Sack of f
new player_b_silver[33] = 0	//Silver Snake Venom
new player_b_acid[33] = 0	//Acid Slug, radiance
new player_b_justice[33] = 0	//2x exp,-50%hp
new player_b_horse[33] = 0	//Fireeee
new player_b_artifactr[33] =0 	//Atrifact Godmoode
new player_b_elecirtc[33] = 0	//Inv time
new player_b_anvil[33] = 0	//Anvil 2xHeal X Sek
new player_b_spittoon[33] = 0	//spittoon
new player_b_pennant[33] = 0	//Fast fire 
new player_b_chest[33] = 0	//healt knife
new player_b_mandrake[33] = 0	//Mandrake lighter
new player_b_juggernaut[33] = 0	//Widzenie niewidzialnych
new player_b_wizard[33] = 0	//50% mniej dmg
new player_b_oven[33] = 0	//Dmg+int 
new player_b_candelabra[33] = 0	//Gravity+1\2 scout
new player_b_jar[33] = 0		//Jaar+hp frag
new player_b_bookofprpoh[33] = 0	//Frags hp 
new player_b_bless[33] = 0       //Bless for speed
new player_b_xylophone[33] = 0	//Xylophone
new player_b_pitchfork[33] = 0	//Pitchfork
new player_b_halberd[33] = 0	//Halberd weapon knife enemy
new player_b_loaf[33] = 0	//Loaf knife damage plus
new player_b_inkwell[33] = 0	//M3 Gooood
new player_b_humility[33] = 0	//Godmode po smierci
new player_b_maul[33] = 0	//Bersek Hight View
new player_b_throwingaxe[33] = 0	//Knifee +INT
new player_b_runeofvalor[33] = 0	//Rune of Valor death oslepienie
new player_b_blackpearl[33] = 0	//Black Pearl
new player_b_bloodmoss[33] = 0	//Bloood Moos 
new player_b_garlic[33] = 0	//Garlic 
new player_b_newmoon[33] = 0	//New mood 
new player_b_rebracer[33] = 0	//Resilient Bracer
new player_b_ashroudnecro[33] = 0//A Necromancer Shroud
new player_b_toxic[33] = 0	//A Toxic Potion Of Virulent Rose Extract
new player_b_rose[33] = 0	//Virulent Rose Extract
new player_b_rosemoney[33] = 0	//How many money
new player_b_plasma[33] = 0	//Plasma fire
new player_b_ninjaitem[33] = 0	//Ninja knife and inv
new player_b_essence[33] = 0	//Essence Of Achievement
new player_b_ecrucitrine[33] = 0	//Ecru Citrine
new player_b_scrapper[33] = 0	//Scrapper`s Compendium
new player_b_transcendence [33] =  0//Scroll Of Transcendence
new player_b_commodity[33] = 0	//Commodity Deed Worth
new player_b_shard[33] = 0	//Skystone Shard
new player_b_instantxm1014[33] = 0//Mesanna Roulette
new player_b_instantm4a1[33] = 0	//Instatnt M4
new player_b_instantak47[33] = 0	//ak47
new player_b_instantjuki[33] = 0	//Juka instant kill
new player_b_assignment[33] = 0	//jumpx and hp
new player_b_themagi[33] = 0	//The Magi
new player_b_blackrock[33] = 0	//Blackrock tmp uzi
new player_b_tome[33] = 0	//Wall block 

new player_dc_name[33][99]	//Information about last disconnected players name
new player_dc_item[33]		//Information about last disconnected players item
new player_c_name[33][50]	//Information about last map->now
new player_c_item[33]		//Information about alst map->now
new Float:player_b_oldsen[33]	//Players old sens

new player_rs_health[33] = 0
new c_shake[33]
new jumpppp[33];
new bool:itemrestore = true	//Can playere restore item
new bool:updatedtable = false	//Has restore table been updated?
new bool:player_b_dagfired[33]	//Fired dagoon?
new bool:used_item[33] 
new bool:used_reset[33]
new jumps[33]			//Keeps charge with the number of jumps the user has made
new bool:dojump[33]		//Are we jumping?
new item_boosted[33]		//Has this user boosted his item?
new earthstomp[33]
new bool:falling[33]
new gravitytimer[33]
new item_durability[33]		//Durability of hold item
new bullets[ 33 ]
new auto[33]
new szkielet_damage[33] = 0
new juggernaut[33] = 0
new ilosc_beltow[32];
new g_god[33], g_killer[33]
new has_commodity[33] = 0
new palenie_gracza[33];
new duchownyrandomhp[33] = 0
new duchownyrandominv[33] = 0
new totemstop[33], zatakowany[33]
new g_bMigraineux
new Float:g_vecPunchAngles[MAX+1][3]
new bool:atakowanymir[33] = false;
new gmsg_SetFOV;

new LeaderCT = -1
new LeaderT = -1

enum { BRAK = 0, SORC, MONK, PALADIN, ASSASSIN, NECROMANCER, BARBARIAN, NINJA, AMAZONKA, MEFISTO, DIABLO, SZKIELET, DRAGONAN, DUCHOWNY, LIZARDMEN, JUKA, SAVAGES, MEER, TERATHAN, ARIEL, ARACHNID, OPHIDIAN }
new Race[22][46] = { "Brak","Sorcerer","Monk","Paladin","Assassin","Necrom","Barbarian", "Ninja", "Amazonka", "Mefisto", "Diablo", "Szkielet", "Dragonan", "Duchowny", "Lizardmen", "Juka", "Savages", "Meer", "Terathan", "Ariel", "Arachnid", "Ophidian" }

/*new LevelXP[25] = { 0,25,85,185,300,450,700,850,1000,1335,1500,1800,2100,2400,2800,3200,3600,4000,
4500,5000,5500,6000,6500,100000000}*/

new const LevelXP[] = {
0,
104, 323, 626, 1005, 1384, 2019, 2740, 3501, 4309, 5273, 
6365, 7534, 8757, 9982, 11557, 13159, 14914, 16926, 19019, 21145, 
23297, 25646, 28028, 30508, 33159, 35974, 38919, 41992, 45161, 48401, 
51658, 54945, 58363, 62127, 65923, 69871, 73918, 77966, 82042, 86245, 
90503, 95099, 99764, 104595, 109578, 114599, 119648, 124815, 130194, 135719, 
141247, 146959, 152829, 158709, 164749
}		 


new CT_Skins[4][] = {"sas","gsg9","urban","gign"};
new Terro_Skins[4][] = {"arctic","leet","guerilla","terror"};

new const maxClip[31] = { -1, 13, -1, 10,  1,  7,  1,  30, 30,  1,  30,  20,  25, 30, 35, 25,  12,  20, 
10,  30, 100,  8, 30,  30, 20,  2,  7, 30, 30, -1,  50 };

new CSW_MAXAMMO[33]= {-2, 52, 0, 90, 1, 32, 1, 100, 90, 1, 120, 100, 100, 90, 90, 90, 100, 120, 30, 120, 200, 32, 90, 120, 90, 2, 35, 90, 90, 0, 100, -1, -1}

const Wep_scout = ((1<<CSW_SCOUT))

static const nazwyweponow[] = { "", "weapon_p228", "", "weapon_scout", "weapon_hegrenade", "weapon_xm1014", "weapon_c4", "weapon_mac10",
"weapon_aug", "weapon_smokegrenade", "weapon_elite", "weapon_fiveseven", "weapon_ump45", "weapon_sg550",
"weapon_galil", "weapon_famas", "weapon_usp", "weapon_glock18", "weapon_awp", "weapon_mp5navy", "weapon_m249",
"weapon_m3", "weapon_m4a1", "weapon_tmp", "weapon_g3sg1", "weapon_flashbang", "weapon_deagle", "weapon_sg552",
"weapon_ak47", "weapon_knife", "weapon_p90" }

new g_iOldClip
new g_iShotgunOwner

new Float:g_fBackupAngle[3]
new Float:g_fAimFrom[3]
new Float:g_fAimTo[3]

//Used for powerupsystem
new CTstart[3]
new Tstart[3]
new NextPowerup[3]
new bool:spawnset = false
new bool:havespawn = false
new bool:powerup_taken = false

//Walljump
new bool:caughtJump[33]
new bool:doJump[33]
new Float:jumpVeloc[33][3]
new newButton[33]
new numJumps[33]

//For Hook and powerup sy
new hooked[33]
new Float:player_global_cooldown[33]

//For optimization
new last_update_xp[33]
new Float:last_update_perc[33]
new bool:use_addtofullpack


//Flags a user can have
enum
{
Flag_Ignite = 0,
Flag_Hooking,
Flag_Rot,
Flag_Dazed,
Flag_Illusion,
Flag_Moneyshield,
Flag_Teamshield,
Flag_Teamshield_Target,
num_of_flags
}


//Flags
new afflicted[33][num_of_flags]

//Radar
new g_msgHostageAdd, g_msgHostageDel; // radar

new giMaxplayers

/* PLUGIN CORE REDIRECTING TO FUNCTIONS ========================================================== */

public plugin_init()
{
	g_vault = nvault_open("Diablo_stats_v9")
	float_to_str(version,sversion,15)
	register_plugin("DiabloMod",sversion,"Morten edit FORMOZA") 
	register_cvar("diablomod_version",sversion,FCVAR_SERVER)
	register_event("CurWeapon","CurWeapon","be") 
	register_event("CurWeapon", "make_tracer", "be", "1=1", "3>0")
	register_event("ResetHUD", "ResetHUD", "abe")
	register_event("HLTV", "event_hltv", "a", "1=0", "2=0")
	register_event("DeathMsg","DeathMsg","ade") 
	register_event("Damage", "Damage", "b", "2!0")
	register_event("Damage", "Damage_Wyrzucenie", "b", "2!=0");
	register_event("Damage", "hedamage_event", "b", "2!0", "4!0", "5!0", "6!0")
	register_event("SendAudio","freeze_over","b","2=%!MRAD_GO","2=%!MRAD_MOVEOUT","2=%!MRAD_LETSGO","2=%!MRAD_LOCKNLOAD")
	register_event("SendAudio","freeze_begin","a","2=%!MRAD_terwin","2=%!MRAD_ctwin","2=%!MRAD_rounddraw") 
	register_event("SendAudio", "award_defuse", "a", "2&%!MRAD_BOMBDEF")  	
	register_event("TextMsg", "award_hostageALL", "a", "2&#All_Hostages_R" ); 
	register_event("TextMsg","host_killed","b","2&#Killed_Hostage") 
	register_event("SendAudio","eventGrenade","bc","2=%!MRAD_FIREINHOLE")
	register_event("TextMsg", "freeze_begin", "a", "2=#Game_will_restart_in")
	register_logevent("award_plant", 3, "2=Planted_The_Bomb");	
	register_logevent("RoundStart", 2, "0=World triggered", "1=Round_Start")
	register_logevent("RoundEnd", 2, "1=Round_End");
	register_clcmd("say /dropitem","dropitem") 
	register_clcmd("say /drop","dropitem")
	register_clcmd("say /wyrzuc","dropitem")
	register_clcmd("dropitem","dropitem") 
	register_clcmd("/dropitem","dropitem") 
	register_clcmd("say /iteminfo","iteminfo")
	register_clcmd("say /item","iteminfo")
	register_clcmd("iteminfo","iteminfo")
	register_clcmd("/iteminfo","iteminfo")
	register_clcmd("say /item","iteminfo")
	register_clcmd("say /perk","iteminfo")
	register_clcmd("say /helpme","helpme") 
	register_clcmd("say /help","helpme") 
	register_clcmd("say /info","helpme")
	register_clcmd("say /reset","reset_skill")
	register_clcmd("say /resetskills","reset_skill")
	register_clcmd("say /changerace","changerace")
	register_clcmd("say /klasa","changerace")
	register_clcmd("say /rasa","changerace")
	register_clcmd("say changerace","changerace")
	register_clcmd("changerace","changerace")
	register_clcmd("say /change","changerace")
	register_clcmd("say /changeclass","changerace")
	register_clcmd("say changeclass","changerace")
	register_clcmd("say /skills", "showskills")
	register_clcmd("say skill", "showskills")
	register_clcmd("say /menu","showmenu") 
	register_clcmd("menu","showmenu")
	register_clcmd("helpme","helpme") 
	register_clcmd("say /rune","buyrune") 
	register_clcmd("say /sklep","buyrune") 
	register_clcmd("/rune","buyrune") 
	register_clcmd("rune","buyrune") 
	//register_clcmd("say 3d","widokk")
	register_clcmd("/skills","showskills")
	register_clcmd("/skillsinfo","showskills")
	register_clcmd("say /skillsinfo","showskills")
	register_clcmd("say /skills","showskills")
	register_clcmd("fullupdate","fullupdate")
	register_menucmd(register_menuid("Wybierz umiejetnosci"), 1023, "skill_menu")
	register_message(get_user_msgid("ScreenFade"), "messageScreenFade");
	register_message(get_user_msgid("SayText"),"handleSayText");
	set_msg_block(get_user_msgid("ClCorpse"), BLOCK_SET);
	gmsgDeathMsg = get_user_msgid("DeathMsg")
	gmsgStatusText = get_user_msgid("StatusText")
	gmsgFade = get_user_msgid("ScreenFade")
	gmsg_SetFOV = get_user_msgid("SetFOV")
	gmsgBartimer = get_user_msgid("BarTime") 
	gmsgScoreInfo = get_user_msgid("ScoreInfo") 
	g_msgHostageAdd = get_user_msgid("HostagePos");
	g_msgHostageDel = get_user_msgid("HostageK");
	register_cvar("diablo_saveitems","1",0) 
	register_cvar("diablo_xpbonus","25",0) 
	register_cvar("diablo_durability","10",0) 
	register_cvar("diablo_spawnchance","2",0)
	register_cvar("SaveXP", "1")
	set_msg_block ( gmsgDeathMsg, BLOCK_SET ) 
	set_task(5.0, "Timed_Healing", 0, "", 0, "b")
	set_task(1.0, "Timed_Ghost_Check", 0, "", 0, "b")
	set_task(1.0, "radar_scan", _, _, _, "b");
	set_task(0.8, "UpdateHUD",0,"",0,"b")
	set_task(RESTORETIME, "DisableItemRestore",0,"",0,"a")
	register_think("PlayerCamera","Think_PlayerCamera");
	register_think("PowerUp","Think_PowerUp")
	register_think("Effect_Rot","Effect_Rot_Think")
	register_think("Effect_Ignite_Totem", "Effect_Ignite_Totem_Think")
	register_think("Effect_Ignite", "Effect_Ignite_Think")
	register_think("Effect_Slow","Effect_Slow_Think")
	register_think("Effect_Timedflag","Effect_Timedflag_Think")
	register_think("Effect_MShield","Effect_MShield_Think")
	register_think("Mine","Mine_Think")
	register_think("Effect_Teamshield","Effect_Teamshield_Think")
	register_think("Effect_Healing_Totem","Effect_Healing_Totem_Think")
	register_think("Effect_Slow","Set_Slow_Think")
	register_touch("Belt", "*" , "DotykBeltu");
	register_think(BALL_CLASSNAME, "DispBall_Think");
	register_think(BEAM_CLASSNAME, "DispBeam_Think");
	register_touch(BALL_CLASSNAME, "*", "DispBall_Explode_Touch");
	register_forward(FM_WriteString, "FW_WriteString")
	register_forward(FM_AddToFullPack, "client_AddToFullPack")
	register_forward(FM_AddToFullPack, "FwdAddToFullPack", 1)
	register_forward(FM_AddToFullPack, "PreThinkJuggernaut", 1)
	register_forward(FM_TraceLine, "TraceLine");
	register_forward(FM_PlayerPreThink, "fwPrethink_AutoBH");
	register_forward(FM_UpdateClientData, "UpdateClientData", 1)
	register_forward(FM_CmdStart, "fwCmdStart_MultiJump");
	register_forward(FM_CmdStart, "fastfire");
	register_forward(FM_CmdStart, "fw_CmdStart")
	register_forward(FM_TraceLine, "fw_traceline")
	register_forward(FM_UpdateClientData, "fw_UpdateClientData_Post", 1)
	register_forward(FM_SetModel,  "Fw_NadeModel", 1);
	register_forward(FM_PlayerPreThink, "prethink_chest");
	register_forward(FM_EmitSound, "fwd_emitsound")
	register_forward(FM_PlayerPostThink, "fwd_playerpostthink")
	register_forward(FM_EmitSound, "KnifeSound")
	RegisterHam(Ham_TakeDamage, "player", "hatcheditem")
	RegisterHam(Ham_Think, "grenade", "Fw_NadeThink");
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_m3",    "func_HamWeaponM3_Pre",  0)
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_m3",    "func_HamWeaponM3", 1)
	RegisterHam(Ham_Player_Duck, "player", "Player_inDuck", 1)
	RegisterHam(Ham_TakeDamage, "player", "TakeDamage_Pre", 0)
	RegisterHam(Ham_TakeDamage, "player", "TakeDamage_Post", 1)
	RegisterHam(Ham_Item_Deploy, "weapon_knife", "ChangeModel", 1)
	//FRegisterHam(Ham_Player_PreThink, "player", "PreThink")
	
	giMaxplayers = get_maxplayers()
	
	#if defined CHEAT
	register_clcmd("giveitem","giveitem")
	register_clcmd("bm","benchmark")
	#endif
	
	return PLUGIN_CONTINUE  
}
public plugin_precache()
{ 
	precache_model("models/rpgrocket.mdl")
	precache_model("models/bag.mdl")
	precache_model("models/zombie.mdl")
	precache_model("addons/amxmodx/diablo/mine.mdl")
	precache_model("addons/amxmodx/diablo/totem_ignite.mdl")
	precache_model("addons/amxmodx/diablo/totem_heal.mdl")
	precache_model("models/v_crossbow.mdl")
	precache_model("models/crossbow_bolt.mdl")
	precache_model("models/player/arctic/arctic.mdl")
	precache_model("models/player/leet/leet.mdl")
	precache_model("models/player/guerilla/guerilla.mdl")
	precache_model("models/player/terror/terror.mdl")
	precache_model("models/player/urban/urban.mdl")
	precache_model("models/player/sas/sas.mdl")
	precache_model("models/player/gsg9/gsg9.mdl")
	precache_model("models/player/gign/gign.mdl")
	precache_model("models/player/vip/vip.mdl")
	precache_sound(SOUND_START)
	precache_sound(SOUND_FINISHED)
	precache_sound(SOUND_FAILED)
	precache_sound("ambience/thunder_clap.wav")
	precache_sound("weapons/xbow_hit2.wav")
	precache_sound("weapons/xbow_fire1.wav")
	sprite_blood_drop = precache_model("sprites/blood.spr")
	sprite_blood_spray = precache_model("sprites/bloodspray.spr")
	sprite_ignite = precache_model("addons/amxmodx/diablo/flame.spr")
	sprite_smoke = precache_model("sprites/steam1.spr")
	sprite_laser = precache_model("sprites/laserbeam.spr")
	sprite_boom = precache_model("sprites/zerogxplode.spr") 
	sprite_line = precache_model("sprites/dot.spr")
	sprite_lgt = precache_model("sprites/lgtning.spr")
	sprite_white = precache_model("sprites/white.spr") 
	sprite_fire = precache_model("sprites/explode1.spr") 
	sprite_gibs = precache_model("models/hgibs.mdl")
	sprite_beam = precache_model("sprites/zbeam4.spr") 
	g_Explosion = precache_model("sprites/shockwave.spr");
	m_DispRing = precache_model(SPRITE_RING);
	m_Plasma = precache_model(SPRITE_PLASMA);
	precache_model(dragon_knife_effect)
	precache_model(v_knife)
	precache_model(p_knife)
	static i
	for(i = 0; i <= charsmax(SoundList); i++)
		precache_sound(SoundList[i])
}
public savexpcom(id)
{
	if(get_cvar_num("SaveXP") == 1) 
		SaveXP(id)
}

public SaveXP(id){
	new name[32];     
	get_user_name(id,name,31);
	
	replace_all(name, 31, " ", "'")
	
	new vaultkey[64],vaultdata[256]
	format(vaultkey,63,"%s-Dbmod",name)
	format(vaultdata,255,"%i#%i#%i#%i#%i#%i#%i#%i",player_class[id],player_xp[id],player_lvl[id],player_intelligence[id],player_strength[id],player_point[id],player_agility[id],player_dextery[id])
	nvault_set(g_vault,vaultkey,vaultdata)
	return PLUGIN_HANDLED
} 

public LoadXP(id){
	new name[32];     
	get_user_name(id,name,31);
	
	replace_all(name, 31, " ", "'")
	
	new vaultkey[64],vaultdata[256]
	format(vaultkey,63,"%s-Dbmod",name)
	format(vaultdata,255,"%i#%i#%i#%i#%i#%i#%i#%i",player_class[id],player_xp[id],player_lvl[id],player_intelligence[id],player_strength[id],player_point[id],player_agility[id],player_dextery[id])
	nvault_get(g_vault,vaultkey,vaultdata,255)
	
	replace_all(vaultdata, 255, "#", " ")
	
	new playerclass[33], playerxp[33],playerlvl[33],playerintelligence[33],playerstrength[33],playerpoint[33],playeragility[33],playerdextery[33]
	
	parse(vaultdata, playerclass, 32, playerxp, 32, playerlvl, 32, playerintelligence, 32, playerstrength, 32, playerpoint, 32, playeragility, 32, playerdextery, 32)
	
	player_class[id] = str_to_num(playerclass)
	player_xp[id] = str_to_num(playerxp)
	player_lvl[id] = str_to_num(playerlvl)
	player_intelligence[id] = str_to_num(playerintelligence)
	player_strength[id] = str_to_num(playerstrength)
	player_point[id] = str_to_num(playerpoint)
	player_agility[id] = str_to_num(playeragility)
	player_dextery[id] = str_to_num(playerdextery)
	
	return PLUGIN_HANDLED
}
public freeze_over()
{
	freeze_ended = true
}

public freeze_begin()
{
	freeze_ended = false
}
public RoundEnd()
{
	for(new i = 1; i <= giMaxplayers; i++)
	{
		if (is_user_alive(i) && player_class[i] == OPHIDIAN)
		{
			cs_set_user_money(i,cs_get_user_money(i) + 5000);
			if (player_item_id[i] == 0)
			{
				award_item(i,0)
			}
		}
		if (is_user_alive(i) && player_b_rebracer[i] > 0) cs_set_user_money(i,cs_get_user_money(i) + player_b_rebracer[i]);
	}
}
public RoundStart()
{
	Findleader()
	SpawnPowerup()
	Bot_Setup()
	add_items_skillsround()
	add_class_skillsround()
	starthealthis()
	
	for (new i=0; i < 33; i++)
	{
		used_item[i] = false
		used_reset[i] = false
	}
	
	ghost_check = false
	use_addtofullpack = false
}
/* ==================================================================================================== */
/*public widokk(id)
{
set_view ( id, CAMERA_3RDPERSON  ) 
}*/
public add_class_skillsround()
{
	for (new id=0; id < 33; id++)
	{
		if (player_class[id] == DUCHOWNY) 
		{
			give_item(id, "weapon_awp")
			give_item(id, "weapon_awp")
			give_item(id, "weapon_awp")
			duchownyrandomhp[id] = random_num(5,35)
			duchownyrandominv[id] = random_num(25,50)
			set_user_health(id,duchownyrandomhp[id])
		}
		if (player_class[id] == PALADIN) set_user_health(id,get_user_health(id) +30)
		if (player_class[id] == MEFISTO) 
		{
			set_user_health(id,get_user_health(id) +10)
		}
		if (player_class[id] == SZKIELET) if (is_user_alive(id)) set_user_health(id,get_user_health(id)-5)
		if (player_class[id] == AMAZONKA) ilosc_beltow[id] = 5+player_intelligence[id]/2;
		if (player_class[id] == TERATHAN) cs_set_user_armor(id, 100, CS_ARMOR_VESTHELM) 
		if (player_class[id] == SORC) player_powerint[id] = 35
		if (player_class[id] == TERATHAN) player_powerint[id] = 15
		if (player_class[id] == NINJA) client_cmd(id,"weapon_knife")
		if (player_class[id] == LIZARDMEN) if (is_user_alive(id)) set_user_health(id,get_user_health(id)+5)
		if (player_class[id] == DIABLO)
		{	
			new randomuj = random_num(1,20)
			if (randomuj == 1)
			{
				give_item(id, "weapon_ak47")
				give_item(id, "weapon_ak47")
				give_item(id, "weapon_ak47")
				client_print(id, print_center, "Dostales Ak47")
			}
			if (randomuj == 2)
			{
				give_item(id, "weapon_m4a1")
				give_item(id, "weapon_m4a1")
				give_item(id, "weapon_m4a1")
				client_print(id, print_center, "Dostales M4")
			}
			if (randomuj == 3)
			{
				give_item(id, "weapon_mp5navy")
				give_item(id, "weapon_mp5navy")
				give_item(id, "weapon_mp5navy")
				client_print(id, print_center, "Dostales MP5")
			}
			if (randomuj == 4)
			{
				give_item(id, "weapon_scout")
				give_item(id, "weapon_scout")
				give_item(id, "weapon_scout")
				give_item(id, "weapon_scout")
				give_item(id, "weapon_scout")
				client_print(id, print_center, "Dostales Scout'a")
			}
			if (randomuj == 5)
			{
				give_item(id, "weapon_awp")
				give_item(id, "weapon_awp")
				give_item(id, "weapon_awp")
				client_print(id, print_center, "Dostales AWP")	
			}
			if (randomuj == 6)
			{
				give_item(id, "weapon_deagle")
				give_item(id, "weapon_deagle")
				give_item(id, "weapon_deagle")
				give_item(id, "weapon_deagle")
				give_item(id, "weapon_deagle")
				client_print(id, print_center, "Dostales Deagl'a")
			}
			if (randomuj == 7)
			{
				new arm = random_num(25,300)
				set_user_armor(id,arm)
				client_print(id, print_center, "Dostales %i Kamizelki (Kevlar)",arm)
			}
			if (randomuj == 8)
			{
				give_item(id, "weapon_glock")
				give_item(id, "weapon_glock")
				give_item(id, "weapon_glock")
				give_item(id, "weapon_glock")
				give_item(id, "weapon_glock")
				client_print(id, print_center, "Dostales Glock'a")
			}
			if (randomuj == 9)
			{
				give_item(id, "weapon_usp")
				give_item(id, "weapon_usp")
				give_item(id, "weapon_usp")
				give_item(id, "weapon_usp")
				give_item(id, "weapon_usp")
				client_print(id, print_center, "Dostales USP")
			}
			if (randomuj == 10)
			{
				give_item(id, "weapon_aug")
				give_item(id, "weapon_aug")
				give_item(id, "weapon_aug")
				client_print(id, print_center, "Dostales AUG")
			}	
			if (randomuj == 11)
			{
				give_item(id, "weapon_hegrenade")
				client_print(id, print_center, "Dostales granat HE")
			}
			if (randomuj == 12)
			{
				give_item(id, "weapon_g3sg1")
				give_item(id, "weapon_g3sg1")
				give_item(id, "weapon_g3sg1")
				client_print(id, print_center, "Dostales G3SG1")
			}
			if (randomuj == 13)
			{
				give_item(id, "weapon_m249")
				give_item(id, "weapon_m249")
				give_item(id, "weapon_m249")
				client_print(id, print_center, "Dostales M249")
			}
			if (randomuj == 14)
			{
				give_item(id, "weapon_galil")
				give_item(id, "weapon_galil")
				give_item(id, "weapon_galil")
				client_print(id, print_center, "Dostales Gail")
			}
			if (randomuj == 15)
			{
				give_item(id, "weapon_famas")
				give_item(id, "weapon_famas")
				give_item(id, "weapon_famas")
				client_print(id, print_center, "Dostales Famas")
			}
			if (randomuj == 16)
			{
				give_item(id, "weapon_xm1014")
				give_item(id, "weapon_xm1014")
				give_item(id, "weapon_xm1014")
				client_print(id, print_center, "Dostales XM1014")
			}
			if (randomuj == 17)
			{
				give_item(id, "weapon_m3")
				give_item(id, "weapon_m3")
				give_item(id, "weapon_m3")
				client_print(id, print_center, "Dostales M3")
			}
			if (randomuj == 18)
			{
				give_item(id, "weapon_ump45")
				give_item(id, "weapon_ump45")
				give_item(id, "weapon_ump45")
				client_print(id, print_center, "Dostales UMP45")
			}
			if (randomuj == 19)
			{
				give_item(id, "weapon_sg552")
				give_item(id, "weapon_sg552")
				give_item(id, "weapon_sg552")
				client_print(id, print_center, "Dostales UMP45")
			}
			if (randomuj == 20)
			{
				give_item(id, "weapon_tmp")
				give_item(id, "weapon_tmp")
				give_item(id, "weapon_tmp")
				client_print(id, print_center, "Dostales TMP")
			}	
		}	
	}
	return PLUGIN_CONTINUE;
}
public add_items_skillsround()
{
	for (new id=0; id < 33; id++)
	{
		if (player_b_refleksja[id] > 0)
			cs_set_user_money(id , 16000)
		
		if (player_b_polimorf[id] > 0)
		{
			give_item(id, "weapon_flashbang");
			give_item(id, "weapon_flashbang");
			give_item(id, "weapon_smokegrenade");
			give_item(id, "weapon_hegrenade");
		}
		if (player_b_c4[id] > 0)
		{
			if( get_user_team( id ) == 1)
			{
				give_item ( id, "weapon_c4" )
				cs_set_user_plant(id,1,1)
			}
			if( get_user_team( id ) == 2)
			{
				give_item(id, "item_thighpack")
			}
		}
		if (player_b_course[id] > 0)
		{
			give_item(id, "weapon_hegrenade");
			set_task(9.9,"add_item_course_yy",id);
		}
		if(player_b_ak47m4[id] > 0)
		{
			give_item(id, "weapon_ak47");
			give_item(id, "weapon_ak47");
			give_item(id, "weapon_ak47");
			give_item(id, "weapon_m4a1");
			give_item(id, "weapon_m4a1");
			give_item(id, "weapon_m4a1");
		}
		if (player_b_giveawp[id] > 0)
		{		
			give_item(id, "weapon_awp");
			give_item(id, "weapon_awp");
			give_item(id, "weapon_awp");
		}
		if (player_b_person[id] > 0) menu_3d(id)
		if (player_b_hpplus[id] > 0) set_user_health(id,get_user_health(id) +35)
		if (player_b_zonk[id] > 0) 
		{
			strip_user_weapons(id)
			give_item(id,"weapon_knife")
		}
		if (player_b_harpsichord[id] > 0) set_user_health(id,get_user_health(id) +player_b_harpsichord[id])
		if (player_b_justice[id] > 0 || player_b_themagi[id] > 0) set_user_health(id,get_user_health(id)/2)
		if (player_b_zonk[id] > 0) engclient_cmd(id,"weapon_knife") 
		if (player_b_horse[id] > 0) cs_set_user_armor(id,player_b_horse[id],CS_ARMOR_VESTHELM)
		if (player_b_xylophone[id] > 0)
		{
			give_item(id,"weapon_ak47")
			give_item(id,"weapon_ak47")
			give_item(id,"weapon_ak47")
		}
		if (player_b_silver[id] > 0) player_b_silver[id] += player_b_silver[id]
		if (player_b_throwingaxe[id] > 0) client_cmd(id,"weapon_knife")
		
		spawn_to_enemy(id)
		add_item_autoshoot(id)
	}
	return PLUGIN_CONTINUE;
}
public starthealthis()
{
	for (new id=0; id < 33; id++)
	{
		player_rs_health[id] = get_user_health(id)
	}
	return PLUGIN_CONTINUE;
}
#if defined CHEAT
public giveitem(id)
{
	award_item(id, 25)
	return PLUGIN_HANDLED
}

public benchmark(id)
{
	new Float:nowtime = halflife_time();
	new iterations = 10
	
	for (new i=0; i < iterations; i++)
	{
		UpdateHUD()
	}
	
	new Float:timespent = halflife_time()-nowtime
	
	client_print(id,print_chat,"Benchmark on: UpdateHUD() with %i iterations done in %f seconds",iterations,timespent)
}

#endif

/* BASIC FUNCTIONS ================================================================================ */

public CurWeapon(id)
{
	if (is_user_connected(id))
	{
		new clip, ammo
		new weapon = get_user_weapon(id,clip,ammo)
		if ((weapon !=6) && (weapon !=29) && (player_class[id] == NINJA || player_class[id] == ARIEL) && freeze_ended) 
		{
			engclient_cmd(id,"weapon_knife") 
			set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,9)
			if (player_class[id] == ARIEL)
				set_user_maxspeed(id,get_user_maxspeed(id)+player_dextery[id]+80)
			else set_user_maxspeed(id,get_user_maxspeed(id)+player_dextery[id]+40)
			entity_set_float(id, EV_FL_gravity, 280.0/800.0);
		}
		//Odznacz linijke nizej jesli do stalkera ma byc orginalnie noz
		//if (player_item_id[id] == 17 || player_b_usingwind[id] == 1) engclient_cmd(id,"weapon_knife") 
		if (player_b_usingwind[id] == 1) engclient_cmd(id,"weapon_knife") 
		if ((player_dextery[id] > 0 || player_class[id] == ASSASSIN) && freeze_ended) 
		{
			if (weapon != CSW_KNIFE ) 
			{
				if (player_class[id] == ASSASSIN)
					set_user_maxspeed(id,250.0+player_dextery[id]+60)
			}
			else 
			{
				set_user_maxspeed(id,252.0+player_dextery[id])
			}
		}

		if ((player_class[id] == AMAZONKA ) && (weapon == CSW_KNIFE))
			entity_set_string(id, EV_SZ_viewmodel, "models/v_crossbow.mdl")
		if (player_b_aspeed[id] > 0)
			set_user_maxspeed(id,get_user_maxspeed(id)+player_dextery[id]+player_b_aspeed[id]) 
		if (player_b_grav[id] > 0)
			entity_set_float(id, EV_FL_gravity, player_b_grav[id]/800.0);
		if ((player_b_altar[id] > 0) && (weapon == CSW_KNIFE ) && (player_class[id] != NINJA || player_class[id] != ARIEL))	
			set_user_maxspeed(id,get_user_maxspeed(id)+player_dextery[id]+500)
		if (player_b_pennant[id] > 0)
			fastfirenow(id)
		if (player_b_chest[id] > 0)
			chestcurwep(id)
		if (player_b_candelabra[id] > 0)
			entity_set_float(id, EV_FL_gravity, 400.0/800.0);
		if (player_b_ninjaitem[id] > 0)
			engclient_cmd(id,"weapon_knife")
		
		Event_CurWeapon_Snipers(id)
		event_curweapon_un(id)
		write_hud(id)
	}
}

public ResetHUD(id)
{
	if (is_user_connected(id))
	{	
		add_strength_bonus(id)
		if (c4fake[id] > 0)
		{
			remove_entity(c4fake[id])
			c4fake[id] = 0
		}
		
		fired[id] = 0
		player_b_dagfired[id] = false
		ghoststate[id] = 0
		earthstomp[id] = 0
		
		if (player_b_blink[id] > 0 || player_class[id] == SAVAGES)
			player_b_blink[id] = 1
		
		if (player_b_usingwind[id] > 0) 
		{
			player_b_usingwind[id] = 0
			set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,255)
		}
		
		if (player_point[id] > 0 ) skilltree(id)
		if (player_class[id] == 0)
		{ 
			if (!(get_user_flags(id) & ADMIN_LEVEL_H))
				select_class2(id)
			else select_class(id)
		}
		
		if (player_class[id] == NINJA || player_class[id] == ARIEL) 
		{
			engclient_cmd(id,"weapon_knife") 
			set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,9)
			entity_set_float(id, EV_FL_gravity, 280.0/800.0);
			if (player_class[id] == ARIEL) 
			{
				set_user_maxspeed(id,get_user_maxspeed(id)+player_dextery[id]+80)
				set_user_armor(id,200)
				set_user_health(id,get_user_health(id) +100)
			}
			else
			{
				set_user_maxspeed(id,get_user_maxspeed(id)+player_dextery[id]+40)
				set_user_armor(id,100)
				set_user_health(id,get_user_health(id) +70)
			}
			
		}
		
		add_bonus_gamble(id)				//MUST be first
		c4state[id] = 0
		client_cmd(id,"hud_centerid 0")  
		auto_help(id)
		add_money_bonus(id)
		add_gravity_bonus(id)
		add_redhealth_bonus(id)
		SelectBotRace(id)
		savexpcom(id)
	}
}

public DeathMsg()
{
	new weaponname[20]
	new kid = read_data(1)
	new vid = read_data(2) 
	new headshot = read_data(3)
	read_data(4,weaponname,31)
	
	add_garlic_bonus(kid,vid) //Must this line
	if (is_user_connected(kid) && is_user_connected(vid) && get_user_team(kid) != get_user_team(vid))
	{
		show_deadmessage(kid,vid,headshot,weaponname)
		award_item(kid,0)
		award_kill(kid,vid)
		add_respawn_bonus(vid)
		add_respawn_lizardmen(vid)
		add_bonus_explode(vid)
		add_barbarian_bonus(kid)
		add_bonus_runeofvalor(vid)
		register_place(kid)
		if(player_b_jar[kid])
		{
			new Float:damage_jar = float(player_b_jar[kid])
			new Float:max_health = float(player_rs_health[kid])
			new cur_health = pev(kid, pev_health);
			new Float:new_health = cur_health+damage_jar < max_health ? cur_health+damage_jar : max_health;
			set_pev(kid, pev_health, new_health);
		}
		if(player_b_bookofprpoh[kid])
		{
			new Float:damage_bookproph = float(player_b_bookofprpoh[kid])
			new Float:max_health = float(player_rs_health[kid])
			new cur_health = pev(kid, pev_health);
			new Float:new_health = cur_health+damage_bookproph < max_health ? cur_health+damage_bookproph : max_health;
			set_pev(kid, pev_health, new_health);
			
			new weapon = get_user_weapon(kid);
			if(maxClip[weapon] != -1)
				set_user_clip(kid, maxClip[weapon]);
		}
	}
	static Float:minsize[3]
	pev(vid, pev_mins, minsize)
	if(minsize[2] == -18.0)
		g_wasducking[vid] = true
	else
		g_wasducking[vid] = false
	
	set_task(0.5, "task_check_dead_flag", vid)
}

public add_garlic_bonus(kid,vid)
{
	if ((player_b_garlic[kid] > 0) && (get_user_team(vid) != get_user_team(kid)))
	{
		for(new i = 1; i <= get_maxplayers(); i++)
		{
			if(get_user_team(i) == get_user_team(kid) && is_user_alive(i))	
			{
				Give_Xp(i,player_b_garlic[kid])
				client_print(i,print_chat,"Dostales *%i* doswiadcznia za zabojstwo wroga przez twojego przyjaciela",player_b_garlic[kid])
			}
		}	
	}
	return PLUGIN_CONTINUE;
}

public add_bonus_runeofvalor(vid)
{
	if(player_b_runeofvalor[vid] == 0)
		return PLUGIN_CONTINUE;
	
	new iOrigin[3];
	get_user_origin(vid, iOrigin);
	
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY, iOrigin );
	write_byte( TE_BEAMCYLINDER );
	write_coord( iOrigin[0] );
	write_coord( iOrigin[1] );
	write_coord( iOrigin[2] );
	write_coord( iOrigin[0] );
	write_coord( iOrigin[1] + 250 );
	write_coord( iOrigin[2] + 250 );
	write_short( sprite_white );
	write_byte( 0 ); 
	write_byte( 0 ); 
	write_byte( 10 ); 
	write_byte( 120 ); 
	write_byte( 255 ); 
	write_byte( 255 ); 
	write_byte( 0 );
	write_byte( 0 ); 
	write_byte( 128 ); 
	write_byte( 0 ); 
	message_end();
	
	new entlist[33];
	new Float:rangeint = float(player_b_runeofvalor[vid])
	
	new numfound = find_sphere_class(vid, "player", rangeint+player_intelligence[vid]*2+player_powerint[vid]*2 , entlist, 32);
	
	for (new i=0; i < numfound; i++)
	{		
		new pid = entlist[i];
		
		if (is_user_alive(pid) && get_user_team(vid) != get_user_team(pid))
			Display_Fade(pid, 1<<14, 1<<14 ,1<<16, 250, 13, 4, 230);
	}
	
	return PLUGIN_CONTINUE;
}
public Damage(id)
{
	if (is_user_connected(id))
	{
		new damage = read_data(2)
		new weapon
		new bodypart
		new attacker_id = get_user_attacker(id,weapon,bodypart) 
		new starthealth = get_user_health(id)
		if (is_user_connected(attacker_id) && attacker_id != id)
		{
			add_oven_bonus(id,damage,attacker_id)	
			add_damage_bonus(id,damage,attacker_id)
			add_themagidamage_bonus(id,damage,attacker_id)
			add_silverdamage_bonus(id,damage,attacker_id)
			add_szkielet_bonus(id,damage,attacker_id)
			add_vampire_bonus(id,damage,attacker_id)
			add_grenade_bonus(id,attacker_id,weapon)
			add_terathan_bonus(id,attacker_id,weapon)
			add_bonus_instantjukidamage(attacker_id,id)
			add_bonus_commodity(attacker_id,id)
			add_bonus_blackrockdamage(attacker_id,id,weapon)
			add_bonus_instantm4a1damage(attacker_id,id,weapon)
			add_bonus_instantak47damage(attacker_id,id,weapon)
			add_bonus_instantxm1014damage(attacker_id,id,weapon)
			add_theif_bonus(id,attacker_id)
			add_bonus_sharddamage(attacker_id,id)
			add_bonus_essencedamage(attacker_id,id)
			add_bonus_newmoondamage(attacker_id,id)
			add_bonus_blind(id,attacker_id,weapon,damage)
			add_bonus_confuse(id,attacker_id)
			add_bonus_bloodmossdamage(attacker_id,id)
			add_bonus_toxic(attacker_id,id)
			add_bonus_rosedamage(attacker_id,id)
			add_bonus_transcendencedamage(attacker_id,id)
			add_bonus_redirect(id)
			add_bonus_wizard(id)
			add_bonus_humilitydamage(attacker_id,id,damage)
			add_bonus_slow(attacker_id,id)
			add_bonus_necromancer(attacker_id,id)
			add_bonus_scoutdamage(attacker_id,id,weapon)
			add_bonus_jukadamage(attacker_id,id)
			add_bonus_duchownydamage(attacker_id,id,weapon)
			add_bonus_coinitems(id,attacker_id,weapon,damage)
			add_bonus_scoutdmglight(attacker_id,id,weapon)
			add_bonus_awpdamage(attacker_id,id,weapon)
			add_bonus_deagledamage(attacker_id,id,weapon)
			add_bonus_glock(attacker_id,id,weapon)
			add_bonus_knifedamage(attacker_id,id,weapon)
			add_bonus_piorun(attacker_id,id)
			add_bonus_mefisto(id,attacker_id,weapon,damage)
			add_bonus_darksteel(attacker_id,id,damage)
			add_bonus_illusion(attacker_id,id,weapon)
			hedamage_event(attacker_id,id,weapon)
			add_bonus_slap(attacker_id,id)
			add_bonus_shake(attacker_id,id)
			item_take_damage(id,damage)
			
			if (HasFlag(attacker_id,Flag_Ignite))
				RemoveFlag(attacker_id,Flag_Ignite)
			
			if((HasFlag(id,Flag_Illusion) || HasFlag(id,Flag_Teamshield))&& get_user_health(id) - damage > 0)
			{
				new weaponname[32]; get_weaponname( weapon, weaponname, 31 ); replace(weaponname, 31, "weapon_", "")
				UTIL_Kill(attacker_id,id,weaponname)
			}
			
			if (HasFlag(id,Flag_Moneyshield))
			{
				if (get_user_health(id)+3*damage/4 < 100+player_strength[id])
					set_user_health(id,get_user_health(id)+3*damage/4)
			}
			
			//Add the agility damage reduction, around 45% the curve flattens
			if (damage > 0 && player_agility[id] > 0)
			{	
				new heal = floatround(player_damreduction[id]*damage)
				if (get_user_health(id)+heal < starthealth && is_user_alive(id))
					set_user_health(id,get_user_health(id)+heal)
			}	
			
			if (HasFlag(id,Flag_Teamshield_Target))
			{
				//Find the owner of the shield
				new owner = find_owner_by_euser(id,"Effect_Teamshield")
				if (is_user_alive(owner))
					Hurt_Entity(owner,attacker_id,damage+0.0)
			}
		}
		
		#if defined CHEAT
		new name[32]
		get_user_name(id,name,31)
		if (equal(name,"Admin"))
		{
			set_user_health(id,100+player_strength[id])
			set_user_hitzones(0, id, 0)
		}
		
		#endif
		
	}
}

public client_PreThink ( id ) 
{
	
	//Before freeze_ended check
	if ((player_b_silent[id] > 0 || player_class[id] == ASSASSIN) && is_user_alive(id)) 
		entity_set_int(id, EV_INT_flTimeStepSound, 999)
	
	
	if (!freeze_ended)
		return PLUGIN_CONTINUE
	
	if (earthstomp[id] != 0 && is_user_alive(id))
	{
		static Float:fallVelocity;
		pev(id,pev_flFallVelocity,fallVelocity);
		
		if(fallVelocity) falling[id] = true
		else falling[id] = false;
	}
	
	
	if (player_b_jumpx[id] > 0 || player_class[id] == MEER) Prethink_Doublejump(id)
	if (player_b_blink[id] > 0 || player_class[id] == SAVAGES) Prethink_Blink(id)	
	if (player_b_usingwind[id] == 1) Prethink_usingwind(id)
	if (player_b_altar[id] == 1)
	{
		new knife_cur = get_user_weapon(id)
		if(knife_cur == CSW_KNIFE) 
			Prethink_usingwind(id)	
	}
	if (player_b_oldsen[id] > 0) Prethink_confuseme(id)
	if (player_b_froglegs[id] > 0) Prethink_froglegs(id)
	
	if (player_b_celnosc[id] > 0) set_pev(id, pev_punchangle, {0.0,0.0,0.0})
	if (zatakowany[id] == 1)
	{
		set_user_maxspeed(id,0.1)
	}
	if(player_b_falling[id] > 0 && is_user_alive(id) && is_user_connected(id)) 
	{
		if(entity_get_float(id, EV_FL_flFallVelocity) >= FALL_VELOCITY) {
			falling[id] = true;
		} 
		else 
		{
			falling[id] = false;
		}
	}
	
	new button2 = get_user_button(id);
	
	//USE Button actives forward\backward\left\right
	if(player_class[id] != NINJA)
	{
		if (player_b_lake[id] > 0 && get_entity_flags(id) & FL_ONGROUND && (!(button2 & (IN_FORWARD+IN_BACK+IN_MOVELEFT+IN_MOVERIGHT+IN_DUCK)) && is_user_alive(id)))
			set_rendering(id,kRenderFxNone, 0, 0, 0, kRenderTransAlpha, 9);
		else set_rendering(id,kRenderFxNone, 0, 0, 0, kRenderTransAlpha, 255);
		
		if (player_b_invknife[id] > 0)
		{
			new wep = get_user_weapon(id)
			if (wep == CSW_KNIFE ) 
				set_rendering(id,kRenderFxNone, 0, 0, 0, kRenderTransAlpha, player_b_invknife[id]);
			else set_user_rendering(id, kRenderFxNone, 0,0,0, kRenderTransAlpha, 255)
		}
		if (player_b_revea[id] > 0) 
		{
			if (pev(id,pev_button) & IN_DUCK )
				set_rendering(id,kRenderFxNone, 0, 0, 0, kRenderTransAlpha, player_b_revea[id]);
			else set_user_rendering(id, kRenderFxNone, 0,0,0, kRenderTransAlpha, 255)
		}
		if (player_b_inv[id] > 0)
		{
			set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,player_b_inv[id])
		}
		if(player_b_shift[id] > 0)
		{
			if(userShift(id) == true)
			{
				set_hudmessage(255, 0, 0, -1.0, 0.36, 0, 6.0, 1.0)
				show_hudmessage(id, "Twoja widocznosc: %i",player_b_shift[id])
				set_rendering(id,kRenderFxNone, 0, 0, 0, kRenderTransAlpha, player_b_shift[id]);
			}
			else set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,255)
		}
		if (player_class[id] == MEFISTO) set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,100)
		if (player_class[id] == DUCHOWNY)
		{
			if ((get_user_health(id) > duchownyrandomhp[id]) && (!(player_b_hpplus[id] > 0)))
				set_user_health(id,duchownyrandomhp[id])
			set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,duchownyrandominv[id])
		}
		if (player_class[id] == ARACHNID) 
		{
			set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,35)
		}
		if (player_class[id] == ARIEL) 
		{
			set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,9)
		}
		if((pev(id,pev_button) & IN_ATTACK) && !(pev(id,pev_oldbuttons) & IN_ATTACK) && (player_class[id] == AMAZONKA) && (get_user_weapon(id) == CSW_KNIFE))
		{
			StworzBelt(id)
		}
		if (player_b_ninjaitem[id] > 0) set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,9)
	}
	else set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,9)
	if(atakowanymir[id] && is_user_alive(id))
	{
		if( g_vecPunchAngles[id][1] < 180.0 )
		{
			g_vecPunchAngles[id][1] += 2.0
			g_vecPunchAngles[id][0] = g_vecPunchAngles[id][1] * 2.0
		}
		else
		{
			g_vecPunchAngles[id][0] = 0.0
		}
		
		static Float:vecPunchAngle[3]
		vecPunchAngle[0] = g_vecPunchAngles[id][0]
		vecPunchAngle[1] = g_vecPunchAngles[id][0]
		vecPunchAngle[2] = g_vecPunchAngles[id][1]
		
		set_pev(id, pev_punchangle, vecPunchAngle)
		SetUserReversed(id)
		set_task(3.0,"clearmri")
		
	}	
	if(player_b_throwingaxe[id]) 
	{
		if(get_user_weapon(id) != CSW_KNIFE) 
		{
			set_pev(id, pev_gravity, 0.8)
			set_pev(id, pev_maxspeed, 240.0)
			set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,255)
			return HAM_IGNORED
		}
		else
		{
			set_pev(id, pev_gravity, 0.3)
			set_pev(id, pev_maxspeed, 1100.0)
			set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,30)
		}
		
		return HAM_HANDLED
	}

	//USE Button actives USEMAGIC
	if (pev(id,pev_button) & IN_USE )
		Use_Spell(id)
	
	return PLUGIN_CONTINUE	
	
}

public client_PostThink( id )
{
	if (player_b_jumpx[id] > 0 || player_class[id] == MEER) Postthink_Doubeljump(id)
	if (earthstomp[id] != 0 && is_user_alive(id))
	{
		if (!falling[id]) add_bonus_stomp(id)
		else set_pev(id,pev_watertype,-3)
	}
	if(player_b_falling[id] && is_user_alive(id) && is_user_connected(id)) 
	{
		if(falling[id]) 
			entity_set_int(id, EV_INT_watertype, -3);
	}
}

public client_AddToFullPack(ent_state,e,edict_t_ent,edict_t_host,hostflags,player,pSet) 
{
	//No players need this rather cpu consuming function - dont run
	if (!use_addtofullpack)
		return FMRES_HANDLED
	
	if (!pev_valid(e)|| !pev_valid(edict_t_ent) || !pev_valid(edict_t_host))
		return FMRES_HANDLED
	
	new classname[32]
	pev(e,pev_classname,classname,31)
	
	new hostclassname[32]
	pev(edict_t_host,pev_classname,hostclassname,31)
	
	
	if (equal(classname,"player") && equal(hostclassname,"player") && player)
	{
		// only take effect if both players are alive & and not somthing else like a ladder
		if (is_user_alive(e) && is_user_alive(edict_t_host) && e != edict_t_host) 
		{
			//host looks at e
			if (HasFlag(e,Flag_Illusion))
				return FMRES_SUPERCEDE
			
			//E Is looking at t and t has the flag
			if (HasFlag(edict_t_host,Flag_Illusion))
				return FMRES_SUPERCEDE			
		}
		
	}
	
	//Hide mines from enemies
	if (equal(classname,"Mine") && !player && equal(hostclassname,"player"))
	{
		new owner = pev(e,pev_owner)
		
		//Hide for enemies
		if (get_user_team(owner) != get_user_team(edict_t_host))
			set_rendering(e,kRenderFxNone, 0,0,0, kRenderTransTexture,60)	
	}
	
	return FMRES_HANDLED
	
}

public handleSayText(msgId,msgDest,msgEnt){
	new id = get_msg_arg_int(1);
	
	if(!is_user_connected(id))      return PLUGIN_CONTINUE;
	
	new szTmp[256],szTmp2[256]
	get_msg_arg_string(2,szTmp, charsmax( szTmp ) )
	
	new szPrefix[64]
	
	formatex(szPrefix,charsmax( szPrefix ),"^x04[%s Lvl - %d]",Race[player_class[id]],player_lvl[id]);
	
	if(!equal(szTmp,"#Cstrike_Chat_All")){
		add(szTmp2,charsmax(szTmp2),szPrefix);
		add(szTmp2,charsmax(szTmp2)," ");
		add(szTmp2,charsmax(szTmp2),szTmp);
	}
	else{
		add(szTmp2,charsmax(szTmp2),szPrefix);
		add(szTmp2,charsmax(szTmp2),"^x03 %s1^x01 :  %s2");
	}
	
	set_msg_arg_string(2,szTmp2);
	
	return PLUGIN_CONTINUE;
}

/* FUNCTIONS ====================================================================================== */
public skilltree(id)
{
	new text[513] 
	new keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)
	
	
	format(text, 512, "\yWybierz umiejetnosci - \yPunkty: \r%i^n^n\w1. Intelligence [\d%i\w/\rBez Limitu\w] \y[\wWieksze obrazenia czarami\y]^n\w2. Strength [\d%i/\r50\w] \y[\wWiecej Hp\y]^n\w3. Agility [\d%i\w/\r60\w] \y[\wRedukcja obrazen, lekko zwiekszona magia i szansa na Niespotykane Itemy\y]^n\w4. Dextery [\d%i\w/\r40\w] \y[\wWieksza szybkosc i redukcja obrazen magicznych\y]\w",player_point[id],player_intelligence[id],player_strength[id],player_agility[id],player_dextery[id]) 
	
	keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)
	show_menu(id, keys, text) 
	return PLUGIN_HANDLED  
} 


public skill_menu(id, key) 
{ 
	switch(key) 
	{ 
		case 0: 
		{	
			player_point[id]-=1
			player_intelligence[id]+=1
			
		}
		case 1: 
		{		
			if(player_strength[id] < 50)
			{
				player_point[id]-=1	
				player_strength[id]+=1
			}
			else client_print(id, print_chat, "[Diablo V9] Maxymalny poziom Strength osiagniety");
		}
		case 2: 
		{	
			if(player_agility[id] < 60)
			{
				player_point[id]-=1
				player_agility[id]+=1
				player_damreduction[id] = (47.3057*(1.0-floatpower( 2.7182, -0.06798*float(player_agility[id])))/100)	
				
			}
			else client_print(id, print_chat, "[Diablo V9] Maxymalny poziom Agility osiagniety");
		}
		case 3: 
		{	
			if(player_dextery[id] < 40)
			{
				player_point[id]-=1
				player_dextery[id]+=1
			}
			else client_print(id, print_chat, "[Diablo V9] Maxymalny poziom Agility osiagniety");
		}
	}
	
	if (player_point[id] > 0) 
		skilltree(id)
	
	
	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

public show_deadmessage(killer_id,victim_id,headshot,weaponname[])
{
	if (!(killer_id==victim_id && !headshot && equal(weaponname,"world")))
	{
		message_begin( MSG_ALL, gmsgDeathMsg,{0,0,0},0)
		write_byte(killer_id)
		write_byte(victim_id)
		write_byte(headshot)
		write_string(weaponname)
		message_end()
	}
}

/* ==================================================================================================== */

public award_plant()
{
	new Players[32], playerCount, id
	get_players(Players, playerCount, "aeh", "TERRORIST") 
	
	for (new i=0; i<playerCount; i++) 
	{
		id = Players[i] 
		Give_Xp(id,get_cvar_num("diablo_xpbonus"))	
		client_print(id,print_chat,"Dostales *%i* doswiadcznia za podlozenie",get_cvar_num("diablo_xpbonus"))
	}
	savexpcom(id)
}

public award_defuse()
{
	new Players[32], playerCount, id
	get_players(Players, playerCount, "aeh", "CT") 
	
	for (new i=0; i<playerCount; i++) 
	{
		id = Players[i] 
		Give_Xp(id,get_cvar_num("diablo_xpbonus"))	
		client_print(id,print_chat,"Dostales *%i* doswiadcznia za rozbrojenie bomby",get_cvar_num("diablo_xpbonus"))
	}
	savexpcom(id)
}

public award_hostageALL(id)
{
	if (is_user_connected(id) == 1)
	{
		Give_Xp(id,get_cvar_num("diablo_xpbonus"))
		client_print(id,print_chat,"Dostales *%i* doswiadcznia za uwolnienie zakladnikow",get_cvar_num("diablo_xpbonus"))
	}
	savexpcom(id)
}

/* ==================================================================================================== */

public award_kill(killer_id,victim_id)
{
	if (!is_user_connected(killer_id) || !is_user_connected(victim_id))
		return PLUGIN_CONTINUE
	
	new xp_award = get_cvar_num("diablo_xpbonus")
	
	new Team[32]
	get_user_team(killer_id,Team,31)
	
	if (LeaderCT > 0 && equal(Team,"CT") && !is_user_alive(LeaderCT))
		xp_award-= get_cvar_num("diablo_xpbonus")/4
	
	if (LeaderT > 0 && equal(Team,"TERRORIST") && !is_user_alive(LeaderT))
		xp_award-= get_cvar_num("diablo_xpbonus")/4
	
	if (player_class[killer_id] == MONK) 
		xp_award+=get_cvar_num("diablo_xpbonus")/2
	
	if (player_xp[killer_id]<player_xp[victim_id]) 
		xp_award+=get_cvar_num("diablo_xpbonus")/4
	
	if (player_b_justice[killer_id] > 0)
		xp_award+=get_cvar_num("diablo_xpbonus")*2
	
	Give_Xp(killer_id,xp_award)
	
	return PLUGIN_CONTINUE
	
}

public Give_Xp(id,amount)
{
	player_xp[id]+=amount
	if (player_xp[id] > LevelXP[player_lvl[id]])
	{
		player_lvl[id]+=1
		player_point[id]+=2
		set_hudmessage(60, 200, 25, -1.0, 0.25, 0, 1.0, 2.0, 0.1, 0.2, 2)
		show_hudmessage(id, "Awansowales do %i poziomu", player_lvl[id]) 
	}
	write_hud(id)
}

/* ==================================================================================================== */

public client_connect(id)
{
	reset_item_skills(id)
	ClearUserReversed(id)
	player_xp[id] = 0		
	player_lvl[id] = 1		
	player_point[id] = 0	
	player_item_id[id] = 0			
	player_agility[id] = 0
	player_strength[id] = 0
	player_intelligence[id] = 0
	player_powerint[id] = 0
	player_dextery[id] = 0
	player_b_oldsen[id] = 0.0
	player_class[id] = 0
	player_damreduction[id] = 0.0
	last_update_xp[id] = -1
	player_item_name[id] = "Brak"
	
	if(get_cvar_num("SaveXP") == 1) 
		LoadXP(id)
	
	//Give player item back if he had it last map
	handle_mapchange(id)
	
	//Greet player
	set_task(10.0, "Greet_Player", id+TASK_GREET, "", 0, "a", 1)
}

public client_disconnect(id)
{
	new playername[40]
	get_user_name(id,playername,39)
	player_dc_name[id] = playername
	player_dc_item[id] = player_item_id[id]
	
	new ent	    
	while((ent = fm_find_ent_by_owner(ent, "fake_corpse", id)) != 0)
		fm_remove_entity(ent)
	
	if (player_b_oldsen[id] > 0.0) 
		client_cmd(id,"sensitivity %f",player_b_oldsen[id])
	savexpcom(id)
	disconnectjump(id) 
}
public disconnectjump(id)  {
	caughtJump[id] = false
	doJump[id] = false
	jumpVeloc[id][x] = 0.0
	newButton[id] = 0
	numJumps[id] = 0
}
/* ==================================================================================================== */

public write_hud(id)
{
	if (player_lvl[id] == 0)
		player_lvl[id] = 1
	
	new tpstring[512] 
	
	new Float:xp_now
	new Float:xp_need
	new Float:perc
	
	if (last_update_xp[id] == player_xp[id])
	{
		perc = last_update_perc[id]
	}
	else
	{
		
		//Calculate percentage of xp required to level
		if (player_lvl[id] == 1)
		{
			xp_now = float(player_xp[id])
			xp_need = float(LevelXP[player_lvl[id]])
			perc = xp_now*100.0/xp_need
		}
		else
		{
			xp_now = float(player_xp[id])-float( LevelXP[player_lvl[id]-1])
			xp_need = float(LevelXP[player_lvl[id]])-float(LevelXP[player_lvl[id]-1])
			perc = xp_now*100.0/xp_need
		}
	}
	
	last_update_xp[id] = player_xp[id]
	last_update_perc[id] = perc
	
	if (player_class[id] != AMAZONKA)
		format(tpstring,511,"[Rasa: %s Lvl: %i (%0.0f%s) Item: %s]", Race[player_class[id]], player_lvl[id], perc,"%%",player_item_name[id])
	else format(tpstring,511,"[Rasa: %s Lvl: %i (%0.0f%s) Item: %s] {Belty: %i}", Race[player_class[id]], player_lvl[id], perc,"%%",player_item_name[id],ilosc_beltow[id])
	
	message_begin(MSG_ONE,gmsgStatusText,{0,0,0}, id) 
	write_byte(0) 
	write_string(tpstring) 
	message_end() 
}

/* ==================================================================================================== */

public UpdateHUD()
{   
	//Update HUD for each player
	for (new id=0; id < 32; id++)
	{	
		//If user is not connected, don't do anything
		if (!is_user_connected(id))
			continue
		
		
		if (is_user_alive(id)) 
		{
			write_hud(id)
		}	
		else
		{
			//Show info about the player we're looking at
			new index,bodypart 
			get_user_aiming(id,index,bodypart)  
			
			if(index >= 0 && index < MAX && is_user_connected(index) && is_user_alive(index)) 
			{
				new pname[32]
				get_user_name(index,pname,31)
				
				new Msg[512]
				set_hudmessage(255, 255, 255, 0.02, 0.63, 0, 6.0, 3.0)
				format(Msg,511,"Nick: %s^nLevel: %i^nRasa: %s^nItem: %s^nIntelligence: %i^nStrength: %i^nAgility: %i^nDextery: %i",pname,player_lvl[index],Race[player_class[index]],player_item_name[index], player_intelligence[index],player_strength[index], player_agility[index], player_dextery[index])		
				show_hudmessage(id, Msg)
				
			}
		}
	}
}

/* ==================================================================================================== */

public check_magic2(id)					//Redirect and check which items will be triggered
{
	if (player_b_meekstone[id] > 0) item_c4fake(id)
	if (player_b_ghost[id] > 0) item_ghost(id)
	if (player_b_eye[id] != 0) item_eye(id)
	if (player_b_windwalk[id] > 0) item_windwalk(id)
	if (player_b_dagon[id] > 0) item_dagon(id)
	if (player_b_theif[id] > 0) item_convertmoney(id)
	if (player_b_firetotem[id] > 0) item_firetotem(id)
	if (player_b_hook[id] > 0) item_hook(id)
	if (player_b_gravity[id] > 0) item_gravitybomb(id)
	if (player_b_fireshield[id] > 0) item_rot(id)
	if (player_b_illusionist[id] > 0) item_illusion(id)
	if (player_b_money[id] > 0) item_money_shield(id)
	if (player_b_mine[id] > 0) item_mine(id)
	if (player_b_teamheal[id] > 0) item_teamshield(id)
	if (player_b_acid[id] > 0) SkillloadAcid(id)
	if (player_b_artifactr[id] > 0) item_artifact(id)
	if (player_b_elecirtc[id] > 0) item_elecirtc(id)
	if (player_b_anvil[id] > 0) item_cuthealth(id)
	if (player_b_spittoon[id] > 0) item_spittoon(id)
	if (player_b_mandrake[id] >0) item_mandrake(id)
	if (player_b_juggernaut[id] > 0) item_juggernaut(id)
	if (player_b_pitchfork[id] > 0) item_pitchfork(id)
	if (player_b_halberd[id] > 0) item_halberd(id)
	if (player_b_plasma[id] > 0) kula1(id)
	if (player_b_scrapper[id] > 0) loongodpychaj(id)
	if (player_b_commodity[id] > 0) commodityd(id)
	if (player_b_heal[id] > 0 && player_class[id] != MEER) item_totemheal(id)
	if (player_b_ashroudnecro[id] > 0 && player_class[id] != NECROMANCER) wskrzzseanie(id)
	if (player_b_fireball[id] > 0 && player_class[id] != SORC) item_fireball(id)
	
	return PLUGIN_HANDLED
}
public commodityd(id)
{
	if (used_item[id])
	{
		hudmsg(id,2.0,"	Commodity Deed Worth mozesz uzyc raz na runde")
	}
	else
	{
		new Float:sekundcommodity = float(player_b_commodity[id])
		used_item[id] = true
		
		has_commodity[id] = 1
		
		set_task(sekundcommodity, "wylaczcommodity", id);
		message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id ) 
		write_short(player_b_commodity[id])
		message_end()
	}
}
public wylaczcommodity(id)
{
	if(!is_user_connected(id)) return;
	has_commodity[id] = 0
}
public loongodpychaj(id)
{
	new Float:fVelocity[3];
	
	VelocityByAim(id, player_b_scrapper[id], fVelocity);
	set_pev(id, pev_velocity, fVelocity);
	
	return PLUGIN_CONTINUE;
}
public wskrzzseanie(id)
{
	if(task_exists(TASKID_REVIVE + id))
		return FMRES_IGNORED
	
	new body = find_dead_body(id)
	if(!fm_is_valid_ent(body))
		return FMRES_IGNORED
	
	new lucky_bastard = pev(body, pev_owner)
	new lb_team = get_user_team(lucky_bastard)
	if(lb_team != 1 && lb_team != 2)
		return FMRES_IGNORED
	
	static name[32]
	get_user_name(lucky_bastard, name, 31)
	client_print(id, print_chat, "Wskrzeszanie %s Trwa", name)
	
	new revivaltime = 3
	msg_bartime(id, revivaltime)
	
	new Float:gametime = get_gametime()
	g_revive_delay[id] = gametime + float(revivaltime) - 0.01
	
	emit_sound(id, CHAN_AUTO, SOUND_START, VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
	set_task(0.0, "task_revive", TASKID_REVIVE + id)
	
	return FMRES_SUPERCEDE
}
public check_magic(id)
{
	if (player_class[id] == MEER || player_class[id] == SORC || player_class[id] == NECROMANCER)
	{
		if (player_item_id[id] != 0)
		{
			new menu = menu_create("\rChcesz uzyc:", "wybierz_useed")
			if (player_class[id] == MEER) menu_additem(menu, "\yUzyj Totemu Leczacego")
			if (player_class[id] == SORC) menu_additem(menu, "\yUzyj Fireballa")
			if (player_class[id] == NECROMANCER) menu_additem(menu, "\yWskrzes \r/ \yPogrzeb")
			menu_additem(menu, "\wUzyj itemu")
			menu_additem(menu, "\dNic nie rob")
			menu_display(id, menu)
		}
		else
		{
			if (player_class[id] == MEER) item_totemheal(id)
			if (player_class[id] == SORC) item_fireball(id)
			if (player_class[id] == NECROMANCER) wskrzzseanie(id)
		}
	}
	
	else check_magic2(id)	
}

public wybierz_useed(id, menu, item)
{
	switch(item)
	{
		case 0: 
		{
			if (player_class[id] == MEER)
				item_totemheal(id)
			if (player_class[id] == SORC)
				item_fireball(id)
			if (player_class[id] == NECROMANCER)
				wskrzzseanie(id)
		}
		case 1: 
		{
			check_magic2(id)
		}
		case 2: menu_destroy(id)
		}
	return PLUGIN_HANDLED
}

public item_halberd(id)
{	
	if (used_item[id])
	{
		hudmsg(id,2.0,"Halberd mozesz uzyc raz na runde")
	}
	else
	{
		used_item[id] = true
		new Float:halberdradius = float(player_b_halberd[id])	
		new iOrigin[3];
		get_user_origin(id, iOrigin);
		
		message_begin( MSG_BROADCAST, SVC_TEMPENTITY, iOrigin );
		write_byte( TE_BEAMCYLINDER );
		write_coord( iOrigin[0] );
		write_coord( iOrigin[1] );
		write_coord( iOrigin[2] );
		write_coord( iOrigin[0] );
		write_coord( iOrigin[1] + player_b_halberd[id]+player_intelligence[id]+player_powerint[id] );
		write_coord( iOrigin[2] + player_b_halberd[id]+player_intelligence[id]+player_powerint[id] );
		write_short( sprite_white );
		write_byte( 0 ); 
		write_byte( 0 ); 
		write_byte( 10 ); 
		write_byte( 120 ); 
		write_byte( 255 ); 
		write_byte( 255 ); 
		write_byte( 0 );
		write_byte( 0 ); 
		write_byte( 128 ); 
		write_byte( 0 ); 
		message_end();
		
		new entlist[33];
		new numfound = find_sphere_class(id, "player", halberdradius+player_intelligence[id]+player_powerint[id] , entlist, 32);
		
		for (new i=0; i < numfound; i++)
		{		
			new pid = entlist[i];
			
			if (is_user_alive(pid) && get_user_team(id) != get_user_team(pid))
				client_cmd(pid,"weapon_knife")
		}
		
		return PLUGIN_CONTINUE;
	}
	return PLUGIN_CONTINUE;
}
public item_pitchfork(id)
{	
	if (used_item[id])
	{
		hudmsg(id,2.0,"Pitchfork mozesz uzyc raz na runde")
	}
	else
	{
		used_item[id] = true
		new Float:pitchforkradius = float(player_b_pitchfork[id])	
		new iOrigin[3];
		get_user_origin(id, iOrigin);
		
		message_begin( MSG_BROADCAST, SVC_TEMPENTITY, iOrigin );
		write_byte( TE_BEAMCYLINDER );
		write_coord( iOrigin[0] );
		write_coord( iOrigin[1] );
		write_coord( iOrigin[2] );
		write_coord( iOrigin[0] );
		write_coord( iOrigin[1] + player_b_pitchfork[id]+player_intelligence[id]+player_powerint[id] );
		write_coord( iOrigin[2] + player_b_pitchfork[id]+player_intelligence[id]+player_powerint[id] );
		write_short( sprite_white );
		write_byte( 0 ); 
		write_byte( 0 ); 
		write_byte( 10 ); 
		write_byte( 120 ); 
		write_byte( 255 ); 
		write_byte( 255 ); 
		write_byte( 255 );
		write_byte( 0 ); 
		write_byte( 128 ); 
		write_byte( 0 ); 
		message_end();
		
		new entlist[33];
		new numfound = find_sphere_class(id, "player", pitchforkradius+player_intelligence[id]+player_powerint[id] , entlist, 32);
		
		for (new i=0; i < numfound; i++)
		{		
			new pid = entlist[i];
			
			if (is_user_alive(pid) && get_user_team(id) != get_user_team(pid))
				Display_Fade(pid, 1<<14, 1<<14 ,1<<16, 255, 155, 50, 230);
		}
		
		return PLUGIN_CONTINUE;
	}
	return PLUGIN_CONTINUE;
}
public PreThinkJuggernaut(es_handle, e, ent, host, hostflags, player, pSet)
{
	if(!is_user_connected(host) || !is_user_connected(ent))
		return;
	
	if(!juggernaut[host])
		return;
	
	set_es(es_handle, ES_RenderAmt, 255.0);
}
public item_juggernaut(id)
{
	if (used_item[id])
	{
		hudmsg(id,2.0,"Juggernaut mozesz uzyc raz na runde")
	}
	else
	{
		new Float:sekundjuggernaut = float(player_b_juggernaut[id])
		used_item[id] = true
		
		juggernaut[id] = 1
		
		set_task(sekundjuggernaut, "wylaczjuggernaut", id);
		message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id ) 
		write_short(player_b_juggernaut[id])
		message_end()
	}
}
public wylaczjuggernaut(id)
{
	if(!is_user_connected(id)) return;
	juggernaut[id] = 0
}
public item_mandrake(id)
{
	if (used_item[id])
	{
		hudmsg(id,2.0,"Mandrake mozesz uzyc raz na runde")
	}
	else
	{
		new Float:sekundmandrake = float(player_b_mandrake[id])
		used_item[id] = true
		
		set_user_hitzones(0, id, 2)
		
		set_task(sekundmandrake, "wylaczmandrake", id);
		message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id ) 
		write_short(player_b_mandrake[id])
		message_end()
	}
}
public wylaczmandrake(id)
{
	if(!is_user_connected(id)) return;
	set_user_hitzones(0, id, 255)
}
public item_spittoon(id)
{
	if (used_item[id])
	{
		hudmsg(id,2.0,"Grawitacje mozesz uzyc raz na runde")
	}
	else
	{
		new Float:sekundspittoon = float(player_b_spittoon[id])
		used_item[id] = true
		
		entity_set_float(id, EV_FL_gravity, 280.0/800.0);
		
		set_task(sekundspittoon, "wylaczspittoon", id);
		message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id ) 
		write_short(player_b_spittoon[id])
		message_end()
	}
}
public wylaczspittoon(id)
{
	if(!is_user_connected(id)) return;
	
	if (player_class[id] != NINJA)
		entity_set_float(id, EV_FL_gravity, 800.0/800.0);
}
public item_cuthealth(id)
{
	if (used_item[id])
	{
		hudmsg(id,2.0,"Anvil mozesz uzyc raz na runde")
	}
	else
	{
		new Float:sekundcuthealth = float(player_b_anvil[id])
		used_item[id] = true
		
		set_user_health(id,get_user_health(id)*2)
		
		set_task(sekundcuthealth, "wylaczcuthealth", id);
		message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id ) 
		write_short(player_b_anvil[id])
		message_end()
	}
}
public wylaczcuthealth(id)
{
	if(!is_user_connected(id)) return;
	
	set_user_health(id,get_user_health(id)/2)
}
public item_elecirtc(id)
{
	if (used_item[id])
	{
		hudmsg(id,2.0,"Niewidzialnosc mozesz uzyc raz na runde")
	}
	else
	{
		new Float:sekundelecirtc = float(player_b_elecirtc[id])
		used_item[id] = true
		
		set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,9)
		
		set_task(sekundelecirtc, "wylaczelecirtc", id);
		message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id ) 
		write_short(player_b_elecirtc[id])
		message_end()
	}
}
public wylaczelecirtc(id)
{
	if(!is_user_connected(id)) return;
	
	if (player_class[id] != NINJA)
		set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,255)
}
public item_artifact(id)
{
	if (used_item[id])
	{
		hudmsg(id,2.0,"Niesmiertelnosc mozesz uzyc raz na runde")
	}
	else
	{
		new Float:sekundartif = float(player_b_artifactr[id])
		used_item[id] = true
		
		set_user_godmode(id,1)
		
		set_task(sekundartif, "wylaczartifact", id);
		message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id ) 
		write_short(player_b_artifactr[id])
		message_end()
	}
}
public wylaczartifact(id)
{
	if(!is_user_connected(id)) return;
	
	set_user_godmode(id,0)
}
/* ==================================================================================================== */
public reset_skill(id)
{	
	if (used_reset[id])
	{
		hudmsg(id,2.0,"Reset mozesz zrobic raz na runde !")
		return PLUGIN_CONTINUE
	}
	
	used_reset[id] = true
	
	skilltree(id)
	client_print(id,print_chat,"Reset umiejetnosci")
	
	player_point[id] = player_lvl[id]*2-2
	player_intelligence[id] = 0
	player_powerint[id] = 0
	player_strength[id] = 0 
	player_agility[id] = 0
	player_dextery[id] = 0
	
	return PLUGIN_CONTINUE;
}
public dropitem(id)
{
	if (player_item_id[id] == 0)
	{
		hudmsg(id,2.0,"Nie masz itemu do wyrzucenia!")
		return PLUGIN_HANDLED
	} 
	
	
	if (item_durability[id] <= 0) 
	{
		hudmsg(id,3.0,"Twoj item sie zniszczyl !")
	}
	else 
	{
		set_hudmessage(100, 200, 55, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
		show_hudmessage(id, "Item wyrzucony")
	}
	
	set_user_rendering(id,kRenderFxGlowShell,0,0,0,kRenderNormal,16)  
	player_item_id[id] = 0
	player_item_name[id] = "Brak"
	player_b_gamble[id] = 0			//Because gamble uses reset skills
	szkielet_damage[id] = 0
	
	if (player_b_extrastats[id] > 0)
	{
		SubtractStats(id,player_b_extrastats[id])
	}
	reset_item_skills(id)
	write_hud(id)
	changeskin(id,1)
	if (player_b_oldsen[id] > 0.0) 
	{
		client_cmd(id,"sensitivity %f",player_b_oldsen[id])
		player_b_oldsen[id] = 0.0
	}
	set_user_gravity(id,1.0)
	
	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

public pfn_touch ( ptr, ptd )
{	
	if (ptd == 0)
		return PLUGIN_CONTINUE
	
	new szClassName[32]
	if(pev_valid(ptd)){
		entity_get_string(ptd, EV_SZ_classname, szClassName, 31)
	}
	else return PLUGIN_HANDLED
	
	if (ptr != 0)
	{
		new szClassNameOther[33]
		entity_get_string(ptr, EV_SZ_classname, szClassNameOther, 32)
		
		
		if(equal(szClassName, "PowerUp") && equal(szClassNameOther, "player"))
		{
			entity_set_int(ptd,EV_INT_iuser2,1)
			award_powerup(ptr)
		}
		
		if(equal(szClassName, "Mine") && equal(szClassNameOther, "player"))
		{
			new owner = pev(ptd,pev_owner)
			
			//Touch
			if (get_user_team(owner) != get_user_team(ptr))
			{
				new Float:origin[3]
				pev(ptd,pev_origin,origin)
				Explode_Origin(owner,origin,55+player_intelligence[owner]+player_powerint[owner],150)
				remove_entity(ptd)
			}
		}
		
		if(equal(szClassName, "grenade") && equal(szClassNameOther, "player"))
		{
			new greModel[64]
			entity_get_string(ptd, EV_SZ_model, greModel, 63)
			
			if(equali(greModel, "models/w_smokegrenade.mdl" ))	
			{
				new id = entity_get_edict(ptd,EV_ENT_owner)
				
				if (is_user_connected(id) 
				&& is_user_alive(id) 
				&& is_user_connected(ptr) 
				&& is_user_alive(ptr) 
				&& player_b_smokehit[id] > 0
				&& get_user_team(id) != get_user_team(ptr))
				UTIL_Kill(id,ptr,"grenade")
			}
			
			
		}
		
	}
	
	
	if(equal(szClassName, "fireball"))
	{
		new Float:origin[3]
		pev(ptd,pev_origin,origin)
		new id = pev(ptd,pev_owner)
		Explode_Origin(id,origin,100,player_b_fireball[id] + player_intelligence[id]+player_powerint[id])
		remove_entity(ptd)
	}
	
	return PLUGIN_CONTINUE
}
/* ==================================================================================================== */
/* ==================================================================================================== */
/* ==================================================================================================== */
/* ==================================================================================================== */
/* ==================================================================================================== */
public ChangeModel(weapon)
{
	if(!pev_valid(weapon))
		return HAM_IGNORED
	
	static player
	player = pev(weapon, pev_owner)
	
	if(!is_user_alive(player))
		return HAM_IGNORED
	
	if(!player_b_throwingaxe[player])
		return HAM_IGNORED
		
	change(player)
	return HAM_HANDLED
}
public KnifeSound(id, channel, sample[], Float:volume, Float:attn, flags, pitch)
{
	if(!equal(sample, "weapons/knife_", 14) || !player_b_throwingaxe[id])
		return FMRES_IGNORED
			
	if(equal(sample[8], "knife_hitwall", 13))
	{
		PlaySound(id, 1)
		util_playweaponanimation(id,3 )	
	}
	else
	if(equal(sample[8], "knife_hit", 9))
	{
		switch(random(2))
		{
			case 0:
			{
				PlaySound(id, 4) 
				util_playweaponanimation(id,2 )
				knife_effect(id)
			}
			case 1:
			{
				PlaySound(id, 5)
				util_playweaponanimation(id,5 )
				knife_effect(id)
			}
		}	
	}
	if(equal(sample[8], "knife_slash", 11)) 
	{
		PlaySound(id, 2)
		util_playweaponanimation(id,3 )
		knife_effect(id)
	}
	if(equal(sample[8], "knife_stab", 10)) 
	{
		PlaySound(id, 3)
		util_playweaponanimation(id,5 )
		knife_effect(id)
	}
	if(equal(sample[8], "knife_deploy", 12)) 
	{
		PlaySound(id, 0)
		util_playweaponanimation(id,1 )
	}
	return FMRES_SUPERCEDE
}

public TakeDamage_Pre(victim, inflictor, attacker, Float:damage, damagetype)
{
	if(!is_user_alive(attacker))
	return HAM_IGNORED
		
	if(!player_b_throwingaxe[attacker] || get_user_weapon(attacker) != CSW_KNIFE)
 	return HAM_IGNORED
 	
	new hit, target
	get_user_aiming(attacker, target, hit)

	new bool:head = (hit == HIT_HEAD)
	new Float:mult_dmg = 1.0
	if(pev(attacker, pev_button, IN_ATTACK))
		mult_dmg = head ? 12.0 : 6.0
	else
		mult_dmg = head ? 6.0 : 4.0
	SetHamParamFloat(4, damage * mult_dmg)
	return HAM_HANDLED
}

public TakeDamage_Post(victim, inflictor, attacker, Float:damage, damagetype)
{
	if(!is_user_alive(attacker) || !is_user_alive(victim)) 
	return HAM_IGNORED
		
	if(!player_b_throwingaxe[attacker] || get_user_weapon(attacker) != CSW_KNIFE)
 	return HAM_IGNORED
		
	new Float:Origin[3], Float:Origin2[3], Float:Velocity[3]
	pev(attacker, pev_origin, Origin)
	pev(victim, pev_origin, Origin2)
	xs_vec_sub(Origin2, Origin, Velocity)
	xs_vec_normalize(Velocity, Velocity)
	xs_vec_mul_scalar(Velocity, (500.0), Velocity)
	if(Velocity[2] <= 100.0) Velocity[2] = random_float(150.0, 250.0)
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
	write_byte(TE_BLOODSPRITE);
	engfunc(EngFunc_WriteCoord, Origin2[0])
	engfunc(EngFunc_WriteCoord, Origin2[1])
	engfunc(EngFunc_WriteCoord, Origin2[2])
	write_short(sprite_blood_drop)
	write_short(sprite_blood_spray)
	write_byte(77)
	write_byte(3)
	message_end()
	set_pev(victim, pev_velocity, Velocity)
	return HAM_HANDLED
}
change(id)
{
	set_pev(id, pev_viewmodel2, v_knife)
	set_pev(id, pev_weaponmodel2, p_knife)
}
public knife_effect(id)
{
	if(is_user_alive(id) && is_user_connected(id))
	{
		static ent1;
		ent1 = -1;
		while((ent1 = engfunc(EngFunc_FindEntityByString, ent1, "classname", "knife_effect")))
		return PLUGIN_HANDLED
		new ent = create_entity("info_target")
    
		static Float:Origin[3],Float:g_angles[3], Float:g_v_angles[3]
		pev(id, pev_angles, g_angles)
		pev(id, pev_v_angle, g_v_angles)
		g_angles[0] += 20.0
		entity_set_vector(ent, EV_VEC_angles, g_angles)
		entity_set_vector(ent, EV_VEC_v_angle, g_v_angles)
		pev(id, pev_origin, Origin)
		entity_set_origin(ent, Origin)
		entity_set_string(ent,EV_SZ_classname, "knife_effect")
		entity_set_model(ent, dragon_knife_effect)
		entity_set_int(ent, EV_INT_solid, SOLID_NOT)
		entity_set_int(ent, EV_INT_movetype, MOVETYPE_NONE)
		set_task(0.1, "remove_knife_effect", ent)
	}
	return PLUGIN_HANDLED
}
public remove_knife_effect(ent)
{
	remove_entity(ent)
}
stock PlaySound(Ent, Sound)
	engfunc(EngFunc_EmitSound, Ent, CHAN_WEAPON, SoundList[_:Sound], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)

stock util_playweaponanimation(const Player, const Sequence)
{
	set_pev(Player, pev_weaponanim, Sequence)
	
	message_begin(MSG_ONE_UNRELIABLE, SVC_WEAPONANIM, .player = Player)
	write_byte(Sequence)
	write_byte(pev(Player, pev_body))
	message_end()
}
/* ==================================================================================================== */
public clearmri(id)
{
	ClearUserReversed(id)
	atakowanymir[id] = false;
}
/* ==================================================================================================== */
public kula1(id)
{
	
	if (used_item[id])
	{
		hudmsg(id,2.0,"Mozesz uzyc tylko 1 kule na runde")
		return PLUGIN_CONTINUE
	}
	
	used_item[id] = true
	DispBall_Spawn(id)
	
	/*if (player_b_plasma[id] > 0)
{
	DispBall_Spawn(id)
}

if(player_item_id[id] == 78)
{
	DispBall_Spawn(id)
}

new xD = floatround(halflife_time()-wait1[id])
new czas = 10-xD
if (halflife_time()-wait1[id] <= 10)
{
	client_print(id, print_center, "Za %d sek mozesz uzyc mocy!", czas)
	return PLUGIN_CONTINUE;
}                                                                                                                       
else 
{
	DispBall_Spawn(id)
	wait1[id]=floatround(halflife_time())
}
*/
	return PLUGIN_HANDLED
}
public DispBall_Explode(ent)
{
	if (!pev(ent, pev_iuser3))
	{
		new Float: origin[3];
		pev(ent, pev_origin, origin);
		set_pev(ent, pev_iuser3, 1);
		
		UTIL_MakeBeamCylinder(origin, m_DispRing) ;
		
		new Players[32], playerCount, a
		get_players(Players, playerCount, "ah")
		
		new id = pev(ent,pev_owner)
		for (new i=0; i<playerCount; i++)
		{
			a = Players[i]
			
			new Float:aOrigin[3]
			pev(a,pev_origin,aOrigin)
			
			if (get_user_team(id) != get_user_team(a) && get_distance_f(aOrigin,origin) < 320.0+player_intelligence[id]*2+player_powerint[id]*2)
			{
				ExecuteHamB(Ham_TakeDamage, a, ent, id, 55.0+player_intelligence[id]*1.5, DMG_ENERGYBEAM );
			}
			
		}
	}
	set_pev(ent, pev_velocity, Float:{0.0, 0.0, 0.0});
	set_pev(ent, pev_iuser4, 1);
	set_pev(ent, pev_nextthink, get_gametime() + 0.6);
}
public DispBall_Spawn(id)
{
	static AllocStringCached;
	if (!AllocStringCached)
	{
		AllocStringCached = engfunc(EngFunc_AllocString, "info_target");
	}
	
	new ent = engfunc(EngFunc_CreateNamedEntity, AllocStringCached);
	if(!pev_valid(ent)) return 0;
	
	set_pev(ent, pev_classname, BALL_CLASSNAME);
	
	new Float: origin[3];
	new Float: velocity[3];
	new Float: v_forward[3];
	new Float: v_right[3];
	new Float: v_up[3];
	
	GetGunPosition(id, origin);
	
	global_get(glb_v_forward, v_forward);
	global_get(glb_v_right, v_right);
	global_get(glb_v_up, v_up);
	
	//xs_vec_mul_scalar(v_forward, 29.0, v_forward)
	xs_vec_mul_scalar(v_right, 2.0, v_right);
	xs_vec_mul_scalar(v_up, -5.0, v_up);
	
	xs_vec_add(origin, v_forward, origin);
	xs_vec_add(origin, v_right, origin);
	xs_vec_add(origin, v_up, origin);
	
	set_pev(ent, pev_origin, origin);
	set_pev(ent, pev_owner, id);
	set_pev(ent, pev_dmg, 100.0);
	
	engfunc(EngFunc_SetModel, ent, "addons/amxmodx/diablo/flame.spr");
	engfunc(EngFunc_SetSize, ent, Float:{0.0, 0.0, 0.0} , Float:{0.0, 0.0, 0.0});
	
	set_pev(ent, pev_effects, pev(ent, pev_effects) | EF_LIGHT);
	set_rendering(ent, kRenderFxNone, 0, 0, 0, kRenderTransAdd, 255);
	
	velocity_by_aim(id, 500, velocity);
	set_pev(ent, pev_velocity, velocity);
	
	dllfunc(DLLFunc_Spawn, ent);
	
	set_pev(ent, pev_movetype, MOVETYPE_FLY);
	set_pev(ent, pev_solid, SOLID_BBOX);
	set_pev(ent, pev_scale, 5);
	set_pev(ent, pev_nextthink, get_gametime() + 0.1);
	
	return ent;
}

public DispBall_Think(ent)
{
	if (!pev_valid(ent))
		return;
	
	DispBall_Animate(ent);
	
	if (pev(ent, pev_iuser4))
	{
		remove_entity(ent);
		return;
	}
	
	static Float: velocity[3];
	pev(ent, pev_velocity, velocity);
	
	if (!vector_length(velocity) || !IsInWorld(ent))
	{
		DispBall_Explode(ent)
		return;
	}
	
	static ptr, i, id, owner, beam;
	static Float: Dist;
	static Float: flFraction;
	static Float: origin[3];
	static Float: vecDir[3];
	static Float: vecEndPos[3];
	
	Dist = 1.00; ptr = create_tr2();
	
	pev(ent, pev_origin, origin);
	
	while ((id = engfunc(EngFunc_FindEntityInSphere, id, origin, 280.0)))
	{
		if (random_float(0.0, 1.0) <= 0.2 && pev(id, pev_takedamage) && is_visible(id, ent) && id != (owner = pev(ent, pev_owner)))
		{
			static Float: target_origin[3]; pev(id, pev_origin, target_origin);
			new Players[32], playerCount, a
			get_players(Players, playerCount, "ah")
			
			new id = pev(ent,pev_owner)
			for (new i=0; i<playerCount; i++)
			{
				new Float:aOrigin[3]
				pev(a,pev_origin,aOrigin)
				
				if (get_user_team(id) != get_user_team(a) && get_distance_f(aOrigin,origin) < 320.0+player_intelligence[id]*2+player_powerint[id]*2)
				{
					ExecuteHamB(Ham_TakeDamage, id, ent, owner, 52.0, DMG_ENERGYBEAM );
				}
				
			}
			
			if ((beam = BeamCreate(id, SPRITE_PLASMA, m_Plasma, 65.0)))
			{
				RelinkBeam(beam, origin, target_origin);
				
				BeamSetColor(beam, 255.0, 255.0, 15.0);
				BeamSetNoise(beam, 45);
				BeamSetBrightness(beam, 255.0);
				BeamSetScrollRate(beam, 35.0);
				BeamLiveForTime(beam, 0.1);
			}
		}
	}
	for (i = 0; i < 10; i++)
	{
		vecDir[0] = random_float(-1.0, 1.0);
		vecDir[1] = random_float(-1.0, 1.0);
		vecDir[2] = random_float(-1.0, 1.0);
		
		VecNormilize(vecDir, vecDir);
		xs_vec_mul_scalar(vecDir, 1536.0, vecDir);
		xs_vec_add(vecDir, origin, vecDir);
		
		engfunc(EngFunc_TraceLine, origin, vecDir, IGNORE_MONSTERS, ent, ptr);
		get_tr2(ptr, TR_flFraction, flFraction);
		
		if (Dist > flFraction)
		{
			get_tr2(ptr, TR_vecEndPos, vecEndPos);
			Dist = flFraction;
		}
	}
	
	if (Dist < 1.0)
	{
		if ((beam = BeamCreate(ent, SPRITE_PLASMA, m_Plasma, 30.0)))
		{
			RelinkBeam(beam, vecEndPos, origin);
			
			BeamSetColor(beam, 255.0, 15.0, 15.0);
			BeamSetNoise(beam, 65);
			BeamSetBrightness(beam, 255.0);
			BeamSetScrollRate(beam, 35.0);
			BeamLiveForTime(beam, 1.0);
		}
	}
	
	set_pev(ent, pev_nextthink, get_gametime() + 0.1);
	free_tr2(ptr);
}

public DispBeam_Think(ent)
{
	if (pev_valid(ent))
	{
		remove_entity(ent);
	}
}

public DispBall_Explode_Touch(ent)
{
	if (pev_valid(ent))
	{
		DispBall_Explode(ent);
	}
}

stock GetGunPosition(const player, Float:origin[3] )
{
	new Float:viewOfs[3];
	
	pev(player, pev_origin, origin);
	pev(player, pev_view_ofs, viewOfs);
	
	xs_vec_add( origin, viewOfs, origin);
}
stock BeamCreate(const endIndex, const pSpriteName[], const spriteIndex, const Float: width)
{
	static AllocStringCached;
	if (!AllocStringCached)
	{
		AllocStringCached = engfunc(EngFunc_AllocString, "beam");
	}
	
	static ent;
	if (!(ent = engfunc(EngFunc_CreateNamedEntity, AllocStringCached)))
		return 0;
	
	set_pev(ent, pev_classname, BEAM_CLASSNAME);
	
	set_pev(ent, pev_flags, pev(ent, pev_flags) | FL_CUSTOMENTITY);
	
	BeamSetFrame(ent, 0);
	
	set_pev(ent, pev_model, pSpriteName);
	
	BeamSetTexture(ent, spriteIndex);
	BeamSetWidth(ent, width);
	
	set_pev(ent, pev_skin, endIndex);
	set_pev(ent, pev_sequence, 0);
	set_pev(ent, pev_rendermode, 1);
	
	DispatchSpawn(ent);
	
	return ent;
}
stock RelinkBeam(const beam, const Float: startPos[3], const Float: endPos[3])
{
	static Float: mins[3], Float: maxs[3];
	
	mins[0] = floatmin(startPos[0], endPos[0]);
	mins[1] = floatmin(startPos[1], endPos[1]);
	mins[2] = floatmin(startPos[2], endPos[2]);
	
	maxs[0] = floatmax(startPos[0], endPos[0]);
	maxs[1] = floatmax(startPos[1], endPos[1]);
	maxs[2] = floatmax(startPos[2], endPos[2]);
	
	xs_vec_sub(mins, startPos, mins);
	xs_vec_sub(maxs, startPos, maxs);
	
	set_pev(beam, pev_mins, mins);
	set_pev(beam, pev_maxs, maxs);
	
	engfunc(EngFunc_SetSize, beam, mins, maxs);
	engfunc(EngFunc_SetOrigin, beam, startPos);
}


stock VecNormilize(Float: in[3], Float: out[3])
{
	static Float: vlen;
	
	vlen = vector_length(in);
	vlen = 1/vlen;
	
	out[0] *= vlen;
	out[1] *= vlen;
	out[2] *= vlen;
}

stock UTIL_MakeBeamCylinder(const Float:origin[3], const m_Sprite)
{
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
	write_byte(TE_BEAMCYLINDER);
	engfunc(EngFunc_WriteCoord, origin[0]);
	engfunc(EngFunc_WriteCoord, origin[1]);
	engfunc(EngFunc_WriteCoord, origin[2]);
	engfunc(EngFunc_WriteCoord, origin[0]);
	engfunc(EngFunc_WriteCoord, origin[1]);
	engfunc(EngFunc_WriteCoord, origin[2] + 200.0) ;
	write_short(m_Sprite) ;
	write_byte(0);
	write_byte(10);
	write_byte(3);
	write_byte(20);
	write_byte(0);
	write_byte(255);
	write_byte(255);
	write_byte(0);
	write_byte(255);
	write_byte(0);
	message_end();
}

DispBall_Animate(const ent)
{
	entity_set_float(ent, EV_FL_frame, entity_get_float(ent, EV_FL_frame) + 10.0);

	if (entity_get_float(ent, EV_FL_frame) > 24.0)
		entity_set_float(ent, EV_FL_frame, 0.0);
}
BeamSetColor(const ent, const Float: red, const Float: green, const Float: blue)
{
	static Float: rgb[3];

	rgb[0] = red;
	rgb[1] = green;
	rgb[2] = blue;

	set_pev(ent, pev_rendercolor, rgb);
}
BeamLiveForTime(const ent, const Float: time) set_pev(ent, pev_nextthink, halflife_time() + time);
BeamSetBrightness(const ent, const Float: brightness) set_pev(ent, pev_renderamt, brightness);
BeamSetNoise(const ent, const noise) set_pev(ent, pev_body, noise);
BeamSetFrame(const ent, const frame) set_pev(ent, pev_frame, frame);
BeamSetScrollRate(const ent, const Float: speed) set_pev(ent, pev_animtime, speed);
BeamSetTexture(const ent, const spriteIndex) set_pev(ent, pev_modelindex, spriteIndex);
BeamSetWidth(const ent, const Float: width) set_pev(ent, pev_scale, width);

/* ==================================================================================================== */
public event_hltv()
{
	fm_remove_entity_name("fake_corpse")
	
	static players[32], num
	get_players(players, num, "a")
	for(new i = 0; i < num; i++)
	{
		if(is_user_connected(players[i]))
		{
			reset_player(players[i])
			msg_bartime(players[i], 0)
		}
	}
}
public fwd_playerpostthink(id)
{
	if(!is_user_connected(id)) 
		return FMRES_IGNORED
	
	if(player_class[id] != NECROMANCER || player_b_ashroudnecro[id] != 1) 
		return FMRES_IGNORED
	
	if(!is_user_alive(id))
	{
		Display_Icon(id,25,25,250,"dmg_shock",0)
		return FMRES_IGNORED
	}
	
	new body = find_dead_body(id)
	if(fm_is_valid_ent(body))
	{
		new lucky_bastard = pev(body, pev_owner)
		
		if(!is_user_connected(lucky_bastard))
			return FMRES_IGNORED
		
		new lb_team = get_user_team(lucky_bastard)
		if(lb_team == 1 || lb_team == 2 ) Display_Icon(id,0,127,255,"dmg_shock",1)
	}
	else Display_Icon(id, 50,50,50 , "dmg_shock",1)
	
	return FMRES_IGNORED
}

public task_check_dead_flag(id)
{
	if(!is_user_connected(id))
		return
	
	if(pev(id, pev_deadflag) == DEAD_DEAD)
		create_fake_corpse(id)
	else
		set_task(0.5, "task_check_dead_flag", id)
}	

public create_fake_corpse(id)
{
	set_pev(id, pev_effects, EF_NODRAW)
	
	static model[32]
	cs_get_user_model(id, model, 31)
	
	static player_model[64]
	format(player_model, 63, "models/player/%s/%s.mdl", model, model)
	
	static Float: player_origin[3]
	pev(id, pev_origin, player_origin)
	
	static Float:mins[3]
	mins[0] = -16.0
	mins[1] = -16.0
	mins[2] = -34.0
	
	static Float:maxs[3]
	maxs[0] = 16.0
	maxs[1] = 16.0
	maxs[2] = 34.0
	
	if(g_wasducking[id])
	{
		mins[2] /= 2
		maxs[2] /= 2
	}
	
	static Float:player_angles[3]
	pev(id, pev_angles, player_angles)
	player_angles[2] = 0.0
	
	new sequence = pev(id, pev_sequence)
	
	new ent = fm_create_entity("info_target")
	if(ent)
	{
		set_pev(ent, pev_classname, "fake_corpse")
		engfunc(EngFunc_SetModel, ent, player_model)
		engfunc(EngFunc_SetOrigin, ent, player_origin)
		engfunc(EngFunc_SetSize, ent, mins, maxs)
		set_pev(ent, pev_solid, SOLID_TRIGGER)
		set_pev(ent, pev_movetype, MOVETYPE_TOSS)
		set_pev(ent, pev_owner, id)
		set_pev(ent, pev_angles, player_angles)
		set_pev(ent, pev_sequence, sequence)
		set_pev(ent, pev_frame, 9999.9)
	}	
}
public task_revive(taskid) 
{
	new id = taskid - TASKID_REVIVE
	
	if(!is_user_alive(id))
	{
		failed_revive(id)
		return FMRES_IGNORED
	}
	new body = find_dead_body(id)
	if(!fm_is_valid_ent(body))
	{
		failed_revive(id)
		return FMRES_IGNORED
	}
	
	new lucky_bastard = pev(body, pev_owner)
	if(!is_user_connected(lucky_bastard))
	{
		failed_revive(id)
		return FMRES_IGNORED
	}
	
	new lb_team = get_user_team(lucky_bastard)
	if(lb_team != 1 && lb_team != 2)
	{
		failed_revive(id)
		return FMRES_IGNORED
	}
	
	static Float:velocity[3]
	pev(id, pev_velocity, velocity)
	velocity[0] = 0.0
	velocity[1] = 0.0
	set_pev(id, pev_velocity, velocity)
	
	new Float:gametime = get_gametime()
	
	if(g_revive_delay[id] < gametime)
	{
		if(findemptyloc(body, 10.0))
		{
			fm_remove_entity(body)
			emit_sound(id, CHAN_AUTO, SOUND_FINISHED, VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
			
			new args[2]
			args[0]=lucky_bastard
			
			if(get_user_team(id)!=get_user_team(lucky_bastard))
			{
				args[1]=1
				Give_Xp(id,get_cvar_num("diablo_xpbonus")/2)
				new health = player_rs_health[id];
				new nowe_zdrowie = (get_user_health(id)<health)? get_user_health(id): health;
				fm_set_user_health(id, nowe_zdrowie);
				cs_set_user_money(id,cs_get_user_money(id)+100)
				client_print(id,print_chat,"Dostales *%i* doswiadcznia za pogrzebanie zwlok wroga w piekle !",get_cvar_num("diablo_xpbonus")/2)
				
			}
			else
			{
				args[1]=0
				Give_Xp(id,get_cvar_num("diablo_xpbonus")/2)
				cs_set_user_money(id,cs_get_user_money(id)+100)
				client_print(id,print_chat,"Dostales *%i* doswiadcznia za wskrzeszenie przyjaciela !",get_cvar_num("diablo_xpbonus")/2)
				set_task(0.1, "task_respawn", TASKID_RESPAWN + lucky_bastard,args,2)
			}
		}
		else
			failed_revive(id)
	}
	else
		set_task(0.1, "task_revive", TASKID_REVIVE + id)
	
	return FMRES_IGNORED
}

public failed_revive(id)
{
	msg_bartime(id, 0)
	emit_sound(id, CHAN_AUTO, SOUND_FAILED, VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
}

public off(id)
{
	msg_bartime(id, 0)
	reset_player(id)
	Display_Icon(id, 15,15,15 , "dmg_shock",0)
}

public task_origin(args[])
{
	new id = args[0]
	engfunc(EngFunc_SetOrigin, id, g_body_origin[id])
	
	static  Float:origin[3]
	pev(id, pev_origin, origin)
	set_pev(id, pev_zorigin, origin[2])
	
	set_task(0.1, "task_stuck_check", TASKID_CHECKST + id,args,2)
	
}

stock find_dead_body(id)
{
	static Float:origin[3]
	pev(id, pev_origin, origin)
	
	new ent
	static classname[32]	
	while((ent = fm_find_ent_in_sphere(ent, origin, 100.0+player_powerint[id]+player_intelligence[id])) != 0) 
	{
		pev(ent, pev_classname, classname, 31)
		if(equali(classname, "fake_corpse") && fm_is_ent_visible(id, ent))
			return ent
	}
	return 0
}

stock msg_bartime(id, seconds) 
{
	if(is_user_bot(id)||!is_user_alive(id)||!is_user_connected(id))
		return
	
	message_begin(MSG_ONE, gmsgBartimer, _, id)
	write_byte(seconds)
	write_byte(0)
	message_end()
}

public task_respawn(args[]) 
{
	new id = args[0]
	
	if (!is_user_connected(id) || is_user_alive(id) || cs_get_user_team(id) == CS_TEAM_SPECTATOR) return
	
	set_pev(id, pev_deadflag, DEAD_RESPAWNABLE) 
	dllfunc(DLLFunc_Think, id) 
	dllfunc(DLLFunc_Spawn, id) 
	set_pev(id, pev_iuser1, 0)
	
	set_task(0.1, "task_check_respawn", TASKID_CHECKRE + id,args,2)
}

public task_check_respawn(args[])
{
	new id = args[0]
	
	if(pev(id, pev_iuser1))
		set_task(0.1, "task_respawn", TASKID_RESPAWN + id,args,2)
	else
		set_task(0.1, "task_origin", TASKID_ORIGIN + id,args,2)
	
}

public task_stuck_check(args[])
{
	new id = args[0]
	
	static Float:origin[3]
	pev(id, pev_origin, origin)
	
	if(origin[2] == pev(id, pev_zorigin))
		set_task(0.1, "task_respawn", TASKID_RESPAWN + id,args,2)
	else
		set_task(0.1, "task_setplayer", TASKID_SETUSER + id,args,2)
}

public task_setplayer(args[])
{
	new id = args[0]
	fm_set_user_health(id, 65+player_powerint[id]+player_intelligence[id])
	
	Display_Fade(id,seconds(2),seconds(2),0,0,0,0,255)
}

stock bool:findemptyloc(ent, Float:radius)
{
	if(!fm_is_valid_ent(ent))
		return false
	
	static Float:origin[3]
	pev(ent, pev_origin, origin)
	origin[2] += 2.0
	
	new owner = pev(ent, pev_owner)
	new num = 0, bool:found = false
	
	while(num <= 100)
	{
		if(is_hull_vacant(origin))
		{
			g_body_origin[owner][0] = origin[0]
			g_body_origin[owner][1] = origin[1]
			g_body_origin[owner][2] = origin[2]
			
			found = true
			break
		}
		else
		{
			origin[0] += random_float(-radius, radius)
			origin[1] += random_float(-radius, radius)
			origin[2] += random_float(-radius, radius)
			
			num++
		}
	}
	return found
}

stock bool:is_hull_vacant(const Float:origin[3])
{
	new tr = 0
	engfunc(EngFunc_TraceHull, origin, origin, 0, HULL_HUMAN, 0, tr)
	if(!get_tr2(tr, TR_StartSolid) && !get_tr2(tr, TR_AllSolid) && get_tr2(tr, TR_InOpen))
		return true
	
	return false
}

/* ==================================================================================================== */
public fw_CmdStart(id, uc_handle, seed)
{
	if(!is_user_alive(id)) return FMRES_IGNORED
	
	if(player_b_maul[id] > 0)
	{
		set_pev(id, pev_view_ofs, {0.0, 0.0, 70.0})
	}
	return FMRES_IGNORED
}

public Player_inDuck(id)
{
	if(player_b_maul[id] > 0)
	{
		static button, ducking
		button = pev(id, pev_button)
		ducking = pev(id, pev_flags) & (FL_DUCKING | FL_ONGROUND) == (FL_DUCKING | FL_ONGROUND)
		
		if(button & IN_DUCK || ducking)
		{
			set_pev(id, pev_view_ofs, {0.0, 0.0, 35.0}) 
		}
	}
}
/* ==================================================================================================== */
public func_HamWeaponM3(iEnt)
{
	if(g_iOldClip>get_pdata_int(iEnt, m_iClip, 4) && g_iOldClip> 1 && pev(g_iShotgunOwner, pev_button) && IN_ATTACK2 && player_b_inkwell[g_iShotgunOwner] > 0)
	{
		static Float:s_fAngleDifference, Float:s_fOldAngle
		set_pev(g_iShotgunOwner, pev_punchangle, g_fBackupAngle)
		s_fOldAngle = g_fBackupAngle[0]
		ExecuteHamB(Ham_Weapon_PrimaryAttack, iEnt)
		pev(g_iShotgunOwner, pev_punchangle, g_fBackupAngle)
		s_fAngleDifference = (g_fBackupAngle[0]-s_fOldAngle)
		if( g_fBackupAngle[0]>-25.0 && g_fBackupAngle[0]<0.0 )
		{
			s_fAngleDifference *= 2.1;
			g_fBackupAngle[0] = (s_fOldAngle+s_fAngleDifference)
			if( g_fBackupAngle[0]<-25.0 )
				g_fBackupAngle[0] = -25.0
			set_pev(g_iShotgunOwner, pev_punchangle, g_fBackupAngle)
		}
	}
}

public func_HamWeaponM3_Pre(iEnt)
{
	if( (g_iOldClip=get_pdata_int(iEnt, m_iClip, 4))>0 )
	{
		if( pev((g_iShotgunOwner=get_pdata_cbase(iEnt, m_pPlayer, 4)), pev_waterlevel)!=3 )
		{
			static Float:s_fViewOfs[3], Float:s_fAngle[3];
			pev(g_iShotgunOwner, pev_origin, g_fAimFrom);
			pev(g_iShotgunOwner, pev_view_ofs, s_fViewOfs);
			pev(g_iShotgunOwner, pev_v_angle, s_fAngle);
			g_fAimFrom[0] += s_fViewOfs[0];
			g_fAimFrom[1] += s_fViewOfs[1];
			g_fAimFrom[2] += s_fViewOfs[2];
			pev(g_iShotgunOwner, pev_punchangle, s_fViewOfs);
			s_fAngle[0] += s_fViewOfs[0];
			s_fAngle[1] += s_fViewOfs[1];
			s_fAngle[2] += s_fViewOfs[2];
			
			s_fAngle[0] *= -1;
			if( get_pdata_int(iEnt, m_iId, 4)==CSW_M3 )
			{
				SphereToCartesian(g_fAimTo, g_fAimFrom, s_fAngle, Float:{0.0, 0.0, 3000.0});
			}
			else
			{
				SphereToCartesian(g_fAimTo, g_fAimFrom, s_fAngle, Float:{0.0, 0.0, 3048.0});
			}
			
			pev(g_iShotgunOwner, pev_punchangle, g_fBackupAngle);
		}
	}	
}

bool:SphereToCartesian(Float:fDest[3], Float:fOrigin[3], Float:fView[3], Float:fAngle[3])
{
	fView[1] *= (M_PI/180.0);
	fView[0] *= (M_PI/180.0);

	fAngle[0] *= (M_PI/-180.0);
	fAngle[1] *= (M_PI/180.0);

	static Float:s_fSin0, Float:s_fCos0, Float:s_fSin1, Float:s_fCos1;
	s_fSin0 = floatsin((fAngle[0]+(M_PI*0.5)), radian);

	fDest[0] = fAngle[2]*s_fSin0*floatcos(fAngle[1], radian);
	fDest[1] = fAngle[2]*s_fSin0*floatsin(fAngle[1], radian);
	fDest[2] = fAngle[2]*floatcos((fAngle[0]+(M_PI*0.5)), radian);

	s_fSin0 = floatsin(fView[0], radian);
	s_fCos0 = floatcos(fView[0], radian);
	s_fSin1 = floatsin(fView[1], radian);
	s_fCos1 = floatcos(fView[1], radian);

	static Float:s_fTemp[3];
	s_fTemp[0] = (fDest[0]*s_fCos0*s_fCos1)-(fDest[1]*s_fSin1)+(fDest[2]*s_fSin0*s_fCos1);
	s_fTemp[1] = (fDest[0]*s_fCos0*s_fSin1)+(fDest[1]*s_fCos1)+(fDest[2]*s_fSin1*s_fSin0);
	s_fTemp[2] = (fDest[2]*s_fCos0)-(fDest[0]*s_fSin0);

	fDest[0] = (fOrigin[0]+s_fTemp[0]);
	fDest[1] = (fOrigin[1]+s_fTemp[1]);
	fDest[2] = (fOrigin[2]-s_fTemp[2]);

	return true;
}
/* ==================================================================================================== */

public func_ExecuteSonic(id)
{	
	new Float:iOrigin[3]
	pev(id,pev_origin,iOrigin)
	
	func_create_blast(iOrigin)
	
	new players[32], pnum, tempid
	new Float:TempOrigin[3]
	
	new Float:iDistance
	
	new Float:vec[3];
	new Float:oldvelo[3];
	
	get_players(players, pnum, "ae", "TERRORIST")
	for(new i; i <= pnum; i++)
	{
		tempid = players[i]
		pev(tempid,pev_origin,TempOrigin)
		
		iDistance = get_distance_f(iOrigin, TempOrigin)
		
		if(iDistance < player_b_loaf[id] && get_user_team(id) != get_user_team(tempid) && is_user_alive(tempid))
		{
			get_user_velocity(tempid, oldvelo);
			create_velocity_vector(tempid , id , vec);
			vec[0] += oldvelo[0];
			vec[1] += oldvelo[1];
			set_user_velocity(tempid , vec)
			UTIL_Kill(id,tempid,"knife")
		}
	}
}

public func_create_blast(Float:origin[3])
{
	new temp_origin[3]
	FVecIVec(origin,temp_origin)
	
	new Float:temp_rgbF[3], temp_rgb[3]
	
	temp_rgbF[0] = 0.0
	temp_rgbF[1] = 206.0
	temp_rgbF[2] = 209.0
	
	FVecIVec(temp_rgbF,temp_rgb)
	
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(TE_BEAMCYLINDER)
	write_coord(temp_origin[0])
	write_coord(temp_origin[1])
	write_coord(temp_origin[2])
	write_coord(temp_origin[0])
	write_coord(temp_origin[1])
	write_coord(temp_origin[2] + 385)
	write_short(g_Explosion)
	write_byte(0)
	write_byte(0)
	write_byte(4)
	write_byte(60)
	write_byte(0)
	write_byte(temp_rgb[0])
	write_byte(temp_rgb[1])
	write_byte(temp_rgb[2])
	write_byte(100)
	write_byte(0)
	message_end()
	
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(TE_BEAMCYLINDER)
	write_coord(temp_origin[0])
	write_coord(temp_origin[1])
	write_coord(temp_origin[2])
	write_coord(temp_origin[0])
	write_coord(temp_origin[1])
	write_coord(temp_origin[2] + 470)
	write_short(g_Explosion)
	write_byte(0)
	write_byte(0)
	write_byte(4)
	write_byte(60)
	write_byte(0)
	write_byte(temp_rgb[0])
	write_byte(temp_rgb[1])
	write_byte(temp_rgb[2])
	write_byte(100)
	write_byte(0)
	message_end()
	
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(TE_BEAMCYLINDER)
	write_coord(temp_origin[0])
	write_coord(temp_origin[1])
	write_coord(temp_origin[2])
	write_coord(temp_origin[0])
	write_coord(temp_origin[1])
	write_coord(temp_origin[2] + 555)
	write_short(g_Explosion)
	write_byte(0)
	write_byte(0)
	write_byte(4)
	write_byte(60)
	write_byte(0)
	write_byte(temp_rgb[0])
	write_byte(temp_rgb[1])
	write_byte(temp_rgb[2])
	write_byte(100)
	write_byte(0)
	message_end()
	
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(TE_DLIGHT)
	write_coord(temp_origin[0])
	write_coord(temp_origin[1])
	write_coord(temp_origin[2])
	write_byte(floatround(200/5.0))
	write_byte(temp_rgb[0])
	write_byte(temp_rgb[1])
	write_byte(temp_rgb[2])
	write_byte(8)
	write_byte(60)
	message_end()
}
/* ==================================================================================================== */

public StworzBelt(id)
{

	if (!is_user_alive(id) || !ilosc_beltow[id])
		return PLUGIN_CONTINUE
	
	ilosc_beltow[id]--;
	new Float: Origin[3], Float: vAngle[3], Float: Velocity[3];		
	entity_get_vector(id, EV_VEC_v_angle, vAngle);
	entity_get_vector(id, EV_VEC_origin , Origin);
	
	new Ent = create_entity("info_target");
	
	entity_set_string(Ent, EV_SZ_classname, "Belt");
	entity_set_model(Ent, "models/crossbow_bolt.mdl");
	
	vAngle[0] *= -1.0;
	
	entity_set_origin(Ent, Origin);
	entity_set_vector(Ent, EV_VEC_angles, vAngle);
	
	entity_set_int(Ent, EV_INT_effects, 2);
	entity_set_int(Ent, EV_INT_solid, SOLID_BBOX);
	entity_set_int(Ent, EV_INT_movetype, MOVETYPE_FLY);
	entity_set_edict(Ent, EV_ENT_owner, id);
	
	VelocityByAim(id, 2200, Velocity);
	entity_set_vector(Ent, EV_VEC_velocity ,Velocity);
	
	return PLUGIN_CONTINUE;
}


public DotykBeltu(ent)
{
	if ( !is_valid_ent(ent))
		return;
	
	new attacker = entity_get_edict(ent, EV_ENT_owner);
	new entlist[33];
	new numfound = find_sphere_class(ent, "player", 10.0, entlist, 32);
	
	for (new i=0; i < numfound; i++)
	{		
		new pid = entlist[i];
		
		if (!is_user_alive(pid) || get_user_team(attacker) == get_user_team(pid))
			continue;
		
		//new hp = get_user_health(pid)
		
		//ExecuteHam(Ham_TakeDamage, pid, ent, attacker, float(hp), 1);
		UTIL_Kill(attacker,pid,"world")
	}
	remove_entity(ent);
}
/* ==================================================================================================== */

public prethink_chest(id)
{
	if(!task_exists(id+TASK_ID))
		return;
	if (player_b_chest[id] > 0)
	{
		if(pev(id, pev_button) & (IN_MOVELEFT+IN_MOVERIGHT+IN_FORWARD+IN_BACK+IN_JUMP+IN_DUCK))
		{
			new Float:secfloatchest = float(player_b_chest[id])
			
			change_task(id+TASK_ID, secfloatchest);
			set_task(secfloatchest, "chestaddhp", id);
			message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id ) 
			write_short(player_b_chest[id])
			message_end()
		}
	}
}
public chestaddhp(id)
{
	id -= TASK_ID;
	
	if(!is_user_connected(id)) return;
	
	new cur_health = get_user_health(id);
	new max_health = player_rs_health[id];
	new new_health = cur_health+5<max_health? cur_health+5: max_health;
	if (player_b_chest[id] > 0)
		set_user_health(id, new_health);
	CurWeapon(id);
}
public chestcurwep(id)
{
	if((get_user_weapon(id) == CSW_KNIFE) && (get_user_health(id) < player_rs_health[id]))
	{
		new Float:secfloatchest = float(player_b_chest[id])
		set_task(secfloatchest, "chestaddhp", id+TASK_ID);
		message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id ) 
		write_short(player_b_chest[id])
		message_end()
	}
	else
	{
		remove_task(id+TASK_ID);
		message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id ) 
		write_short(0)
		message_end()
	}
}
/* ==================================================================================================== */

public fastfirenow(id)
{
	new iEnt;
	
	static Float:fSpeedMultiplier;
	
	fSpeedMultiplier = floatdiv(1.0, 1.0+(float(player_b_pennant[id])/100.0));
	
	for (new i = 1; i < sizeof nazwyweponow; i++)
	{
		iEnt = fm_find_ent_by_owner(-1, nazwyweponow[i], id)
		
		if(iEnt)
		{
			set_pdata_float( iEnt, 46, ( get_pdata_float(iEnt, 46, 4) * fSpeedMultiplier), 4 );
			set_pdata_float( iEnt, 47, ( get_pdata_float(iEnt, 47, 4) * fSpeedMultiplier), 4 );
		}
	}
	return PLUGIN_CONTINUE;
	
}
/* ==================================================================================================== */

public SkillloadAcid(id)
{
	if(!is_user_alive(id))
		return;
	
	static iButton; iButton = pev(id, pev_button)
	static iOldButton; iOldButton = pev(id, pev_oldbuttons)
	
	if (used_item[id])
	{
		hudmsg(id,2.0,"Pole mozesz uzyc raz na runde")
	}
	else
	{
		if( ( iButton & IN_USE ) && !( iOldButton & IN_USE ) )
		{
			if(!is_user_alive(id))
				return;
			
			message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id ) 
			write_byte(2)
			write_byte(0)
			message_end()
			set_task(2.0, "blast_players", id+TASK_BARTIME)
		}
		
		if( iOldButton & IN_USE && !( iButton & IN_USE ) && is_user_alive(id))
			blast_stop(id)
		used_item[id] = true
	}
}
public blast_stop(id)
{
	message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id )
	write_byte(0)
	write_byte(0)
	message_end()
	
	remove_task(id+TASK_BARTIME)
	
}

public blast_players(id)
{
	id -= TASK_BARTIME
	
	new Float: iOrigin[3]
	pev(id, pev_origin, iOrigin)
	
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, iOrigin, 0)
	write_byte(TE_BEAMCYLINDER)
	engfunc(EngFunc_WriteCoord, iOrigin[0])
	engfunc(EngFunc_WriteCoord, iOrigin[1])
	engfunc(EngFunc_WriteCoord, iOrigin[2])
	engfunc(EngFunc_WriteCoord, iOrigin[0])
	engfunc(EngFunc_WriteCoord, iOrigin[1])
	engfunc(EngFunc_WriteCoord, iOrigin[2]+1500.0)
	write_short(sprite_white)
	write_byte(0)
	write_byte(0)
	write_byte(4)
	write_byte(60)
	write_byte(0)
	write_byte(random_num(15,255))
	write_byte(random_num(15,255))
	write_byte(random_num(15,255))
	write_byte(200)
	write_byte(0)
	message_end()
	
	static Ent, Float: originF[3]
	new Float:radiussacid = float(player_b_acid[id])
	
	while( (Ent = engfunc(EngFunc_FindEntityInSphere, Ent, iOrigin, radiussacid)) )
	{
		if( is_player(Ent) && Ent != id )
		{
			if (get_user_team(id) != get_user_team(Ent))
			{
				fm_set_user_health(Ent, pev(Ent, pev_health) - get_user_health(Ent)/2)
				
				pev(Ent, pev_origin, originF)
				
				originF[0] = (originF[0] - iOrigin[0]) * 10.0 
				originF[1] = (originF[1] - iOrigin[1]) * 10.0 
				originF[2] = (originF[2] - iOrigin[2]) + 500.0
				
				set_pev(Ent, pev_velocity, originF)
			}
		}
	}
	
	return PLUGIN_HANDLED;
}
/*stock fm_set_user_health(id, health)
{
	(health > 0) ? set_pev(id, pev_health, float(health)) : dllfunc(DLLFunc_ClientKill, id);
}*/
/* ==================================================================================================== */

public Fw_NadeThink(nade)
{
	if(pev_valid(nade) && grenade_type(nade) == 3)
	{
		set_pev(nade, pev_flags, FL_ONGROUND);
	}
}
stock grenade_type(index)
{
	new g_Class[9];
	
	pev(index, pev_classname, g_Class, charsmax(g_Class));
	
	if(!equal(g_Class, "grenade") || get_pdata_int(index, 96) & 1 << 8){
		return 0;
	}
	
	new g_Bits = get_pdata_int(index, 114);
	
	if(g_Bits & 1 << 0){
		return 1;
	}
	
	else if(!g_Bits){
		return 2;
	}
	
	else if(g_Bits & 1 << 1){
		return 3;
	}
	
	return 0;
}
public Fw_NadeModel(nade, NadeModel[])
{
if(pev_valid(nade)){
	new g_Nade = grenade_type(nade);
	
	new id = pev(nade,pev_owner);
	new Float:numczas = float(player_b_sack[id])
	
	if(g_Nade && is_user_connected(id) && numczas > 0)
	{
		switch(g_Nade)
		{
			case 1: set_pev(nade, pev_dmgtime, get_gametime() + numczas);
				
			}
		}
	}
}
/* ==================================================================================================== */

public FwdAddToFullPack(es_handle, e, ent, host, hostflags, player, pSet)
{
	if(!is_user_connected(host))
		return;
	
	if(!player_b_harpsichord[host])
		return;
	
	if(!pev_valid(ent))
		return;
	
	new classname[5];
	pev(ent, pev_classname, classname, 4);
	if(equal(classname, "mine"))
	{
		set_es(es_handle, ES_RenderMode, kRenderTransAdd);
		set_es(es_handle, ES_RenderAmt, 255.0);
	}
	
}
/* ==================================================================================================== */

public piorun_black(id)
{
	set_lights("d")
	set_task(1.5,"piorun_normal")
}
public piorun_normal(id)
{
	set_lights("m")
}
public add_bonus_piorun(attacker_id,id)
{
	if (player_b_whitep[attacker_id] && (random_num(1, player_b_whitep[attacker_id]) == 1) && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{
		new Float:fl_Origin[3]
		pev(id, pev_origin, fl_Origin)  
		if(cs_get_user_team(attacker_id) == cs_get_user_team(id))
			return HAM_IGNORED
		
		set_pev(id, pev_velocity, Float:{0.0,0.0,0.0}) // stop motion
		set_pev(id, pev_maxspeed, 2.0) // prevent from moving
		
		thunder_effects(fl_Origin)
		ExecuteHam(Ham_TakeDamage, id, attacker_id, attacker_id, 55.0, 1);
		emit_sound(0 ,CHAN_ITEM, "ambience/thunder_clap.wav", 1.0, ATTN_NORM, 0, PITCH_NORM);
		set_lights("z")
		set_task(0.5,"piorun_black")
	}
	return PLUGIN_HANDLED
}
thunder_effects(Float:fl_Origin[3])
{
	new Float:fX = fl_Origin[0], Float:fY = fl_Origin[1], Float:fZ = fl_Origin[2]

	// Beam effect between two points
	engfunc(EngFunc_MessageBegin, MSG_BROADCAST, SVC_TEMPENTITY, fl_Origin, 0)
	write_byte(TE_BEAMPOINTS)               // 0
	engfunc(EngFunc_WriteCoord, fX + 150.0) // start position
	engfunc(EngFunc_WriteCoord, fY + 150.0)
	engfunc(EngFunc_WriteCoord, fZ + 800.0)
	engfunc(EngFunc_WriteCoord, fX) // end position
	engfunc(EngFunc_WriteCoord, fY)
	engfunc(EngFunc_WriteCoord, fZ)
	write_short(sprite_lgt) // sprite index
	write_byte(1)                                   // starting frame
	write_byte(15)                                  // frame rate in 0.1's
	write_byte(10)                                  // life in 0.1's
	write_byte(80)                                  // line width in 0.1's
	write_byte(30)                                  // noise amplitude in 0.01's
	write_byte(255)                                 // red
	write_byte(255)                                 // green
	write_byte(255)                                 // blue
	write_byte(255)                                 // brightness
	write_byte(200)                                 // scroll speed in 0.1's
	message_end()

	// Sparks
	message_begin(MSG_PVS, SVC_TEMPENTITY)
	write_byte(TE_SPARKS)                   // 9
	engfunc(EngFunc_WriteCoord, fX) // position
	engfunc(EngFunc_WriteCoord, fY)
	engfunc(EngFunc_WriteCoord, fZ + 10.0)
	message_end()

	// Smoke
	engfunc(EngFunc_MessageBegin, MSG_BROADCAST, SVC_TEMPENTITY, fl_Origin, 0)
	write_byte(TE_SMOKE)                    // 5
	engfunc(EngFunc_WriteCoord, fX) // position
	engfunc(EngFunc_WriteCoord, fY)
	engfunc(EngFunc_WriteCoord, fZ + 10.0)
	write_short(sprite_smoke)               // sprite index
	write_byte(10)                                  // scale in 0.1's
	write_byte(10)                                  // framerate
	message_end()

	// Blood
	engfunc(EngFunc_MessageBegin, MSG_BROADCAST, SVC_TEMPENTITY, fl_Origin, 0)
	write_byte(TE_LAVASPLASH)               // 10
	engfunc(EngFunc_WriteCoord, fX) // position
	engfunc(EngFunc_WriteCoord, fY)
	engfunc(EngFunc_WriteCoord, fZ + 12.0)
	message_end()
}
/* ==================================================================================================== */

stock bool:userShift(id){
return ( pev(id,pev_gaitsequence) == 3);
}
/* ==================================================================================================== */

public add_item_autoshoot(id)
{
if(player_b_autoshoot[id] > 0)
{
	new param[2] 
	param[0] = id
	auto[id] = 1
	set_task (0.5,"autoshoot",0,param,1,"b")
}

}
public autoshoot(param[]) 
{ 
	new id = param[0] 
	if(player_b_autoshoot[id] ==1)
	{
		new target,body
		get_user_aiming(id,target,body)
		//client_print(id,print_chat,"%d %d %s",hzone[target], body, body)
		
		if(get_user_team(id) != get_user_team(target)){
			if (get_user_team(target)==1 || get_user_team(target)==2)
			{
				//client_print(id,print_chat,"%d",body)
				if(get_cvar_num("sv_head")==1 && body == 1&& is_user_alive(id)==1)
					client_cmd(id,"+attack;wait;-attack")
				if(get_cvar_num("sv_head")==0 && is_user_alive(id)==1)
					client_cmd(id,"+attack;wait;-attack")
			}
		}
	}	
	return PLUGIN_CONTINUE
}
/* ==================================================================================================== */

public hatcheditem(this, idinflictor, idattacker, Float:damage, damagebits)
{
	if( !is_user_connected( idattacker ) )
		return HAM_IGNORED;
	
	if (damagebits&(1<<1) && player_b_hatched[this] > 0)
	{
		SetHamParamEntity(1, idattacker);
		SetHamParamEntity(2,this );
		SetHamParamEntity(3,this );
		player_b_hatched[this]--;
		return HAM_HANDLED;
	}
	if ((get_user_team(idattacker) != get_user_team(this)) && player_b_loaf[idattacker] > 0 && get_user_weapon(idattacker) == CSW_KNIFE)
		func_ExecuteSonic(idattacker)
	
	if (player_b_blackpearl[idattacker] > 0)
	{
		new ents[1];
		new Float:pearlfloatowany = float(player_b_blackpearl[idattacker])
		find_sphere_class( idattacker, "player", pearlfloatowany, ents, 1 );
		if( !is_user_alive( ents[0] ) )
			return HAM_IGNORED;
		
		ExecuteHam(Ham_TakeDamage, this, idinflictor, idattacker, damage+random_float(5.0,20.0), 1);
		
		return HAM_HANDLED;
	}
	
	return HAM_IGNORED;
}

/* ==================================================================================================== */
public fw_traceline(Float:vector_start[3], Float:vector_end[3], ignored_monster, id, handle)
{
	if (!is_user_alive(id))
		return FMRES_IGNORED;
	
	if (get_user_weapon(id) != CSW_KNIFE)
		return FMRES_IGNORED;
	
	new Float:numknifedclass = float(800)+player_intelligence[id]*1.5+player_powerint[id]*1.5
	new Float:numodleglosc = float(player_b_commemorative[id]+player_intelligence[id]+player_powerint[id])
	
	pev(id, pev_v_angle, vector_end)
	angle_vector(vector_end, ANGLEVECTOR_FORWARD, vector_end)
	
	if (player_class[id] == MEFISTO) xs_vec_mul_scalar(vector_end, numknifedclass, vector_end)
	if (player_b_commemorative[id] > 0) xs_vec_mul_scalar(vector_end, numodleglosc, vector_end)
	
	xs_vec_add(vector_start, vector_end, vector_end)
	engfunc(EngFunc_TraceLine, vector_start, vector_end, ignored_monster, id, handle)
	
	return FMRES_SUPERCEDE;
}
	
stock create_velocity_vector(victim,attacker,Float:velocity[3])
{
	new Float:vicorigin[3];
	new Float:attorigin[3];
	entity_get_vector(victim   , EV_VEC_origin , vicorigin);
	entity_get_vector(attacker , EV_VEC_origin , attorigin);
	
	new Float:origin2[3]
	origin2[0] = vicorigin[0] - attorigin[0];
	origin2[1] = vicorigin[1] - attorigin[1];
	
	new Float:largestnum = 0.0;
	
	if(floatabs(origin2[0])>largestnum) largestnum = floatabs(origin2[0]);
	if(floatabs(origin2[1])>largestnum) largestnum = floatabs(origin2[1]);
	
	origin2[0] /= largestnum;
	origin2[1] /= largestnum;
	
	velocity[0] = ( origin2[0] * (20.0 * 3000) ) / get_entity_distance(victim , attacker);
	velocity[1] = ( origin2[1] * (20.0 * 3000) ) / get_entity_distance(victim , attacker);
	if(velocity[0] <= 20.0 || velocity[1] <= 20.0)
		velocity[2] = random_float(200.0 , 275.0);
	
	return 1;
}

/* ==================================================================================================== */

public make_tracer(id)
{
	new clip,ammo
	new wpnid = get_user_weapon(id,clip,ammo)
	new pteam[16]
	
	new buttons = pev(id, pev_button)
	new oldbuttons = pev(id, pev_oldbuttons)
	
	get_user_team(id, pteam, 15)
	
	if ((bullets[id] > clip) && (wpnid == CSW_SCOUT) && (player_b_conjurg[id] > 0) && (get_user_button(id) & IN_ATTACK))
	{
		new vec1[3], vec2[3]
		get_user_origin(id, vec1, 1) // origin; your camera point.
		get_user_origin(id, vec2, 4) // termina; where your bullet goes (4 is cs-only)
		
		
		//BEAMENTPOINTS
		message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
		write_byte (0)     //TE_BEAMENTPOINTS 0
		write_coord(vec1[0])
		write_coord(vec1[1])
		write_coord(vec1[2])
		write_coord(vec2[0])
		write_coord(vec2[1])
		write_coord(vec2[2])
		write_short( sprite_line )
		write_byte(0)
		write_byte(1)
		write_byte(3)
		write_byte(10)	//WITD
		write_byte(60)
		write_byte(250)
		write_byte(0)
		write_byte(0)
		write_byte(100)	//BRIGT
		write_byte(80)
		message_end()
		
	}
	if(buttons & IN_ATTACK || oldbuttons & IN_ATTACK)
	{
		if (player_b_silver[id] > 0) 
		{
			
			static Origin[3], Origin2[3]
			get_user_origin(id, Origin, 1) 
			get_user_origin(id, Origin2, 4) 
			
			message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
			write_byte (0)     
			write_coord(Origin[0])
			write_coord(Origin[1])
			write_coord(Origin[2])
			write_coord(Origin2[0])
			write_coord(Origin2[1])
			write_coord(Origin2[2])
			write_short(sprite_line)
			write_byte(1) 
			write_byte(5) 
			write_byte(2) 
			write_byte(10) 
			write_byte(0) 
			write_byte(132)     
			write_byte(132)       
			write_byte(132)
			write_byte(200) 
			write_byte(150) 
			message_end()
			
			player_b_silver[id]--
		}
	}
	if(player_b_silver[id] <= 0) player_b_silver[id] = 0
	bullets[id] = clip
}
/* ==================================================================================================== */
public menu_3d(id)
{
	new menu = menu_create("\yWidok\w:", "treeperson")
	menu_additem(menu, "\rWlacz widok \w3\yD \rPerson")
	menu_additem(menu, "\yWidok zza ramienia w ktorym trzymamy bron")
	menu_additem(menu, "\wNie wlaczaj widoku")
	menu_display(id, menu)
}
public treeperson(id, menu, item)
{
	switch(item)
	{
		case 0:    set_view ( id, CAMERA_3RDPERSON  ) 
			case 1: set_view ( id, CAMERA_UPLEFT  ) 
			case 2: set_view ( id, CAMERA_NONE  ) 
		}
}
/* ==================================================================================================== */
public event_curweapon_un(id)
{
	if(is_user_alive(id) && player_b_unlimited[id] > 0)
	{
		//Get and check weapon ID
		new weaponID= read_data(2)
		if(weaponID==CSW_C4 || weaponID==CSW_KNIFE || weaponID==CSW_HEGRENADE || weaponID==CSW_SMOKEGRENADE || weaponID==CSW_FLASHBANG)
			return PLUGIN_CONTINUE;
		
		if(cs_get_user_bpammo(id, weaponID)!=CSW_MAXAMMO[weaponID])
			cs_set_user_bpammo(id, weaponID, CSW_MAXAMMO[weaponID])
	}
	return PLUGIN_CONTINUE;
}
/* ==================================================================================================== */
public fastfire(id, uc_handle)
{
	if(player_b_fasthand[id] > 0 )
	{
		
		new buttons = get_uc(uc_handle, UC_Buttons);
		new oldbuttons = pev(id, pev_oldbuttons);
		new clip, ammo, weapon = get_user_weapon(id, clip, ammo);
		
		if(maxClip[weapon] == -1 || !ammo)
			return PLUGIN_CONTINUE;
		
		if((buttons & IN_RELOAD && !(oldbuttons & IN_RELOAD) && !(buttons & IN_ATTACK)) || !clip)
		{
			cs_set_user_bpammo(id, weapon, ammo-(maxClip[weapon]-clip));
			new new_ammo = (maxClip[weapon] > ammo)? clip+ammo: maxClip[weapon]
			set_user_clip(id, new_ammo);
		}
	}
	if(player_b_xylophone[id] && get_uc(uc_handle, UC_Buttons) & IN_ATTACK)
	{
		new Float:punchangle[3]
		pev(id, pev_punchangle, punchangle)
		for(new i=0; i<3;i++) 
			punchangle[i]*=0.9;
		set_pev(id, pev_punchangle, punchangle)
	}
	return PLUGIN_HANDLED;
}
stock set_user_clip(id, ammo)
{
	new weaponname[32], weaponid = -1, weapon = get_user_weapon(id, _, _);
	get_weaponname(weapon, weaponname, 31);
	while ((weaponid = engfunc(EngFunc_FindEntityByString, weaponid, "classname", weaponname)) != 0)
		if (pev(weaponid, pev_owner) == id) 
	{
		set_pdata_int(weaponid, 51, ammo, 4);
		return weaponid;
	}
	return 0;
}
/* ==================================================================================================== */
public fwCmdStart_MultiJump(id, uc_handle)
{
	if(!is_user_alive(id) || !player_b_air[id])
		return FMRES_IGNORED;
	
	new flags = pev(id, pev_flags);
	
	if((get_uc(uc_handle, UC_Buttons) & IN_JUMP) && !(flags & FL_ONGROUND) && !(pev(id, pev_oldbuttons) & IN_JUMP) && jumpppp[id])
	{
		jumpppp[id]--;
		new Float:velocity[3];
		pev(id, pev_velocity,velocity);
		velocity[2] = random_float(265.0,285.0);
		set_pev(id, pev_velocity,velocity);
	}
	else if(flags & FL_ONGROUND)
		jumpppp[id] = -1;
	
	return FMRES_IGNORED;
}
/* ==================================================================================================== */
public UpdateClientData(id, sw, cd_handle)
{
	if(player_b_celnosc[id])
		set_cd(cd_handle, CD_PunchAngle, {0.0,0.0,0.0})   
}
/* ==================================================================================================== */
public messageScreenFade(msgId, msgType, id)
{
	if(player_b_nightsight[id] != 1) 
		return PLUGIN_CONTINUE;  
	
	if(get_msg_arg_int(4) == 255 && get_msg_arg_int(5) == 255 && get_msg_arg_int(6) == 255 && get_msg_arg_int(7) > 199)
		return PLUGIN_HANDLED;
	
	return PLUGIN_CONTINUE;
}
/* ==================================================================================================== */

public add_item_course_yy(id)
{
	id -= TASK_SHADOW;
	
	if(!is_user_connected(id))
		return PLUGIN_CONTINUE;
	
	if(player_b_course[id])
	{
		set_task(10.0, "add_item_course_yy", id+TASK_SHADOW);
		give_item(id, "weapon_hegrenade");
	}
	
	return PLUGIN_CONTINUE;
}
/* ==================================================================================================== */
public changeskin(id,reset)
{
	if (!is_user_connected(id))
		return PLUGIN_CONTINUE;
	
	if (reset)
		cs_reset_user_model(id);
	else
	{
		new num = random_num(0,3);
		
		cs_set_user_model(id, (get_user_team(id) == 1)? CT_Skins[num]: Terro_Skins[num]);
	}
	
	return PLUGIN_CONTINUE;
}
/* ==================================================================================================== */
public radar_scan() 
{
	for(new id=1; id<=MAX; id++) {
		if(!is_user_alive(id) || !player_b_radar[id]) continue;
		
		for(new i=1; i<=MAX; i++) {
			if(!is_user_alive(i) || id == i || get_user_team(id) == get_user_team(i)) continue;
			
			new PlayerCoords[3];
			get_user_origin(i, PlayerCoords);
			
			message_begin(MSG_ONE_UNRELIABLE, g_msgHostageAdd, _, id);
			write_byte(id);
			write_byte(i);
			write_coord(PlayerCoords[0]);
			write_coord(PlayerCoords[1]);
			write_coord(PlayerCoords[2]);
			message_end();
			
			message_begin(MSG_ONE_UNRELIABLE, g_msgHostageDel, _, id);
			write_byte(i);
			message_end();
		}
	}
}
/* ==================================================================================================== */
public add_bonus_shake(attacker_id,id)
{
	if(player_b_shake[attacker_id] > 0||c_shake[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && is_user_alive(id)) 
	{
		if (random_num(1,player_b_shake[attacker_id]) == 1)
		{
			message_begin(MSG_ONE,get_user_msgid("ScreenShake"),{0,0,0},id); 
			write_short(7<<14); 
			write_short(1<<13); 
			write_short(1<<14); 
			message_end();
		}
		else if (random_num(1,c_shake[attacker_id]) == 1)
		{
			message_begin(MSG_ONE,get_user_msgid("ScreenShake"),{0,0,0},id); 
			write_short(7<<14); 
			write_short(1<<13); 
			write_short(1<<14); 
			message_end();
		}
	}
	return PLUGIN_HANDLED
}
/* ==================================================================================================== */
public Event_CurWeapon_Snipers(id)
{
	if( player_b_crosshair[id] > 0 )
	{
		static iMsgCrosshair
		if( iMsgCrosshair || ( iMsgCrosshair = get_user_msgid("Crosshair") ) )
		{
			message_begin(MSG_ONE_UNRELIABLE, iMsgCrosshair, _, id);
			write_byte(1);
			message_end();
		}
	}
}
/* ==================================================================================================== */
public add_bonus_slap(attacker_id,id)
{
	if(player_item_id[attacker_id] == 70 && (random_num(1,player_b_feeblemind[id]) == 1) && get_user_team(attacker_id) != get_user_team(id)){
		user_slap(id, player_powerslap[id], 1)
	}
	
}
public hedamage_event(attacker_id,id,weapon) 
{
	if (player_b_jumphe[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && weapon == CSW_HEGRENADE)
	{
		new MAXPLAYERS
		MAXPLAYERS = get_maxplayers()
		
		new inflictor = entity_get_edict(id, EV_ENT_dmg_inflictor)
		if (inflictor <= MAXPLAYERS)
			return PLUGIN_CONTINUE
		
		new classname2[8]
		entity_get_string(inflictor, EV_SZ_classname, classname2, 7)
		if (!equal(classname2, "grenade"))
			return PLUGIN_CONTINUE
		
		new Float:upVector[3]
		upVector[0] = float(read_data(4))
		upVector[1] = float(read_data(5))
		upVector[2] = float(read_data(6))
		
		new Float:push = float(80)
		new damagerept = read_data(2)
		set_velocity_from_origin(id, upVector, push*damagerept)
	}
	return PLUGIN_CONTINUE
}
stock get_velocity_from_origin( ent, Float:fOrigin[3], Float:fSpeed, Float:fVelocity[3] )
{
	new Float:fEntOrigin[3];
	entity_get_vector( ent, EV_VEC_origin, fEntOrigin );
	
	// Velocity = Distance / Time
	
	new Float:fDistance[3];
	fDistance[0] = fEntOrigin[0] - fOrigin[0];
	fDistance[1] = fEntOrigin[1] - fOrigin[1];
	fDistance[2] = fEntOrigin[2] - fOrigin[2];
	
	new Float:fTime = ( vector_distance( fEntOrigin,fOrigin ) / fSpeed );
	
	fVelocity[0] = fDistance[0] / fTime;
	fVelocity[1] = fDistance[1] / fTime;
	fVelocity[2] = fDistance[2] / fTime;
	
	return ( fVelocity[0] && fVelocity[1] && fVelocity[2] );
}


// Sets velocity of an entity (ent) away from origin with speed (speed)

stock set_velocity_from_origin( ent, Float:fOrigin[3], Float:fSpeed )
{
	new Float:fVelocity[3];
	get_velocity_from_origin( ent, fOrigin, fSpeed, fVelocity )
	
	entity_set_vector( ent, EV_VEC_velocity, fVelocity );
	
	return ( 1 );
}

/* ==================================================================================================== */
public fwPrethink_AutoBH(id)
{
	if(!player_b_bunnyhop[id])
		return PLUGIN_CONTINUE
	
	if (pev(id, pev_button) & IN_JUMP) {
		new flags = pev(id, pev_flags)
		
		if (flags & FL_WATERJUMP)
			return FMRES_IGNORED;
		if ( pev(id, pev_waterlevel) >= 2 )
			return FMRES_IGNORED;
		if ( !(flags & FL_ONGROUND) )
			return FMRES_IGNORED;
		
		new Float:velocity[3];
		pev(id, pev_velocity, velocity);
		velocity[2] += 250.0;
		set_pev(id, pev_velocity, velocity);
		
		set_pev(id, pev_gaitsequence, 6);
		
	}
	return FMRES_IGNORED;
}
/* ==================================================================================================== */
public Damage_Wyrzucenie(id)
{
	new idattacker = get_user_attacker(id);
	
	if(!is_user_alive(idattacker))
		return;
	
	if(!player_b_drop[idattacker])
		return;
	
	if(random_num(1, player_b_drop[id]) != 1)
		return;
	
	client_cmd(id, "drop");
}
/* ==================================================================================================== */
public spawn_to_enemy(id)
{
	if(!is_user_alive(id))
		return;
		
	menu_destroy(id)
	
	if(!player_b_chance_spawn[id])
		return;
	
	if(random_num(1,player_b_chance_spawn[id]) == 1)
	{
		client_print(id, print_center, "Zrespiles sie u przeciwnika!")
		new CsTeams:team = cs_get_user_team(id);
		
		cs_set_user_team(id, (team == CS_TEAM_CT)? CS_TEAM_T: CS_TEAM_CT);
		ExecuteHam(Ham_CS_RoundRespawn, id);
		
		cs_set_user_team(id, team);
	}
}
/* ==================================================================================================== */
public TraceLine(Float:start[3], Float:end[3], conditions, id, trace)
{ 
	if(get_tr2(trace, TR_iHitgroup) != HIT_HEAD)
		return FMRES_IGNORED;
	
	new iHit = get_tr2(trace, TR_pHit);
	
	if(!is_user_connected(iHit))
		return FMRES_IGNORED;
	
	if(!player_b_hsprotection[iHit])
		return FMRES_IGNORED;
	
	set_tr2(trace, TR_iHitgroup, 8);
	
	return FMRES_IGNORED;
}
/* ==================================================================================================== */

public Explode_Origin(id,Float:origin[3],damage,dist)
{
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(3)
	write_coord(floatround(origin[0]))
	write_coord(floatround(origin[1]))
	write_coord(floatround(origin[2]))
	write_short(sprite_boom)
	write_byte(50)
	write_byte(15)
	write_byte(0)
	message_end()
	
	new Players[32], playerCount, a
	get_players(Players, playerCount, "ah") 
	
	for (new i=0; i<playerCount; i++) 
	{
		a = Players[i] 
		
		new Float:aOrigin[3]
		pev(a,pev_origin,aOrigin)
		
		if (get_user_team(id) != get_user_team(a) && get_distance_f(aOrigin,origin) < dist+0.0)
		{
			new dam = damage-player_dextery[a]*2
			
			if (get_user_health(a)-dam < 5)
				UTIL_Kill(id,a,"grenade")
			else
			{
				set_user_health(a,get_user_health(a)-dam)
				Effect_Bleed(a,248)
			}
			
		}
		
	}
}

/* ==================================================================================================== */

public Timed_Healing()
{
	new Players[32], playerCount, a
	get_players(Players, playerCount, "ah") 
	
	for (new i=0; i<playerCount; i++) 
	{
		a = Players[i] 
		if (player_b_heal[a] <= 0)
			continue
		
		if (get_user_health(a)+player_b_heal[a] <= 100+player_strength[a]*2)
			set_user_health(a,get_user_health(a) + player_b_heal[a])
		else 
			set_user_health(a,100+player_strength[a]*2)
	}
}


/* ==================================================================================================== */

public Timed_Ghost_Check(id)
{
	if (ghost_check == true)
	{	
		new Globaltime = floatround(halflife_time())
		
		new Players[32], playerCount, a
		get_players(Players, playerCount, "h") 
		
		for (new i=0; i<playerCount; i++) 
		{
			a = Players[i] 
			
			if (ghoststate[a] == 2 && Globaltime - player_b_ghost[a] > ghosttime[a])
			{
				ghoststate[a] = 3
				ghosttime[a] = 0
				set_user_noclip(a,0)
				ghost_check = false
				new Float:aOrigin[3]
				entity_get_vector(a,EV_VEC_origin,aOrigin)	
				
				if (PointContents (aOrigin) != -1)
				{
					user_kill(a,1)	
				}
				else
				{
					aOrigin[2]+=10
					entity_set_vector(a,EV_VEC_origin,aOrigin)
				}
				
				
				
			}
			
		}
		
	}
}

public reset_item_skills(id)
{
	if(player_b_person[id] > 0)
	{
		player_b_person[id] = 0	//3D Perosn
		set_view(id, CAMERA_NONE)
	}
	player_b_vampire[id] = 0		//Vampyric damage
	player_b_damage[id] = 0		//Bonus damage
	player_b_money[id] = 0		//Money bonus
	player_b_gravity[id] = 0		//Gravity bonus : 1 = best
	player_b_inv[id] = 0		//Invisibility bonus
	player_b_grenade[id] = 0		//Grenade bonus = 1/chance to kill
	player_b_reduceH[id] = 0		//Reduces player health each round start
	player_b_theif[id] = 0		//Amount of money to steal
	player_b_respawn[id] = 0		//Chance to respawn upon death
	player_b_explode[id] = 0		//Radius to explode upon death
	player_b_heal[id] = 0		//Ammount of hp to heal each 5 second
	player_b_blind[id] = 0		//Chance 1/Value to blind the enemy
	player_b_fireshield[id] = 0	//Protects against explode and grenade bonus 
	player_b_meekstone[id] = 0	//Ability to lay a fake c4 and detonate 
	player_b_teamheal[id] = 0		//How many hp to heal when shooting a teammate 
	player_b_redirect[id] = 0		//How much damage will the player redirect 
	player_b_fireball[id] = 0		//Ability to shot off a fireball value = radius *
	player_b_ghost[id] = 0		//Ability to walk through walls
	player_b_eye[id] = 0		//Ability to snarkattack
	player_b_blink[id] = 0		//Abiliy to use railgun
	player_b_windwalk[id] = 0		//Ability to windwalk
	player_b_usingwind[id] = 0	//Is player using windwalk
	player_b_reverse[id] = 0
	player_b_froglegs[id] = 0
	player_b_silent[id] = 0
	player_b_dagon[id] = 0		//Abliity to nuke opponents
	player_b_sniper[id] = 0		//Ability to kill faster with scout
	player_b_jumpx[id] = 0
	player_b_smokehit[id] = 0
	player_b_extrastats[id] = 0
	player_b_firetotem[id] = 0
	player_b_hook[id] = 0
	player_b_darksteel[id] = 0
	player_b_illusionist[id] = 0
	player_b_mine[id] = 0 
	player_b_hsprotection[id] = 0	//Protection to kill HeadShoot
	player_b_refleksja[id] = 0	//Give 16000$
	player_b_polimorf[id] = 0		//Give HE, SMOKE, 2xFLASH
	player_b_chance_spawn[id] = 0	//chance to enemy spawn
	player_b_drop[id] = 0		//Drop weapon enemy
	player_b_bunnyhop[id] = 0		//bunnyhop item
	player_b_jumphe[id] = 0		// jump for he
	player_b_stone[id] = 0		//none
	player_b_feeblemind[id] = 0	//Slap to attack enemy
	player_powerslap[id] = 0		//power slap
	player_b_aspeed[id] = 0		//speed
	player_b_c4[id] = 0		//item tihngpcka
	player_b_crosshair[id] = 0    	//Crosshair to all snipers
	player_b_grav[id] = 0           		//Gravity change
	player_b_shake[id] = 0		//Shakeee
	player_b_radar[id] = 0		//Radar
	player_b_pozornosc[id] = 0	//Skin
	player_b_course[id] = 0	      	//Course
	player_b_nightsight[id] = 0  	//No flash
	player_b_celnosc[id] = 0     	//No Recoil
	player_b_air[id] = 0        		//Jump+Jump+Jump+Jump+Jump infinitely many
	player_b_awp[id] = 0		//Instant Kill With AWP
	player_b_fasthand[id] = 0   	//Fast Reolad
	player_b_unlimited[id] = 0  	//Unlimited ammo
	player_b_ak47m4[id] = 0		//Give ak47m4
	player_b_falling[id] = 0		//Fallllllll
	player_b_deagle[id] = 0		//1\x z Deagla
	player_b_giveawp[id] = 0		//give awp
	player_b_book[id] = 0		//Book expirence
	player_b_glock[id] = 0		//Ability to kill in 1/(this) to instant kill with glock\usp
	player_b_revea[id] = 0		//Invisible in duck
	player_b_spawnuse[id] = 0		//+USE to spawn
	player_b_hpplus[id] = 0		// +35 hp
	player_b_zonk[id] = 0		// Lost weapon, Bad weapon
	player_b_knife[id] = 0		//Ability to kill in 1/knifed with knife
	player_b_conjurg[id] = 0		//Lighting scout damage
	player_b_commemorative[id] = 0	//Looooong knifeee ;d and damage ;)
	player_b_altar[id] = 0		//Speed on knife
	player_b_hatched[id] = 0		//Off attack
	player_b_invknife[id] = 0   	//Inv on knife
	player_b_lake[id] = 0		//Lake Shit 
	player_b_autoshoot[id] = 0	//autoshooy
	player_b_whitep[id] = 0		//Lighting
	player_b_shift[id] = 0		//Ree
	player_b_harpsichord[id] = 0	//See mines, +hp
	player_b_sack[id] = 0		//Sack of f
	player_b_silver[id] = 0		//Silver Snake Venom
	player_b_acid[id] = 0		//Acid Slug, radiance
	player_b_justice[id] = 0		//2x exp,-50%hp
	player_b_horse[id] = 0		//Fireeee
	player_b_artifactr[id] =0 	//Atrifact Godmoode
	player_b_elecirtc[id] = 0		//Inv time
	player_b_anvil[id] = 0		//Anvil 2xHeal X Sek
	player_b_spittoon[id] = 0	//spittoon
	player_b_pennant[id] = 0		//Fast fire 
	player_b_chest[id] = 0		//healt knife
	player_b_mandrake[id] = 0	//Mandrake lighter
	player_b_juggernaut[id] = 0	//Widzenie niewidzialnych
	player_b_wizard[id] = 0		//50%- dmg
	player_b_oven[id] = 0		//Dmg+int 
	player_b_candelabra[id] = 0	//Gravity+1\2 scout
	player_b_jar[id] = 0		//Jaar+hp frag
	player_b_bookofprpoh[id] = 0	//Frags hp 
	player_b_bless[id] = 0      	//Bless for speed
	player_b_xylophone[id] = 0	//Xylophone'
	player_b_pitchfork[id] = 0	//Pitchfork
	player_b_halberd[id] = 0	//Halberd weapon knife enemy
	player_b_loaf[id] = 0		//Loaf knife damage plus
	player_b_inkwell[id] = 0	//M3 Gooood
	player_b_humility[id] = 0	//Godmode po smierci
	player_b_maul[id] = 0		//Bersek Hight View
	player_b_throwingaxe[id] = 0	//Knifee +INT
	player_b_runeofvalor[id] = 0	//Rune of Valor death oslepienie
	player_b_blackpearl[id] = 0	//Black pearl
	player_b_bloodmoss[id] = 0	//Bloood Moos 
	player_b_garlic[id] = 0		//Garlic 
	player_b_newmoon[id] = 0	//New mood 
	player_b_rebracer[id] = 0	//Resilient Bracer
	player_b_ashroudnecro[id] = 0	//A Necromancer Shroud
	player_b_toxic[id] = 0		//A Toxic Potion Of Virulent Rose Extract
	player_b_rose[id] = 0		//Virulent Rose Extract
	player_b_rosemoney[id] = 0	//How many money
	player_b_plasma[id] = 0		//plasma
	player_b_ninjaitem[id] = 0	//Ninja knife and inv
	player_b_essence[id] = 0	//Essence Of Achievement
	player_b_ecrucitrine[id] = 0	//Ecru Citrine
	player_b_scrapper[id] = 0	//Scrapper`s Compendium
	player_b_transcendence [id] =  0	//Scroll Of Transcendence
	player_b_commodity[id] = 0	//Commodity Deed Worth
	player_b_shard[id] = 0		//Skystone Shard
	player_b_instantxm1014[id] = 0	//Mesanna Roulette
	player_b_instantm4a1[id] = 0	//Instatnt M4
	player_b_instantak47[id] = 0	//ak47
	player_b_instantjuki[id] = 0	//Juka instant kill
	player_b_assignment[id] = 0	//jumpx and hp
	player_b_themagi[id] = 0	//The Magi
	player_b_blackrock[id] = 0	//Blackrock tmp uzi
	player_b_tome[id] = 0		//Wall block 
	
	juggernaut[id] = 0
	item_boosted[id] = 0
	item_durability[id] = 0		//Not holding an item
	jumps[id] = 0
	gravitytimer[id] = 0
	c_shake[id] = 0
	g_god[id] = 0
	g_killer[id] = 0
	has_commodity[id] = 1
	reset_player(id)
}
public reset_player(id)
{
	Display_Icon(id, 15,15,15 , "dmg_shock",0)
	remove_task(TASKID_REVIVE + id)
	remove_task(TASKID_RESPAWN + id)
	remove_task(TASKID_CHECKRE + id)
	remove_task(TASKID_CHECKST + id)
	remove_task(TASKID_ORIGIN + id)
	remove_task(TASKID_SETUSER + id)
	
	
	g_revive_delay[id] 	= 0.0
	g_wasducking[id] 	= false
	g_body_origin[id] 	= Float:{0.0, 0.0, 0.0}
}
/* ==================================================================================================== */

public auto_help(id)
{
	new rnd = random_num(1,5+player_lvl[id])
	if (rnd <= 5)
		set_hudmessage(0, 180, 0, -1.0, 0.70, 0, 10.0, 5.0, 0.1, 0.5, 11) 	
	if (rnd == 1)
		show_hudmessage(id, "Aby wyrzucic item napisz /dropitem lub zobaczyc informacje o nim /iteminfo")
	if (rnd == 2)
		show_hudmessage(id, "Specyficznych itemow mozesz uzywac klawiszem USE - domyslnie e")
	if (rnd == 3)
		show_hudmessage(id, "Aby uzysakc pomoc napisz /helpme")
	if (rnd == 4)
		show_hudmessage(id, "Zninduj klawisz do MENU dla uzywania diablo menu - jest to zalecane!")
	if (rnd == 5)
		show_hudmessage(id, "Czesc itemow mozna ulepszyc przez Runy. Napisz /rune aby zobaczyc dostepne runy")
}

/* ==================================================================================================== */

public helpme(id)
{	 
	showitem(id,"Helpmenu","Common","Brak","You gain items and xp by killing enemies, you can only gain an item if you're item slot is free<br><br>See what the item does by saying /iteminfo or drop it by saying /dropitem<br><br>Some items can be used with the USE button<br> Say /skills to see what attributes you have")
}

/* ==================================================================================================== */


/* ==================================================================================================== */

public showitem(id,itemname[],itemvalue[],itemeffect[],Durability[])
{
	new diabloDir[64]	
	new g_ItemFile[64]
	new amxbasedir[64]
	get_basedir(amxbasedir,63)
	
	format(diabloDir,63,"%s/diablo",amxbasedir)
	
	if (!dir_exists(diabloDir))
	{
		new errormsg[512]
		format(errormsg,511,"Error: The folder %s/diablo could not be found. Please copy this folder from the install package to the amxmodx folder",amxbasedir)
		show_motd(id, errormsg, "An error has occured")	
		return PLUGIN_HANDLED
	}
	
	
	format(g_ItemFile,63,"%s/diablo/item.txt",amxbasedir)
	if(file_exists(g_ItemFile))
		delete_file(g_ItemFile)
	
	new Data[768]
	
	//Header
	format(Data,767,"<html><head><title>Informacje o Itemie</title></head>")
	write_file(g_ItemFile,Data,-1)
	
	//Background
	format(Data,767,"<body text=^"#FFFF00^" bgcolor=^"#000000^">",Basepath)
	write_file(g_ItemFile,Data,-1)
	
	//Table stuff
	format(Data,767,"<table border=^"0^" cellpadding=^"0^" cellspacing=^"0^" style=^"border-collapse: collapse^" width=^"100%s^"><tr><td width=^"0^">","^%")
	write_file(g_ItemFile,Data,-1)
	
	//item name
	format(Data,767,"<td width=^"0^"><p align=^"center^"><font face=^"Arial^"><font color=^"#FFCC00^"><b>Item: </b>%s</font><br>",itemname)
	write_file(g_ItemFile,Data,-1)
	
	//item value
	format(Data,767,"<font color=^"#FFCC00^"><b><br>Wartosc: </b>%s</font><br>",itemvalue)
	write_file(g_ItemFile,Data,-1)
	
	//Durability
	format(Data,767,"<font color=^"#FFCC00^"><b><br>Wytrzymalosc: </b>%s</font><br><br>",Durability)
	write_file(g_ItemFile,Data,-1)
	
	//Effects
	format(Data,767,"<font color=^"#FFCC00^"><b>Efekt:</b> %s</font></font></td>",itemeffect)
	write_file(g_ItemFile,Data,-1)
	
	//end
	format(Data,767,"</tr></table></body></html>")
	write_file(g_ItemFile,Data,-1)
	
	//show window with message
	show_motd(id, g_ItemFile, "Informacje o Itemie")
	
	return PLUGIN_HANDLED
	
}


/* ==================================================================================================== */

public iteminfo(id)
{
	new itemvalue[100]
	
	if (player_item_id[id] <= 10) itemvalue = "Pospolity"
	if (player_item_id[id] <= 30) 
		itemvalue = "Rzakdi"
	else 
		itemvalue = "Szlachetny"
	
	if (player_item_id[id] > 42) itemvalue = "Antyk"
	if (player_item_id[id] > 80) itemvalue = "Magiczny"
	if (player_item_id[id] > 100) itemvalue = "Legendarny"
	
	new itemEffect[200]
	
	new TempSkill[11]					//There must be a smarter way
	
	if (player_b_vampire[id] > 0) 
	{
		num_to_str(player_b_vampire[id],TempSkill,10)
		add(itemEffect,199,"Kradnie ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," zycia po trafieniu w przeciwnika<br>")
	}
	if (player_b_damage[id] > 0) 
	{
		num_to_str(player_b_damage[id],TempSkill,10)
		add(itemEffect,199,"Zyskujesz ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," Dodatkowe obrazenia za kazdym razem gdy trafisz przeciwnika<br>")
	}
	if (player_b_money[id] > 0) 
	{
		num_to_str(player_b_money[id],TempSkill,10)
		add(itemEffect,199,"Dostajesz $")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," + intelligene*50 bonusu pienieznego w kazdej rundzie. Nacisnij E aby wlaczyc tarcze, ktora redukuje normalne obrazenia o 50%<br>")
	}
	if (player_b_gravity[id] > 0) 
	{
		num_to_str(player_b_gravity[id],TempSkill,10)
		add(itemEffect,199,"Grawitacja zredukowana do ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199,". Nacisnij E aby wykonac Aero Stapniecie w powietrzu. Obrazenia zaleza od odleglosci skoku i ilosci inteligencji<br>")
	}
	if (player_b_inv[id] > 0) 
	{
		num_to_str(player_b_inv[id],TempSkill,10)
		add(itemEffect,199,"Twoja widocznosc jest zredukowana z 255 do ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199,"<br>")
	}
	if (player_b_grenade[id] > 0) 
	{
		num_to_str(player_b_grenade[id],TempSkill,10)
		add(itemEffect,199,"Masz 1/")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," szans na natychmiastowe zabicie z HE<br>")
	}
	if (player_b_reduceH[id] > 0) 
	{
		num_to_str(player_b_reduceH[id],TempSkill,10)
		add(itemEffect,199,"Twoje zycie jest zredukowane o ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," w kazdej rundzie. Sila nie ma tu znaczenia<br>")
	}
	if (player_b_theif[id] > 0) 
	{
		num_to_str(player_b_theif[id],TempSkill,10)
		add(itemEffect,199,"Masz 1/7 szans ukrasc $")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," za kazdym razem gdy trafisz wroga. Mozesz uzyc do konwertowania 1000$ za 15 zycia<br>")
	}
	if (player_b_respawn[id] > 0) 
	{
		num_to_str(player_b_respawn[id],TempSkill,10)
		add(itemEffect,199,"Masz 1/")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," na respawn po smieci<br>")
	}
	if (player_b_explode[id] > 0) 
	{
		num_to_str(player_b_explode[id],TempSkill,10)
		add(itemEffect,199,"Kiedy zginiesz, eksplodujesz w promieniu ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," zadaje 75 obrazen wokol ciebie - inteligencja zwieksza zasieg explozji<br>")
	}
	if (player_b_heal[id] > 0) 
	{
		num_to_str(player_b_heal[id],TempSkill,10)
		add(itemEffect,199,"Zyskasz +")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," zycia co 5 sekund. Nacisnij E aby polozyc totem leczacy na 7 sekund<br>")
	}
	if (player_b_gamble[id] > 0) 
	{
		num_to_str(player_b_gamble[id],TempSkill,10)
		add(itemEffect,199,"Zyskasz losowa umiejetnosc na poczatek kazdej rundy 1/")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199,"<br>")
	}
	if (player_b_blind[id] > 0) 
	{
		num_to_str(player_b_blind[id],TempSkill,10)
		add(itemEffect,199,"Masz 1/")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," szans na oslepienie wroga po trafieniu go<br>")
	}
	if (player_b_fireshield[id] > 0) 
	{
		num_to_str(player_b_fireshield[id],TempSkill,10)
		add(itemEffect,199,"Nie mozesz byc zabity przez itemy<br>")
		add(itemEffect,199,"Nacisnij E aby spowolnic, uszkodzic albo oslepic wszystkich przeciwnikow wokol ciebie<br>")
	}
	if (player_b_meekstone[id] > 0) 
	{
		num_to_str(player_b_meekstone[id],TempSkill,10)
		add(itemEffect,199,"Mozesz polozyc falszywe C4, Aby polozyc nacisnij E aby zdetonowac ponownie E<br>")
	}
	if (player_b_teamheal[id] > 0) 
	{
		num_to_str(player_b_teamheal[id],TempSkill,10)
		add(itemEffect,199,"Nacisnij E aby wykonac tarcze na graczu.<br>")
		add(itemEffect,199," Wszysktie obrazenie zostaja odbite. Jesli zostaniesz zraniony umrzesz")
	}
	if (player_b_redirect[id] > 0) 
	{
		num_to_str(player_b_redirect[id],TempSkill,10)
		add(itemEffect,199,"Masz redukcje obrazen o ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," hp<br>")
	}
	if (player_b_fireball[id] > 0) 
	{
		num_to_str(player_b_fireball[id],TempSkill,10)
		add(itemEffect,199,"Nacisnij E aby rzucic ognista kula - Inteligencja wzmacnia moc kule. Zabije wszystkich w promieniu ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199,"<br>")
	}
	if (player_b_ghost[id] > 0) 
	{
		num_to_str(player_b_ghost[id],TempSkill,10)
		add(itemEffect,199,"Nacisnij E aby przechodzic przez sciany przez ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," sekund<br>")
	}
	if (player_b_eye[id] > 0) 
	{
		add(itemEffect,199,"Nacisnij E aby polozyc kamere, wlacz\wylacz ")
		
	}
	if (player_b_blink[id] > 0) 
	{
		add(itemEffect,199,"Mozesz znikac nozem. Inteligencja zwieksza zasieg migniecia nozem")
	}
	
	if (player_b_windwalk[id] > 0) 
	{
		num_to_str(player_b_windwalk[id],TempSkill,10)
		add(itemEffect,199,"Mozesz stac sie niewidzialny, w tym czasie nie mozesz atakowac. Czas niewidzialnosci ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," sekund.<br>")
	}
	
	if (player_b_reverse[id] > 0) 
	{
		num_to_str(player_b_reverse[id],TempSkill,10)
		add(itemEffect,199,"Masz 1/")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," szans na zmylenie przeciwnika po trafieniu go<br>")
	}
	if (player_b_froglegs[id] > 0)
	{
		add(itemEffect,199,"Przytrzymaj kucniecie aby wykonac longjump")
	}
	if (player_b_dagon[id] == 1)
	{
		add(itemEffect,199,"Nacisniej E aby wystrzelic magiczny piorun do najblizszego przeciwnika - mozesz ulepszyc ten item przez /rune")
		add(itemEffect,199,"Inteligencja zwieksza zasieg pioruna")
	}
	if (player_b_sniper[id] > 0) 
	{
		num_to_str(player_b_sniper[id],TempSkill,10)
		add(itemEffect,199,"Masz 1/")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," szans na natychmiastowe zabicie ze scout-a<br>")
	}
	if (player_b_jumpx[id] > 0)
	{
		num_to_str(player_b_jumpx[id],TempSkill,10)
		add(itemEffect,199,"Mozesz wykonac ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," dodatkowy skok w powietrzu(double jump)<br>")	
	}
	if (player_b_smokehit[id] > 0)
	{
		add(itemEffect,199,"Toje smoki zabijaja natychmiast gdy dotkna przeviwnika")
	}
	if (player_b_extrastats[id] > 0)
	{
		num_to_str(player_b_extrastats[id],TempSkill,10)
		add(itemEffect,199,"Zystujesz +")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," stat trzymajac ten przedniot")
	}
	if (player_b_firetotem[id] > 0)
	{
		num_to_str(player_b_firetotem[id],TempSkill,10)
		add(itemEffect,199,"Nacisnij E aby polozyc explodujacy totem ktory wybuchnie po 7 sekundach w promieniu ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," wybuchu od totemu")
	}
	if (player_b_hook[id] > 0)
	{
		num_to_str(player_b_hook[id],TempSkill,10)
		add(itemEffect,199,"Nacisnij E aby rzucic hakiem w zakresie 600 i przyciagnac do siebie. Im wiecej inteligecji tym szybszy hak")
	}
	if (player_b_darksteel[id] > 0)
	{		
		new ddam = floatround(player_strength[id]*2*player_b_darksteel[id]/10.0)*3
		
		num_to_str(player_b_darksteel[id],TempSkill,10)
		add(itemEffect,199,"Dostajesz 15 + 0.")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199,"*strength: ")
		num_to_str(ddam,TempSkill,10)
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," dodatkowych obrazen po trafieniu wroga od tylu ")
	}
	if (player_b_illusionist[id] > 0)
	{
		add(itemEffect,199,"Nacisnij E aby stac sie niewidzialnym na 7 sekund. Kazde obrazenia, w tym czasie zabijaja cie")
	}
	if (player_b_mine[id] > 0)
	{
		add(itemEffect,199,"Nacisnij E aby polozyc niewidzialna mine. Gdy przeciwnik wejdzie na nia zabiera mu 50hp+inteligencja obrazen. Masz 3 miny na runde")
	}
	if (player_b_hsprotection[id] > 0)
	{
		add(itemEffect, 199, "Nie mozna zabic cie head shootem<br>");
	}
	if (player_b_chance_spawn[id] > 0) 
	{
		num_to_str(player_b_chance_spawn[id],TempSkill,10)
		add(itemEffect,199,"Masz 1\")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," szans na respawn u przeciwnika<br>")
	}
	if (player_b_refleksja[id] > 0)
	{
		add(itemEffect, 199, "Dostajesz 16000 $ co runde<br>");
	}
	if (player_b_polimorf[id] > 0)
	{
		add(itemEffect, 199, "Dostajesz wszystkie granaty (HE, SMOKE, 2xFLASH)<br>");
	}
	if (player_b_drop[id] > 0)
	{
		num_to_str(player_b_drop[id],TempSkill,10)
		add(itemEffect,199,"Masz 1\")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," szans na wyrzucenie broni przeciwnika")
	}
	if (player_b_bunnyhop[id] > 0)
	{
		add(itemEffect, 199, "Mozesz wykonac Bunny Hop<br>");
	}
	if (player_b_jumphe[id] > 0) 
	{
		add(itemEffect, 199, "Twoje granaty HE odrzucaja<br>");
	}
	if (player_b_stone[id] > 0) 
	{
		add(itemEffect, 199, "Ten item nic nie daje, mozesz go wyrzucic<br>");
	}
	if (player_b_feeblemind[id] > 0) 
	{
		num_to_str(player_b_feeblemind[id],TempSkill,10)
		add(itemEffect,199,"Masz 1\")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," szans na slap przeciwnika z moca ")
		num_to_str(player_powerslap[id],TempSkill,10)
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," Hp<br>")
	}
	if (player_b_aspeed[id] > 0) 
	{
		num_to_str(player_b_aspeed[id],TempSkill,10)
		add(itemEffect,199,"Jestes szybszy o  ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," punktow<br>")
	}
	if (player_b_c4[id] > 0) 
	{
		add(itemEffect, 199, "Jesli jestes w TT dostajesz C4 a jesli w CT to DefuseKit<br>");
	}
	if (player_b_crosshair[id] > 0) 
	{
		add(itemEffect, 199, "Masz celownik przy wszystkich snajperkach<br>");
	}
	if (player_b_grav[id] > 0) 
	{
		num_to_str(player_b_grav[id],TempSkill,10)
		add(itemEffect,199,"Twoja grawitacja jest zredukowana do ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199,"<br>")
	}
	if (player_b_shake[id] > 0) 
	{
		num_to_str(player_b_shake[id],TempSkill,10)
		add(itemEffect,199,"Masz 1/")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," szans ze przciwnikowi zacznie sie trzesc ekran<br>")
	}
	if(player_b_radar[id] > 0)
	{ 
		add(itemEffect, 199, "Widzisz przeciwnikow na radarze.<br>");
	}
	if (player_b_pozornosc[id] > 0) 
	{ 
		add(itemEffect, 199, "Masz stroj przeciwnika<br>");
	}
	if (player_b_course[id] > 0)
	{
		add(itemEffect, 199, "Dostajesz HE Grenade co 10 sekund<br>");
	}
	if (player_b_nightsight[id] > 0)
	{
		add(itemEffect, 199, "Nie dzialaja na ciebie flahsbangi<br>");
	}
	if (player_b_celnosc[id] > 0)
	{
		add(itemEffect, 199, "Masz mniejszy rozrzut<br>");
	}
	if (player_b_air[id] > 0)
	{
		add(itemEffect, 199, "Masz nieskonczenie wiele podskokow w powietrzu<br>");
	}
	if (player_b_awp[id] > 0)
	{
		add(itemEffect, 199, "Masz natychmiastowe zabicie z AWP<br>");
	}
	if (player_b_fasthand[id] > 0)
	{
		add(itemEffect, 199, "Masz natychmiastowe przeladowanie broni<br>");
	}
	if (player_b_unlimited[id] > 0)
	{
		add(itemEffect, 199, "Masz nieskonczona amunicje<br>");
	}
	if (player_b_ak47m4[id] > 0)
	{
		add(itemEffect, 199, "Dostajesz AK47 i M4<br>");
	}
	if (player_b_falling[id] > 0)
	{
		add(itemEffect, 199, "Nie tracisz Hp spadajac z wysokosci<br>");
	}
	if (player_b_deagle[id] > 0) 
	{
		num_to_str(player_b_deagle[id],TempSkill,10)
		add(itemEffect,199,"Dostajesz Deagla i masz 1\ ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," na natychmiastowe zabicie z niego<br>")
	}
	if (player_b_giveawp[id] > 0)
	{
		add(itemEffect, 199, "Dostajesz AWP co runde<br>");
	}
	if (player_b_book[id] > 0) 
	{
		num_to_str(get_cvar_num("diablo_xpbonus"),TempSkill,10)
		add(itemEffect,199,"Dostajesz ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," doswiadczenia. Mozesz juz wyrzucic item<br>")
	}
	if (player_b_person[id] > 0)
	{
		add(itemEffect, 199, "Masz widok 3D Person<br>");
	}
	if (player_b_glock[id] > 0) 
	{
		num_to_str(player_b_glock[id],TempSkill,10)
		add(itemEffect,199,"Masz 1/")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," szans na natychmiastowe zabicie z Glock\Usp<br>")
	}
	if (player_b_revea[id] > 0) 
	{
		num_to_str(player_b_revea[id],TempSkill,10)
		add(itemEffect,199,"Gdy kucasz twoja widocznosc jest zredukowana do ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," <br>")
	}
	if (player_b_spawnuse[id] > 0)
	{
		add(itemEffect, 199, "Mozesz uzyc spawn-u kiedy chcesz. Nacisnij E kiedy bedziesz niezywy i chcesz sie odrodzic<br>");
	}
	if (player_b_hpplus[id] > 0) 
	{
		add(itemEffect, 199, "Dstajesz +35 HP<br>");
	}
	if (player_b_knife[id] > 0) 
	{
		num_to_str(player_b_knife[id],TempSkill,10)
		add(itemEffect,199,"Masz 1/")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," szans na natychmiastowe zabicie z noza<br>")
	}
	if (player_b_conjurg[id] > 0) 
	{
		num_to_str(player_b_conjurg[id],TempSkill,10)
		add(itemEffect,199,"Masz 1/")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," szans na natychmiastowe zabicie ze scouta<br>")
	}
	if (player_b_commemorative[id] > 0) 
	{
		num_to_str(player_b_commemorative[id],TempSkill,10)
		add(itemEffect,199,"Mozesz atakowac nozem na odleglosc ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," jednostek<br>")
	}
	if (player_b_altar[id] > 0)
	{
		add(itemEffect, 199, "Jestes szybki na nozu lecz nie mozesz w tym czasie atakowac<br>");
	}
	if (player_b_hatched[id] > 0) 
	{
		num_to_str(player_b_hatched[id],TempSkill,10)
		add(itemEffect,199,"Mozesz odbic ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," pociskow od swojego pancerza<br>")
	}
	if (player_b_invknife[id] > 0) 
	{
		num_to_str(player_b_invknife[id],TempSkill,10)
		add(itemEffect,199,"Twoja widocznosc jest zredukowana z 255 do ")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," gdy trzymasz noz<br>")
	}
	if (player_b_lake[id] > 0)
	{
		add(itemEffect, 199, "Gdy stoisz w miejscu nie widac Cie<br>");
	}
	if (player_b_autoshoot[id] > 0)
	{
		add(itemEffect, 199, "Automatycznie strzelasz do przeciwnikow<br>");
	}
	if (player_b_whitep[id] > 0)
	{
		num_to_str(player_b_whitep[id],TempSkill,10)
		add(itemEffect,699,"Masz 1/")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," szans ,zeby uderzyc we wroga piorunem<br>")
	}
	if (player_b_shift[id] > 0)
	{
		num_to_str(player_b_shift[id],TempSkill,10)
		add(itemEffect,699,"Twoja widocznosc jest zredukowana do ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," gdy trzymasz Shift<br>")
	}
	if (player_b_harpsichord[id] > 0)
	{
		num_to_str(player_b_harpsichord[id],TempSkill,10)
		add(itemEffect,699,"Widzisz miny, dostajesz +")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," HP<br>")
	}
	if (player_b_sack[id] > 0)
	{
		num_to_str(player_b_sack[id],TempSkill,10)
		add(itemEffect,699,"Twoje granaty wybuchaja z opuznieniem ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," sekund<br>")
	}
	if (player_b_silver[id] > 0)
	{
		num_to_str(player_b_silver[id],TempSkill,10)
		add(itemEffect,699,"Masz ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," srebrnych naboii zadajacych +15 obrazen<br>")
	}
	if (player_b_acid[id] > 0)
	{
		num_to_str(player_b_acid[id],TempSkill,10)
		add(itemEffect,699,"Masz pole magnetyczne. Nacisnij E aby uzyc. W promieniu ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," zabierze wrogom polowe hp<br>")
	}
	if (player_b_justice[id] > 0)
	{
		add(itemEffect, 199, "Tracisz polowe Hp, ale zdobywasz 2x wiecej doswiadczenia<br>");
	}
	if (player_b_horse[id] > 0)
	{
		num_to_str(player_b_horse[id],TempSkill,10)
		add(itemEffect,699,"Dostajesz ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," kamizelki ( Kevlar )<br>")
	}
	if (player_b_artifactr[id] > 0)
	{
		num_to_str(player_b_artifactr[id],TempSkill,10)
		add(itemEffect,699,"Masz ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," sekund niesmiertelnosci. Nacisnij E aby uzyc<br>")
	}
	if (player_b_elecirtc[id] > 0)
	{
		num_to_str(player_b_elecirtc[id],TempSkill,10)
		add(itemEffect,699,"Masz ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," sekund niewidzialnosci. Nacisnij E aby uzyc<br>")
	}
	if (player_b_anvil[id] > 0)
	{
		num_to_str(player_b_anvil[id],TempSkill,10)
		add(itemEffect,699,"Nacisnij E aby podwoic Hp na ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," sekund<br>")
	}
	if (player_b_spittoon[id] > 0)
	{
		num_to_str(player_b_spittoon[id],TempSkill,10)
		add(itemEffect,699,"Nacisnij E aby zmniejszyc grawitacje na ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," sekund<br>")
	}
	if (player_b_pennant[id] > 0)
	{
		num_to_str(player_b_pennant[id],TempSkill,10)
		add(itemEffect,699,"Zwieksza szybkostrzelnosc o ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," %<br>")
	}
	if (player_b_chest[id] > 0)
	{
		num_to_str(player_b_chest[id],TempSkill,10)
		add(itemEffect,699,"Mozesz sie leczyc na nozu, +5 HP co ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," sekund<br>")
	}
	if (player_b_mandrake[id] > 0)
	{
		num_to_str(player_b_mandrake[id],TempSkill,10)
		add(itemEffect,699,"Mozna Cie zabic tylko HeadShootem. Nacisnij E aby uzyc na ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," sekund<br>")
	}
	if (player_b_juggernaut[id] > 0)
	{
		num_to_str(player_b_juggernaut[id],TempSkill,10)
		add(itemEffect,699,"Widzisz niewidzialnych na ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," sekund. Nacisnij E aby uzyc<br>")
	}
	if (player_b_wizard[id] > 0)
	{
		add(itemEffect, 199, "Redukuje to obrazenia o 50%<br>");
	}
	if (player_b_oven[id] > 0)
	{
		num_to_str(player_b_oven[id],TempSkill,10)
		add(itemEffect,699,"Masz ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," dodatkowych obrazen + inteligencja<br>")
	}
	if (player_b_candelabra[id] > 0)
	{
		add(itemEffect, 199, "Masz 1\2 ze scout-a, zmniejszona grawitacja do 400<br>");
	}
	if (player_b_jar[id] > 0)
	{
		num_to_str(player_b_jar[id],TempSkill,10)
		add(itemEffect,699,"Masz ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," Hp za kazdego fraga<br>")
	}
	if (player_b_bookofprpoh[id] > 0)
	{
		num_to_str(player_b_bookofprpoh[id],TempSkill,10)
		add(itemEffect,699,"Masz ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," Hp za kazdego fraga i pelny magazynek<br>")
	}
	if (player_b_bless[id] > 0)
	{
		num_to_str(player_b_bless[id],TempSkill,10)
		add(itemEffect,699,"Mozesz 1\ ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," szans na spowolnienie przeciwnika<br>")
	}
	if (player_b_xylophone[id] > 0)
	{
		add(itemEffect, 199, "Dostajesz Ak47 i masz lekko ograniczony rozrzut<br>");
	}
	if (player_b_pitchfork[id] > 0)
	{
		num_to_str(player_b_pitchfork[id],TempSkill,10)
		add(itemEffect,699,"Nacisnij E aby oslepic przeciwnika w promieniu ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," jednostek +inteligencja<br>")
	}
	if (player_b_halberd[id] > 0)
	{
		num_to_str(player_b_halberd[id],TempSkill,10)
		add(itemEffect,699,"Nacisnij E aby zmienic bron przeciwnika przeciwnika na noz w promieniu ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," jednostek +inteligencja<br>")
	}
	if (player_b_loaf[id] > 0)
	{
		num_to_str(player_b_loaf[id],TempSkill,10)
		add(itemEffect,699,"Masz mocny noz, masz natychmiastowe zabicie z niego i w promieniu ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," zabije to tez wrogow<br>")
	}
	if (player_b_inkwell[id] > 0)
	{
		add(itemEffect, 199, "Strzerasz 8 pociskow za jednym razem z M3<br>");
	}
	if (player_b_humility[id] > 0)
	{
		num_to_str(player_b_humility[id],TempSkill,10)
		add(itemEffect,699,"Giniesz po ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," sekundach od faktycznego zabojstwa<br>")
	}
	if (player_b_maul[id] > 0)
	{
		add(itemEffect, 199, "Jestes wysoki (Widzisz wyzej)<br>");
	}
	if (player_b_throwingaxe[id] > 0)
	{
		add(itemEffect, 199, "Masz Dragontail<br>");
	}
	if (player_b_runeofvalor[id] > 0)
	{
		num_to_str(player_b_runeofvalor[id],TempSkill,10)
		add(itemEffect,699,"Po smierci oslepiasz przeciwnikow w promieniu ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," jednostek<br>")
	}
	if (player_b_blackpearl[id] > 0)
	{
		num_to_str(player_b_blackpearl[id],TempSkill,10)
		add(itemEffect,699,"Gdy jestes w promieniu ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," jednostek od przyjaciela z druyzny, zadajesz losowo wieksze obrazenia<br>")
	}
	if (player_b_bloodmoss[id] > 0)
	{
		num_to_str(player_b_bloodmoss[id],TempSkill,10)
		add(itemEffect,699,"Masz 1\ ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," szans na otrucie przeciwnika na 8 sekund<br>")
	}
	if (player_b_garlic[id] > 0)
	{
		num_to_str(player_b_garlic[id],TempSkill,10)
		add(itemEffect,699,"Gdy zabijesz przeciwnika twoj team dostaje +")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," dodatkowego doswiadczenia<br>")
	}
	if (player_b_newmoon[id] > 0)
	{
		num_to_str(player_b_newmoon[id],TempSkill,10)
		add(itemEffect,699,"Masz 1\ ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," szans na podpalenie przeciwnika<br>")
	}
	if (player_b_rebracer[id] > 0)
	{
		num_to_str(player_b_rebracer[id],TempSkill,10)
		add(itemEffect,699,"Dostajesz ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," $za przezycie rundy<br>")
	}
	if (player_b_ashroudnecro[id] > 0)
	{
		add(itemEffect, 199, "Potrafisz wskrzeszac<br>");
	}
	if (player_b_toxic[id] > 0)
	{
		num_to_str(player_b_toxic[id],TempSkill,10)
		add(itemEffect,699,"Masz 1\")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," szans na zatrzymanie przeciwnika<br>")
	}
	if (player_b_rose[id] > 0) 
	{
		num_to_str(player_b_rose[id],TempSkill,10)
		add(itemEffect,199,"Masz 1\")
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," szans na zabranie wrogowi ")
		num_to_str(player_b_rosemoney[id],TempSkill,10)
		add(itemEffect,199,TempSkill)
		add(itemEffect,199," $<br>")
	}
	if (player_b_plasma[id] > 0) 
	{
		add(itemEffect, 199, "Masz kule plasmowa<br>");
	}
	if (player_b_ninjaitem[id] > 0) 
	{
		add(itemEffect, 199, "Dostajesz 80 HP jestes niewidzialny i masz tylko noz<br>");
	}
	if (player_b_essence[id] > 0) 
	{
		add(itemEffect, 199, "Gdy trafisz przeciwnika nie moze on uzyc swojego itemu w rundzie<br>");
	}
	if (player_b_rebracer[id] > 0)
	{
		num_to_str(player_b_rebracer[id],TempSkill,10)
		add(itemEffect,699,"Masz 1\ ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," szans na odwrocenie ekranu przeciwnika na 3 sekundy<br>")
	}
	if (player_b_scrapper[id] > 0)
	{
		num_to_str(player_b_scrapper[id],TempSkill,10)
		add(itemEffect,699,"Mozesz sie odepchnac z sila ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," jednostek<br>")
	}
	if (player_b_transcendence[id] > 0)
	{
		num_to_str(player_b_transcendence[id],TempSkill,10)
		add(itemEffect,699,"Masz 1\ ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," szans na zabranie kamizelki wroga<br>")
	}
	if (player_b_commodity[id] > 0)
	{
		num_to_str(player_b_commodity[id],TempSkill,10)
		add(itemEffect,699,"Przez ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," sekundy masz natychmiastowe zabicie z kazdej broni. Nacisnij E aby uzyc<br>")
	}
	if (player_b_shard[id] > 0)
	{
		num_to_str(player_b_shard[id],TempSkill,10)
		add(itemEffect,699,"Masz 1\ ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," szans na zwiekszenie grawitacji wroga<br>")
	}
	if (player_b_instantxm1014[id] > 0)
	{
		num_to_str(player_b_instantxm1014[id],TempSkill,10)
		add(itemEffect,699,"Masz 1\ ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," szans na natychmiastowe zabicie z XM1014<br>")
	}
	if (player_b_instantm4a1[id] > 0)
	{
		num_to_str(player_b_instantm4a1[id],TempSkill,10)
		add(itemEffect,699,"Masz 1\ ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," szans na natychmiastowe zabicie z M4A1<br>")
	}
	if (player_b_instantak47[id] > 0)
	{
		num_to_str(player_b_instantak47[id],TempSkill,10)
		add(itemEffect,699,"Masz 1\ ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," szans na natychmiastowe zabicie z AK47<br>")
	}
	if (player_b_instantjuki[id] > 0)
	{
		num_to_str(player_b_instantjuki[id],TempSkill,10)
		add(itemEffect,699,"Masz 1\ ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," szans na natychmiastowe zabicie z kazdej broni<br>")
	}
	if (player_b_assignment[id] > 0)
	{
		num_to_str(player_b_assignment[id],TempSkill,10)
		add(itemEffect,699,"Masz + ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," Hp<br>")
	}
	if (player_b_themagi[id] > 0)
	{
		num_to_str(player_b_themagi[id],TempSkill,10)
		add(itemEffect,699,"Tracisz polowe hp, zadajesz ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," wiecej dmg<br>")
	}
	if (player_b_blackrock[id] > 0)
	{
		num_to_str(player_b_blackrock[id],TempSkill,10)
		add(itemEffect,699,"Masz 1\ ")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," szans na natychmiastowe zabicie z MAC10 lub TMP<br>")
	}
	if (player_b_tome[id] > 0)
	{
		num_to_str(player_b_tome[id],TempSkill,10)
		add(itemEffect,699,"Item")
		add(itemEffect,699,TempSkill)
		add(itemEffect,699," testowy<br>")
	}

	new Durability[10]
	num_to_str(item_durability[id],Durability,9)
	if (equal(itemEffect,"")) showitem(id,"Brak","Brak","Zabij przeciwnika aby zdobyc item. Mozesz takze kupic item wpisujac /rune","Brak")
	if (!equal(itemEffect,"")) showitem(id,player_item_name[id],itemvalue,itemEffect,Durability)
	
}

/* ==================================================================================================== */

public award_item(id, itemnum)
{
	if (player_item_id[id] != 0)
		return PLUGIN_HANDLED
	
	set_hudmessage(220, 115, 70, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
	new rannum = random_num(1,153)
	
	new maxfind = player_agility[id]
	if (maxfind > 15) maxfind = 15
	
	new rf = random_num(1,25-maxfind)
	
	if (itemnum > 0) rannum = itemnum
	else if (itemnum < 0) return PLUGIN_HANDLED
		
	if (rf == 3 && itemnum == 0)						//We found a rare item			
	{
		award_unique_item(id)	
		rannum = -1
	}				
	
	if (rannum == 1)
	{
		player_item_name[id] = "Bronze Amplifier"
		player_item_id[id] = rannum
		player_b_damage[id] = random_num(1,5)
		show_hudmessage(id, "Znalazles: %s :: +%i obrazen",player_item_name[id],player_b_damage[id])
	}
	
	if (rannum == 2)
	{
		player_item_name[id] = "Silver Amplifier"
		player_item_id[id] = rannum
		player_b_damage[id] = random_num(6,9)
		show_hudmessage(id, "Znalazles: %s :: +%i obrazen",player_item_name[id],player_b_damage[id])
	}
	
	if (rannum == 3)
	{
		player_item_name[id] = "Gold Amplifier"
		player_item_id[id] = rannum
		player_b_damage[id] = random_num(10,18)
		show_hudmessage(id, "Znalazles: %s :: +%i obrazen",player_item_name[id],player_b_damage[id])	
	}
	if (rannum == 4)
	{
		player_item_name[id] = "Vampyric Staff"
		player_item_id[id] = rannum
		player_b_vampire[id] = random_num(1,5)
		show_hudmessage(id, "Znalazles: %s :: +%i vampirzych obrazen",player_item_name[id],player_b_vampire[id])	
	}
	if (rannum == 5)
	{
		player_item_name[id] = "Vampyric Amulet"
		player_item_id[id] = rannum
		player_b_vampire[id] = random_num(6,9)
		show_hudmessage(id, "Znalazles: %s :: +%i vampirzych obrazen",player_item_name[id],player_b_vampire[id])	
	}
	if (rannum == 6)
	{
		player_item_name[id] = "Vampyric Scepter"
		player_item_id[id] = rannum
		player_b_vampire[id] = random_num(10,15)
		show_hudmessage(id, "Znalazles: %s :: +%i vampirzych obrazen",player_item_name[id],player_b_vampire[id])	
	}
	if (rannum == 7)
	{
		player_item_name[id] = "Small bronze bag"
		player_item_id[id] = rannum
		player_b_money[id] = random_num(150,500)
		show_hudmessage(id, "Znalazles: %s :: +%i co runde. Nacisnij E aby wlaczyc tarcze. Intelligencja zwieksza ilosc pieniedzy",player_item_name[id],player_b_money[id]+player_intelligence[id]*50)	
	}
	if (rannum == 8)
	{
		player_item_name[id] = "Medium silver bag"
		player_item_id[id] = rannum
		player_b_money[id] = random_num(500,1200)
		show_hudmessage(id, "Znalazles: %s :: +%i co runde. Nacisnij E aby wlaczyc tarcze. Intelligencja zwieksza ilosc pieniedzy",player_item_name[id],player_b_money[id]+player_intelligence[id]*50)	
	}
	if (rannum == 9)
	{
		player_item_name[id] = "Large gold bag"
		player_item_id[id] = rannum
		player_b_money[id] = random_num(1200,3000)
		show_hudmessage(id, "Znalazles: %s :: +%i co runde. Nacisnij E aby wlaczyc tarcze. Intelligencja zwieksza ilosc pieniedzy",player_item_name[id],player_b_money[id]+player_intelligence[id]*50)	
	}
	if (rannum == 10)
	{
		player_item_name[id] = "Small angel wings"
		player_item_id[id] = rannum
		player_b_gravity[id] = random_num(4,9)
		
		if (is_user_alive(id))
			add_gravity_bonus(id)
		show_hudmessage(id, "Znalazles: %s :: +%i bonus grawitacji - Nacisnij E aby zrobic Aero Stapniecie",player_item_name[id],10-player_b_gravity[id])	
	}
	if (rannum == 11)
	{
		player_item_name[id] = "Arch angel wings"
		player_item_id[id] = rannum
		player_b_gravity[id] = random_num(1,4)
		
		if (is_user_alive(id))
			add_gravity_bonus(id)
		
		show_hudmessage(id, "Znalazles: %s :: +%i bonus grawitacji - Nacisnij E aby zrobic Aero Stapniecie",player_item_name[id],10-player_b_gravity[id])	
		
	}
	if (rannum == 12)
	{
		player_item_name[id] = "Invisibility Rope"
		player_item_id[id] = rannum
		player_b_inv[id] = random_num(130,200)
		show_hudmessage(id, "Znalazles: %s :: +%i bonus niewidzianlosci",player_item_name[id],255-player_b_inv[id])	
	}
	if (rannum == 13)
	{
		player_item_name[id] = "Invisibility Coat"
		player_item_id[id] = rannum
		player_b_inv[id] = random_num(85,130)
		show_hudmessage(id, "Znalazles: %s :: +%i bonus niewidzianlosci",player_item_name[id],255-player_b_inv[id])	
	}
	if (rannum == 14)
	{
		player_item_name[id] = "Invisibility Armor"
		player_item_id[id] = rannum
		player_b_inv[id] = random_num(45,85)
		show_hudmessage(id, "Znalazles: %s :: +%i bonus niewidzianlosci",player_item_name[id],255-player_b_inv[id])	
	}
	if (rannum == 15)
	{
		player_item_name[id] = "Firerope"
		player_item_id[id] = rannum
		player_b_grenade[id] = random_num(2,6)
		show_hudmessage(id, "Znalazles: %s :: +1/%i szans na natychmiastowe zabicie z HE",player_item_name[id],player_b_grenade[id])	
	}
	if (rannum == 16)
	{
		player_item_name[id] = "Fire Amulet"
		player_item_id[id] = rannum
		player_b_grenade[id] = random_num(1,4)
		show_hudmessage(id, "Znalazles: %s :: +1/%i szans na natychmiastowe zabicie z HE",player_item_name[id],player_b_grenade[id])	
	}
	if (rannum == 17)
	{
		player_item_name[id] = "Stalkers ring"
		player_item_id[id] = rannum
		player_b_reduceH[id] = 95
		player_b_inv[id] = 9	
		
		if (is_user_alive(id)) set_user_health(id,5)		
		show_hudmessage(id, "Znalazles: %s :: 5 hp - i jestes niewidzialny",player_item_name[id])	
	}
	if (rannum == 18)
	{
		player_item_name[id] = "Arabian Boots"
		player_item_id[id] = rannum
		player_b_theif[id] = random_num(500,1100)
		show_hudmessage(id, "Znalazles: %s :: 1/5 szans na kradziez $%i za kazdym razem gdy trafisz woga. Nacisnij E aby zamienic pieniadze na zycie",player_item_name[id],player_b_theif[id])	
	}
	if (rannum == 19)
	{
		player_item_name[id] = "Phoenix Ring"
		player_item_id[id] = rannum
		player_b_respawn[id] = random_num(3,6)
		show_hudmessage(id, "Znalazles: %s :: 1/%i szans na respawn po smierci",player_item_name[id],player_b_respawn[id])	
	}
	if (rannum == 20)
	{
		player_item_name[id] = "Sorcerers ring"
		player_item_id[id] = rannum
		player_b_respawn[id] = random_num(2,3)
		show_hudmessage(id, "Znalazles: %s :: 1/%i szans na respawn po smierci",player_item_name[id],player_b_respawn[id])	
	}
	if (rannum == 21)
	{
		player_item_name[id] = "Chaos Orb"
		player_item_id[id] = rannum
		player_b_explode[id] = random_num(150,260)
		show_hudmessage(id, "Znalazles: %s :: Explodujesz w promieniu %i po smierci",player_item_name[id],player_b_explode[id])	
	}
	if (rannum == 22)
	{
		player_item_name[id] = "Hell Orb"
		player_item_id[id] = rannum
		player_b_explode[id] = random_num(260,600)
		show_hudmessage(id, "Znalazles: %s :: Explodujesz w promieniu %i po smierci",player_item_name[id],player_b_explode[id])	
	}
	if (rannum == 23)
	{
		player_item_name[id] = "Gold statue"
		player_item_id[id] = rannum
		player_b_heal[id] = random_num(5,15)
		show_hudmessage(id, "Znalazles: %s :: Uleczasz %i hp co kazde 5 sekund. Nacisnij E aby polozyc totem. Ulecza wszystkich w promieniu %i",player_item_name[id],player_b_heal[id],player_b_heal[id])	
	}
	if (rannum == 24)
	{
		player_item_name[id] = "Daylight Diamond"
		player_item_id[id] = rannum
		player_b_heal[id] = random_num(15,25)
		show_hudmessage(id, "Znalazles: %s :: Uleczasz %i hp co kazde 5 sekund. Nacisnij E aby polozyc totem. Ulecza wszystkich w promieniu %i",player_item_name[id],player_b_heal[id],player_b_heal[id])	
	}
	if (rannum == 25)
	{
		player_item_name[id] = "Blood Diamond"
		player_item_id[id] = rannum
		player_b_heal[id] = random_num(20,35)
		show_hudmessage(id, "Znalazles: %s :: Uleczasz %i hp co kazde 5 sekund. Nacisnij E aby polozyc totem. Ulecza wszystkich w promieniu %i",player_item_name[id],player_b_heal[id],player_b_heal[id])	
	}
	if (rannum == 26)
	{
		player_item_name[id] = "Wheel of Fortune"
		player_item_id[id] = rannum
		player_b_gamble[id] = random_num(2,3)
		show_hudmessage(id, "Znalazles: %s :: +%i szans na bonus w kazdej rundzie",player_item_name[id],player_b_gamble[id])	
	}
	if (rannum == 27)
	{
		player_item_name[id] = "Four leaf Clover"
		player_item_id[id] = rannum
		player_b_gamble[id] = random_num(4,5)
		show_hudmessage(id, "Znalazles: %s :: +%i szans na bonus w kazdej rundzie",player_item_name[id],player_b_gamble[id])	
	}
	if (rannum == 28)
	{
		player_item_name[id] = "Amulet of the sun"
		player_item_id[id] = rannum
		player_b_blind[id] = random_num(6,9)
		show_hudmessage(id, "Znalazles: %s :: 1/%i szans na oslepienie przeciwnika gdy go trafisz",player_item_name[id],player_b_blind[id])	
	}
	if (rannum == 29)
	{
		player_item_name[id] = "Sword of the sun"
		player_item_id[id] = rannum
		player_b_blind[id] = random_num(2,5)
		show_hudmessage(id, "Znalazles: %s :: 1/%i szans na oslepienie przeciwnika gdy go trafisz",player_item_name[id],player_b_blind[id])	
	}
	if (rannum == 30)
	{
		player_item_name[id] = "Fireshield"
		player_item_id[id] = rannum
		player_b_fireshield[id] = 1
		show_hudmessage(id, "Znalazles: %s :: Chroni przed natychmiastowym zabiciem przez itemy",player_item_name[id],player_b_fireshield[id])	
	}
	if (rannum == 31)
	{
		player_item_name[id] = "Stealth Shoes"
		player_item_id[id] = rannum
		player_b_silent[id] = 1
		show_hudmessage(id, "Znalazles: %s :: Twoje kroki staja sie ciche",player_item_name[id])	
	}
	if (rannum == 32)
	{
		player_item_name[id] = "Meekstone"
		player_item_id[id] = rannum
		player_b_meekstone[id] = 1
		show_hudmessage(id, "Znalazles: %s :: Nacisnij E aby polozyc falszywe C4",player_item_name[id])	
	}
	if (rannum == 33)
	{
		player_item_name[id] = "Medicine Glar"
		player_item_id[id] = rannum
		player_b_teamheal[id] = random_num(10,20)
		show_hudmessage(id, "Znalazles: %s :: strzel do kolegow aby uleczyc %i hp. Nacisnij E aby aktywowac magiczna tarcze",player_item_name[id],player_b_teamheal[id])	
	}
	if (rannum == 34)
	{
		player_item_name[id] = "Medicine Totem"
		player_item_id[id] = rannum
		player_b_teamheal[id] = random_num(25,50)
		show_hudmessage(id, "Znalazles: %s :: strzel do kolegow aby uleczyc %i hp. Nacisnij E aby aktywowac magiczna tarcze",player_item_name[id],player_b_teamheal[id])	
	}
	if (rannum == 35)
	{
		player_item_name[id] = "Iron Armor"
		player_item_id[id] = rannum
		player_b_redirect[id] = random_num(3,6)
		show_hudmessage(id, "Znalazles: %s :: +%i redukcji obrazen",player_item_name[id],player_b_redirect[id])	
	}
	if (rannum == 36)
	{
		player_item_name[id] = "Mitril Armor"
		player_item_id[id] = rannum
		player_b_redirect[id] = random_num(6,11)
		show_hudmessage(id, "Znalazles: %s :: +%i redukcji obrazen",player_item_name[id],player_b_redirect[id])	
	}
	if (rannum == 37)
	{
		player_item_name[id] = "Godly Armor"
		player_item_id[id] = rannum
		player_b_redirect[id] = random_num(10,15)
		show_hudmessage(id, "Znalazles: %s :: +%i redukcji obrazen",player_item_name[id],player_b_redirect[id])	
	}
	if (rannum == 38)
	{
		player_item_name[id] = "Fireball staff"
		player_item_id[id] = rannum
		player_b_fireball[id] = random_num(50,100)
		show_hudmessage(id, "Znalazles: %s :: Uszkadza wszystko w promienu %i",player_item_name[id],player_b_fireball[id])	
	}
	if (rannum == 39)
	{
		player_item_name[id] = "Fireball scepter"
		player_item_id[id] = rannum
		player_b_fireball[id] = random_num(150,250)
		show_hudmessage(id, "Znalazles: %s :: Uszkadza wszystko w promienu %i",player_item_name[id],player_b_fireball[id])	
	}
	if (rannum == 40)
	{
		player_item_name[id] = "Ghost Rope"
		player_item_id[id] = rannum
		player_b_ghost[id] = random_num(4,15)
		show_hudmessage(id, "Znalazles: %s :: Nacisnij E aby przechodzic przez sciany przez %i sekund",player_item_name[id],player_b_ghost[id])	
	}
	if (rannum == 41)
	{
		player_item_name[id] = "Nicolas Eye"
		player_item_id[id] = rannum
		player_b_eye[id] = -1
		show_hudmessage(id, "Znalazles: %s :: Nacisnij E aby polozyc kamere, ponownie E aby wlaczyc/wylaczyc",player_item_name[id])	
	}
	if (rannum == 42)
	{
		player_item_name[id] = "Knife Ruby"
		player_item_id[id] = rannum
		player_b_blink[id] = floatround(halflife_time())
		show_hudmessage(id, "Znalazles: %s :: Mozesz znikac na 3 sekundy, gdy atakujesz nozem PPM",player_item_name[id])	
	}
	if (rannum == 43)
	{
		player_item_name[id] = "Lothars Edge"
		player_item_id[id] = rannum
		player_b_windwalk[id] = random_num(7,17)
		show_hudmessage(id, "Znalazles: %s :: Nacisnij E aby stac sie niewidocznym na %i sekund, zwieksza szybkosc w tym czasie ale nie mozna aktakowac",player_item_name[id],player_b_windwalk[id])	
	}
	if (rannum == 44)
	{
		player_item_name[id] = "Staff of the Earth"
		player_item_id[id] = rannum
		player_b_reverse[id] = random_num(2,4)
		show_hudmessage(id, "Znalazles: %s :: 1/%i szans na zmylenie przeciwnika po trafieniu go",player_item_name[id],player_b_reverse[id])	
	}
	if (rannum == 45)
	{
		player_item_name[id] = "Magic Booster"
		player_item_id[id] = rannum
		player_b_froglegs[id] = 1
		show_hudmessage(id, "Znalazles: %s :: Przytrzymaj kucanie na 3 sekundy aby wykonac long jump",player_item_name[id])	
	}
	if (rannum == 46)
	{
		player_item_name[id] = "Dagon I"
		player_item_id[id] = rannum
		player_b_dagon[id] = 1
		show_hudmessage(id, "Znalazles: %s :: Nacisnij E aby wystrzelic piorun do najblizszego przeciwnika",player_item_name[id],player_b_reverse[id])	
	}
	if (rannum == 47)
	{
		player_item_name[id] = "Scout Extender"
		player_item_id[id] = rannum
		player_b_sniper[id] = random_num(1,3)
		show_hudmessage(id, "Znalazles: %s :: 1/%i szans na natychiastowe zabicie ze scout-a",player_item_name[id],player_b_sniper[id])	
	}
	if (rannum == 48)
	{
		player_item_name[id] = "Scout Amplifier"
		player_item_id[id] = rannum
		player_b_sniper[id] = random_num(3,4)
		show_hudmessage(id, "Znalazles: %s :: 1/%i szans na natychiastowe zabicie ze scout-a",player_item_name[id],player_b_sniper[id])	
	}
	if (rannum == 49)
	{
		player_item_name[id] = "Air booster"
		player_item_id[id] = rannum
		player_b_jumpx[id] = 1
		show_hudmessage(id, "Znalazles: %s :: Mozesz wykonac podwojny skok w powietrzu",player_item_name[id],player_b_sniper[id])	
	}
	if (rannum == 50)
	{
		player_item_name[id] = "Iron Spikes"
		player_item_id[id] = rannum
		player_b_smokehit[id] = 1
		show_hudmessage(id, "Znalazles: %s :: Jesli uderzysz przeciwnika smok-iek zabijesz go",player_item_name[id])	
	}
	if (rannum == 51)
	{
		player_item_name[id] = "Point Booster"
		player_item_id[id] = rannum
		player_b_extrastats[id] = random_num(1,3)
		BoostStats(id,player_b_extrastats[id])
		show_hudmessage(id, "Znalazles: %s :: Zyskasz +%i do kazdej umiejetnosci trzymajac ten item",player_item_name[id],player_b_extrastats[id])	
	}
	if (rannum == 52)
	{
		player_item_name[id] = "Totem amulet"
		player_item_id[id] = rannum
		player_b_firetotem[id] = random_num(250,400)
		show_hudmessage(id, "Znalazles: %s :: Nacisnij E aby polozyc wybuchajacy totem",player_item_name[id])	
	}
	if (rannum == 53)
	{
		player_item_name[id] = "Magic Hook"
		player_item_id[id] = rannum
		player_b_hook[id] = 1
		show_hudmessage(id, "Znalazles: %s :: Nacisnij E aby rzucic hakiem",player_item_name[id])	
	}
	if (rannum == 54)
	{
		player_item_name[id] = "Darksteel Glove"
		player_item_id[id] = rannum
		player_b_darksteel[id] = random_num(10,20)
		show_hudmessage(id, "Znalazles: %s :: Dodatkowe %i obrazen, gdy trafisz wroga od tylu",player_item_name[id],player_b_darksteel[id])	
	}
	if (rannum == 55)
	{
		player_item_name[id] = "Darksteel Gaunlet"
		player_item_id[id] = rannum
		player_b_darksteel[id] = random_num(20,30)
		show_hudmessage(id, "Znalazles: %s :: Dodatkowe %i obrazen, gdy trafisz wroga od tylu",player_item_name[id],player_b_darksteel[id])	
	}
	if (rannum == 56)
	{
		player_item_name[id] = "Illusionists Cape"
		player_item_id[id] = rannum
		player_b_illusionist[id] = 1
		show_hudmessage(id, "Znalazles: %s :: Nacisnij E aby stac sie niewidzialny dla wszystkich",player_item_name[id])	
	}
	if (rannum == 57)
	{
		player_item_name[id] = "Techies scepter"
		player_item_id[id] = rannum
		player_b_mine[id] = 3
		show_hudmessage(id, "Znalazles przedmiot: %s :: Nacisnij E aby polozyc mine (Masz 3 miny)",player_item_name[id])
	}
	if (rannum == 58)
	{
		player_item_name[id] = "Arch Protection"
		player_item_id[id] = rannum
		player_b_hsprotection[id] = 1
		show_hudmessage(id, "Znalazles przedmiot: %s :: Nie masz glowy",player_item_name[id])
	}
	if (rannum == 59)
	{
		player_item_name[id] = "Arch Cure"
		player_item_id[id] = rannum
		player_b_chance_spawn[id] = random_num(2,4)
		show_hudmessage(id, "Znalazles: %s :: Masz 1\%i szans na respawn u przeciwnika",player_item_name[id],player_b_chance_spawn[id])	
	}
	if (rannum == 60)
	{
		player_item_name[id] = "Magiczna Refleksja"
		player_item_id[id] = rannum
		player_b_refleksja[id] = 1
		cs_set_user_money(id , 16000)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Dostajesz 16000 $ co runde",player_item_name[id])
	}
	if (rannum == 61)
	{
		player_item_name[id] = "Polimorf"
		player_item_id[id] = rannum
		player_b_polimorf[id] = 1
		give_item(id, "weapon_flashbang");
		give_item(id, "weapon_flashbang");
		give_item(id, "weapon_smokegrenade");
		give_item(id, "weapon_hegrenade");
		show_hudmessage(id, "Znalazles przedmiot: %s :: Dostajesz wszystkie granaty (HE, SMOKE, 2xFLASH)",player_item_name[id])
	}
	if (rannum == 62)
	{
		player_item_name[id] = "Telekineza"
		player_item_id[id] = rannum
		player_b_drop[id] = random_num(3,10)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz 1/%i szans na wrzucenie broni przeciwnikowi",player_item_name[id],player_b_drop[id])
	}
	if (rannum == 63)
	{
		player_item_name[id] = "Runa Energii"
		player_item_id[id] = rannum
		player_b_bunnyhop[id] = 1
		show_hudmessage(id, "Znalazles przedmiot: %s :: Mozesz wykonac Bunny Hop",player_item_name[id])
	}
	if (rannum == 64)
	{
		player_item_name[id] = "Pazur Demona"
		player_item_id[id] = rannum
		player_b_jumphe[id] = 1
		show_hudmessage(id, "Znalazles przedmiot: %s :: Twoje granaty HE odrzucaja",player_item_name[id])
	}
	if (rannum == 65)
	{
		player_item_name[id] = "Kamien"
		player_item_id[id] = rannum
		player_b_stone[id] = 1
		show_hudmessage(id, "Znalazles przedmiot: %s :: Ten item nic nie daje, mozesz go wyrzucic",player_item_name[id])   
	}
	if (rannum == 66)
	{
		player_item_name[id] = "Feeblemind"
		player_item_id[id] = rannum
		player_b_feeblemind[id] = random_num(3,6)
		player_powerslap[id] = random_num(5,15)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz 1\%i na slap przeciwnika z moca %i Hp",player_item_name[id],player_b_feeblemind[id], player_powerslap[id])
	}
	if (rannum == 67)
	{
		player_item_name[id] = "Amulet Zwinnosci"
		player_item_id[id] = rannum
		player_b_aspeed[id] = random_num(10,80)
		set_user_maxspeed(id,get_user_maxspeed(id)+player_dextery[id]+player_b_aspeed[id]) 
		show_hudmessage(id, "Znalazles przedmiot: %s :: Jestes szybszy o %i punktow",player_item_name[id],player_b_aspeed[id])
	}
	if (rannum == 68)
	{
		player_item_name[id] = "Plecak Sapera"
		player_item_id[id] = rannum
		player_b_c4[id] = 1
		if(get_user_team(id) == 1)
		{
			show_hudmessage(id, "Znalazles przedmiot: %s :: Masz C4 do podlozenia",player_item_name[id])
			cs_set_user_plant(id,1,1)
			give_item ( id, "weapon_c4" )
		}
		if(get_user_team(id) == 2)
		{
			show_hudmessage(id, "Znalazles przedmiot: %s :: Masz DefuseKit do rozbrojenia",player_item_name[id])
			give_item ( id, "item_thighpack" )
		}
	}
	if (rannum == 69)
	{
		player_item_name[id] = "Stare Zapiski"
		player_item_id[id] = rannum
		player_b_crosshair[id] = 1
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz celownik przy wszystkich snajperkach",player_item_name[id])
	}
	if (rannum == 70)
	{
		player_item_name[id] = "Lekkie Buty"
		player_item_id[id] = rannum
		player_b_grav[id] = random_num(50,800)
		entity_set_float(id, EV_FL_gravity, player_b_grav[id]/800.0);
		show_hudmessage(id, "Znalazles przedmiot: %s :: Twoja grawitacja jest zredukowana do %i",player_item_name[id],player_b_grav[id])
	}
	if (rannum == 71)
	{
		player_item_name[id] = "Cursed"
		player_item_id[id] = rannum
		player_b_shake[id] = random_num(3,6)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz 1/%i ze przeciwnikowi zacznie sie trzesc ekran",player_item_name[id],player_b_shake[id])
	}
	if (rannum == 72)
	{
		player_item_name[id] = "Lightning Arrow"
		player_item_id[id] = rannum
		player_b_radar[id] = 1
		show_hudmessage(id, "Znalazles: %s :: Widzisz przeciwnikow na radarze",player_item_name[id])
	}
	if (rannum == 73)
	{
		player_item_name[id] = "Silver Snake"
		player_item_id[id] = rannum
		player_b_pozornosc[id] = 1
		changeskin(id,0)  
		show_hudmessage(id, "Znalazles: %s :: Wygladasz jak przeciwnik",player_item_name[id])
	}
	if (rannum == 74)
	{
		player_item_name[id] = "Shadow Strike"
		player_item_id[id] = rannum
		player_b_course[id] = 1
		set_task(10.0, "add_item_course_yy", id+TASK_SHADOW);
		give_item(id, "weapon_hegrenade");
		show_hudmessage(id, "Znalazles przedmiot: %s :: Dostajesz HE Grenade co 10 sekund",player_item_name[id])
	}
	if (rannum == 75)
	{
		player_item_name[id] = "Nocny Wzrok"
		player_item_id[id] = rannum
		player_b_nightsight[id] = 1
		show_hudmessage(id, "Znalazles przedmiot: %s :: Nie dzialaja na ciebie flash-e",player_item_name[id])
	}
	if (rannum == 76)
	{
		player_item_name[id] = "Double Shot"
		player_item_id[id] = rannum
		player_b_celnosc[id] = 1
		show_hudmessage(id, "Znalazles przedmiot: %s :: Mniejszy rozrzut",player_item_name[id])
	}
	if (rannum == 77)
	{
		player_item_name[id] = "Feint"
		player_item_id[id] = rannum
		player_b_air[id] = 1
		show_hudmessage(id, "Znalazles przedmiot: %s :: Nieskonczenie wiele skokow",player_item_name[id])
	}
	if (rannum == 78)
	{
		player_item_name[id] = "Dismount"
		player_item_id[id] = rannum
		player_b_awp[id] = 1
		show_hudmessage(id, "Znalazles przedmiot: %s :: Natychmiastowe zabicie z AWP",player_item_name[id])
	}
	if (rannum == 79)
	{
		player_item_name[id] = "Mystic Arc"
		player_item_id[id] = rannum
		player_b_fasthand[id] = 1
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz natychmiastowe przeladowanie",player_item_name[id])
	}
	if (rannum == 80)
	{
		player_item_name[id] = "Whirlwind Attack"
		player_item_id[id] = rannum
		player_b_unlimited[id] = 1 
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz nieskonczona amunicje",player_item_name[id])
	}
	if (rannum == 81)
	{
		player_item_name[id] = "Swiftflight"
		player_item_id[id] = rannum
		player_b_ak47m4[id] = 1  
		give_item(id, "weapon_ak47");
		give_item(id, "weapon_ak47");
		give_item(id, "weapon_ak47");
		give_item(id, "weapon_m4a1");
		give_item(id, "weapon_m4a1");
		give_item(id, "weapon_m4a1");
		show_hudmessage(id, "Znalazles przedmiot: %s :: Dostajesz Ak47 i M4 ",player_item_name[id])
	}
	if (rannum == 82)
	{
		player_item_name[id] = "Scythe"
		player_item_id[id] = rannum
		player_b_falling[id] = 1  
		show_hudmessage(id, "Znalazles przedmiot: %s :: Nie tracisz Hp spadajac z wysokosci",player_item_name[id])
	}
	if (rannum == 83)
	{
		player_item_name[id] = "Feathernock"
		player_item_id[id] = rannum
		player_b_deagle[id] = random_num(3,10)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz 1\%i na natychmiastowe zabicie z Deagla",player_item_name[id], player_b_deagle[id])
	}
	if (rannum == 84)
	{
		player_item_name[id] = "Infused Throw"
		player_item_id[id] = rannum
		player_b_giveawp[id] = 1
		give_item(id, "weapon_awp");
		give_item(id, "weapon_awp");
		give_item(id, "weapon_awp");
		show_hudmessage(id, "Znalazles przedmiot: %s :: Dostajesz AWP",player_item_name[id])
	}
	if (rannum == 85)
	{
		player_item_name[id] = "Demon Bridle Ring"
		player_item_id[id] = rannum
		player_b_book[id] = 1
		Give_Xp(id,get_cvar_num("diablo_xpbonus"))
		show_hudmessage(id, "Znalazles przedmiot: %s :: Dostajesz %i doswiadczenia",player_item_name[id],get_cvar_num("diablo_xpbonus"))
	}
	if (rannum == 86)
	{
		player_item_name[id] = "Duch Powietrza"
		player_item_id[id] = rannum
		player_b_person[id] = 1
		menu_3d(id)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz widok 3D Person",player_item_name[id])
	}
	if (rannum == 87)
	{
		player_item_name[id] = "Runa Ujawnienia"
		player_item_id[id] = rannum
		player_b_glock[id] = random_num(4,8)
		show_hudmessage(id, "Znalazles: %s :: 1/%i szans na natychiastowe zabicie z glock\usp",player_item_name[id],player_b_glock[id])	
		
	}
	if (rannum == 88)
	{
		player_item_name[id] = "Revea"
		player_item_id[id] = rannum
		player_b_revea[id] = random_num(15,80)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Gdy kucasz twoja widocznosc jest zredukowana do %i",player_item_name[id],player_b_revea[id])
	}
	if (rannum == 89)
	{
		player_item_name[id] = "Urn of Ashes"
		player_item_id[id] = rannum
		player_b_spawnuse[id] = 1
		show_hudmessage(id, "Znalazles przedmiot: %s :: Mozesz sie odrodzic kiedy chcesz",player_item_name[id])
	}	
	if (rannum == 90)
	{
		player_item_name[id] = "Storm Ring"
		player_item_id[id] = rannum
		player_b_hpplus[id] = 1
		if(is_user_alive(id))
			set_user_health(id,get_user_health(id) +35)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Dostajesz +35 HP",player_item_name[id])
	}
	if (rannum == 91)
	{
		player_item_name[id] = "Rekawice Pechu"
		player_item_id[id] = rannum
		player_b_zonk[id] = 1
		engclient_cmd(id,"weapon_knife") 
		show_hudmessage(id, "Znalazles przedmiot: %s :: Tracisz bronie",player_item_name[id])
	}
	if (rannum == 92)
	{
		player_item_name[id] = "Bladeweave"
		player_item_id[id] = rannum
		if (player_class[id] == NINJA)
			player_b_knife[id] = random_num(2,4)
		else player_b_knife[id] = random_num(1,3)
		show_hudmessage(id, "Znalazles: %s :: Masz 1/%i na natychmiastowe zabicie z noza",player_item_name[id],player_b_knife[id])
	}
	if (rannum == 93)
	{
		player_item_name[id] = "Conjurer`s Garb"
		player_item_id[id] = rannum
		player_b_conjurg[id] = random_num(1,2)
		show_hudmessage(id, "Znalazles: %s :: 1/%i szans na natychiastowe zabicie ze scouta",player_item_name[id],player_b_conjurg[id])	
	}
	if (rannum == 94)
	{
		player_item_name[id] = "Commemorative Coin"
		player_item_id[id] = rannum
		player_b_commemorative[id] = random_num(10, 1500)
		show_hudmessage(id, "Znalazles: %s :: Masz dlugi noz, mozesz atakowac na odleglosc %i jednostek",player_item_name[id],player_b_commemorative[id])	
	}
	if (rannum == 95)
	{
		player_item_name[id] = "Altar of Spirituality"
		player_item_id[id] = rannum
		player_b_altar[id] = 1
		show_hudmessage(id, "Znalazles przedmiot: %s :: Jestes bardzo szybki na nozu lecz nie mozesz w tym czasie atakowac",player_item_name[id])
	}
	if (rannum == 96)
	{
		player_item_name[id] = "Hatched Dragon Egg"
		player_item_id[id] = rannum
		player_b_hatched[id] = random_num(1,4)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Mozesz odbic %i pociskow i trafic w przeciwnika",player_item_name[id],player_b_hatched[id])
	}
	if (rannum == 97)
	{
		player_item_name[id] = "Lavaliere"
		player_item_id[id] = rannum
		player_b_autoshoot[id] = 1    
		add_item_autoshoot(id)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz Automatyczne Strzelanie",player_item_name[id])
	}
	if (rannum == 98)
	{
		player_item_name[id] = "Defense Mastery"
		player_item_id[id] = rannum
		player_b_invknife[id] = random_num(25,85)   
		show_hudmessage(id, "Znalazles przedmiot: %s :: Widocznosc zredukowana do %i gdy trzymasz noz",player_item_name[id],player_b_invknife[id])
	}
	if (rannum == 99)
	{
		player_item_name[id] = "Lake Shit"
		player_item_id[id] = rannum
		player_b_lake[id] = 1  
		show_hudmessage(id, "Znalazles przedmiot: %s :: Gdy stoisz w miejscu nie widac Cie",player_item_name[id])
	}
	if (rannum == 100)
	{
		player_item_name[id] = "White Potion"
		player_item_id[id] = rannum
		player_b_whitep[id] = random_num(3,7)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz 1/%i szans ,ze trafisz wroga piorunem",player_item_name[id],player_b_whitep[id])
	}
	if (rannum == 101)
	{
		player_item_name[id] = "Chain Coif"
		player_item_id[id] = rannum
		player_b_shift[id] = random_num(9,80)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Gdy trzymasz Shift, twoja widocznosc wynosi %i",player_item_name[id],player_b_shift[id])
	}
	if (rannum == 102)
	{
		player_item_name[id] = "Harpsichord"
		player_item_id[id] = rannum
		player_b_harpsichord[id] = random_num(5,12)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Widzisz miny, dostajesz +%i Hp",player_item_name[id],player_b_harpsichord[id])
	}
	if (rannum == 103)
	{
		player_item_name[id] = "Sack of Flour"
		player_item_id[id] = rannum
		player_b_sack[id] = random_num(1,10)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Twoje granty wybuchaja z opoznieniem %i sekund",player_item_name[id],player_b_sack[id])
	}
	if (rannum == 104)
	{
		player_item_name[id] = "Silverware"
		player_item_id[id] = rannum
		player_b_silver[id] = random_num(1,8)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz %i srebrnych naboii i +15 dmg z nich",player_item_name[id],player_b_silver[id])
	}
	if (rannum == 105)
	{
		player_item_name[id] = "Acid Slug"
		player_item_id[id] = rannum
		player_b_acid[id] = random_num(100,1200)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz pole magnetyczne, w promieniu %i zabierze wrogom polowe Hp",player_item_name[id],player_b_acid[id])
	}
	if (rannum == 106)
	{
		player_item_name[id] = "Rune of Justice"
		player_item_id[id] = rannum
		player_b_justice[id] = 1
		set_user_health(id,get_user_health(id)/2)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Tracisz polowe Hp, ale zdobywasz 2x wiecej doswiadczenia",player_item_name[id])
	}
	if (rannum == 107)
	{
		player_item_name[id] = "Horse's Carcass"
		player_item_id[id] = rannum
		player_b_horse[id] = random_num(100,255)
		cs_set_user_armor(id,player_b_horse[id],CS_ARMOR_VESTHELM)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Dostajesz %i kamizelki ( Kevlar )",player_item_name[id],player_b_horse[id])
	}
	if (rannum == 108)
	{
		player_item_name[id] = "Artifact Rarity"
		player_item_id[id] = rannum
		player_b_artifactr[id] = random_num(3,8)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz %i sekund niesmiertelnosci",player_item_name[id], player_b_artifactr[id])
	}
	if (rannum == 109)
	{
		player_item_name[id] = "Electric Field"
		player_item_id[id] = rannum
		player_b_elecirtc[id] = random_num(2,8)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz %i sekund niewidzialnosci",player_item_name[id], player_b_elecirtc[id])
	}
	if (rannum == 110)
	{
		player_item_name[id] = "Anvil"
		player_item_id[id] = rannum
		player_b_anvil[id] = random_num(3,10)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Nacisnij E aby podwoic hp na %i sekund",player_item_name[id], player_b_anvil[id])
	}
	if (rannum == 111)
	{
		player_item_name[id] = "Spittoon"
		player_item_id[id] = rannum
		player_b_spittoon[id] = random_num(5,10)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Nacisnij E aby zmniejszyc grawitacje na %i sekund",player_item_name[id], player_b_spittoon[id])
	}
	if (rannum == 112)
	{
		player_item_name[id] = "Pennant"
		player_item_id[id] = rannum
		player_b_pennant[id] = random_num(10,50)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Zwieksza szybkostrzelnosc o %i%",player_item_name[id], player_b_pennant[id])
	}
	if (rannum == 113)
	{
		player_item_name[id] = "Chest of Drawers"
		player_item_id[id] = rannum
		player_b_chest[id] = random_num(3,6)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Mozesz leczyc sie trzymajac noz +5 Hp co %i sekund",player_item_name[id], player_b_chest[id])
	}
	if (rannum == 114)
	{
		player_item_name[id] = "Mandrake"
		player_item_id[id] = rannum
		player_b_mandrake[id] =  random_num(2,10)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Mozna Cie zabic tylko HeadShootem. Nacisnij E aby uzyc na %i sekund",player_item_name[id], player_b_mandrake[id])
	}
	if (rannum == 115)
	{
		player_item_name[id] = "Juggernaut"
		player_item_id[id] = rannum
		player_b_juggernaut[id] = random_num(1,6)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Widzisz niewidzialnych na %i sekund po uzyciu E",player_item_name[id],player_b_juggernaut[id])
	}
	if (rannum == 116)
	{
		player_item_name[id] = "Wizard's Eye"
		player_item_id[id] = rannum
		player_b_wizard[id] = 1
		show_hudmessage(id, "Znalazles przedmiot: %s :: Redukuje to obrazenia o 50%",player_item_name[id])
	}
	if (rannum == 117)
	{
		player_item_name[id] = "Oven Spatula"
		player_item_id[id] = rannum
		player_b_oven[id] = random_num(4,10)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz %i dodatkowych obrazen + inteligencja",player_item_name[id],player_b_oven[id])
	}
	if (rannum == 118)
	{
		player_item_name[id] = "Candelabra"
		player_item_id[id] = rannum
		player_b_candelabra[id] = 1
		entity_set_float(id, EV_FL_gravity, 400.0/800.0);
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz 1\2 ze scout-a, zmniejszona grawitacja do 400",player_item_name[id])
	}
	if (rannum == 119)
	{
		player_item_name[id] = "Jar of Honey"
		player_item_id[id] = rannum
		player_b_jar[id] = random_num(5,50)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Za kazdego fraga dostajesz %i Hp",player_item_name[id],player_b_jar[id])
	}
	if (rannum == 120)
	{
		player_item_name[id] = "Book of Prophecies"
		player_item_id[id] = rannum
		player_b_bookofprpoh[id] = random_num(5,30)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Za kazdego fraga dostajesz %i Hp i pelny magazynek",player_item_name[id],player_b_bookofprpoh[id])
	}
	if (rannum == 121)
	{
		player_item_name[id] = "Book of Circles"
		player_item_id[id] = rannum
		player_b_bless[id] = random_num(2,6)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz 1\%i szans na spowolnienie przeciwnika",player_item_name[id],player_b_bless[id])
	}
	if (rannum == 122)
	{
		player_item_name[id] = "Xylophone"
		player_item_id[id] = rannum
		player_b_xylophone[id] = 1
		give_item(id,"weapon_ak47")
		give_item(id,"weapon_ak47")
		give_item(id,"weapon_ak47")
		show_hudmessage(id, "Znalazles przedmiot: %s :: Dostajesz Ak47 i masz lekko ograniczony rozrzut",player_item_name[id])
	}
	if (rannum == 123)
	{
		player_item_name[id] = "Pitchfork"
		player_item_id[id] = rannum
		player_b_pitchfork[id] = random_num(200,600)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Mozesz oslepic przeciwnika w promieniu %i jednostek",player_item_name[id],player_b_pitchfork[id])
	}
	if (rannum == 124)
	{
		player_item_name[id] = "Halberd"
		player_item_id[id] = rannum
		player_b_halberd[id] = random_num(100,550)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Mozesz uzyc aby zmienic bron przeciwnika na noz w promieniu %i jednostek",player_item_name[id],player_b_halberd[id])
	}
	if (rannum == 125)
	{
		player_item_name[id] = "Loaf of Bread"
		player_item_id[id] = rannum
		player_b_loaf[id] = random_num(10,400)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz natychmiastowe zabicie z noza i w promieniu %i zabije to tez wrogow",player_item_name[id],player_b_loaf[id])
	}
	if (rannum == 126)
	{
		player_item_name[id] = "Inkwell"
		player_item_id[id] = rannum
		player_b_inkwell[id] = 1
		show_hudmessage(id, "Znalazles przedmiot: %s :: Strzerasz 8 pociskow za jednym razem z M3",player_item_name[id])
	}
	if (rannum == 127)
	{
		player_item_name[id] = "Rune of Humility"
		player_item_id[id] = rannum
		player_b_humility[id] = random_num(1,3)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Giniesz po %i sekundach od zabojstwa",player_item_name[id],player_b_humility[id])
	}	
	if (rannum == 128)
	{
		player_item_name[id] = "Berserkers Maul"
		player_item_id[id] = rannum
		player_b_maul[id] = 1
		show_hudmessage(id, "Znalazles przedmiot: %s :: Jestes wysoki",player_item_name[id])
	}
	if (rannum == 129)
	{
		player_item_name[id] = "Royal Guard Survival Knife"
		player_item_id[id] = rannum
		player_b_throwingaxe[id] = 1
		change(id)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz Dragontail",player_item_name[id])
	}
	if (rannum == 130)
	{
		player_item_name[id] = "Rune of Valor"
		player_item_id[id] = rannum
		player_b_runeofvalor[id] = random_num(500,1100)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Oslepiasz przeciwnikow po smierci w promieniu %i jednostek",player_item_name[id],player_b_runeofvalor[id])
	}
	if (rannum == 131)
	{
		player_item_name[id] = "Rune of Valor"
		player_item_id[id] = rannum
		player_b_blackpearl[id] = random_num(10,300)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Zadajesz losowo wieksze obrazenia gdy jestes blisko przyjaciela teamu ( W promieniu %i jednostek)",player_item_name[id],player_b_blackpearl[id])
	}
	if (rannum == 132)
	{
		player_item_name[id] = "Blood Moss"
		player_item_id[id] = rannum
		player_b_bloodmoss[id] = random_num(2,8)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz 1\%i szans na otrucie przeciwnika na 8 sekund",player_item_name[id],player_b_bloodmoss[id])
	}
	if (rannum == 133)
	{
		player_item_name[id] = "Garlic"
		player_item_id[id] = rannum
		player_b_garlic[id] = random_num(2,20)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Gdy zabijesz przeciwnika twoj team dostaje +%i dodatkowego doswiadczenia",player_item_name[id],player_b_garlic[id])
	}
	if (rannum == 134)
	{
		player_item_name[id] = "Moonstone (new moon)"
		player_item_id[id] = rannum
		player_b_newmoon[id] = random_num(2,8)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz 1\%i szans na podpalenie przeciwnika",player_item_name[id],player_b_newmoon[id])
	}
	if (rannum == 135)
	{
		player_item_name[id] = "Resilient Bracer"
		player_item_id[id] = rannum
		player_b_rebracer[id] = random_num(100,15000)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Dostajesz %i$ za przezycie rundy",player_item_name[id],player_b_rebracer[id])
	}
	if (rannum == 136)
	{
		player_item_name[id] = "A Necromancer Shroud"
		player_item_id[id] = rannum
		player_b_ashroudnecro[id] = 1
		show_hudmessage(id, "Znalazles przedmiot: %s :: Potrafisz wskrzeszac",player_item_name[id])
	}
	if (rannum == 137)
	{
		player_item_name[id] = "A Toxic Potion"
		player_item_id[id] = rannum
		player_b_toxic[id] = random_num(3,7)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz 1\%i szans na zatrzymanie przeciwnika ",player_item_name[id],player_b_toxic[id])
	}
	if (rannum == 138)
	{
		player_item_name[id] = "Virulent Rose Extract"
		player_item_id[id] = rannum
		player_b_rose[id] = random_num(2,5)		
		player_b_rosemoney[id] = random_num(1500,6000)	
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz 1\%i szans na zabranie wrogowi %i$",player_item_name[id],player_b_rose[id],player_b_rosemoney[id])
	}
	if (rannum == 139)
	{
		player_item_name[id] = "Pedestal With Crystal"
		player_item_id[id] = rannum
		player_b_plasma[id] = 1
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz kule plasmowa",player_item_name[id])
	}
	if (rannum == 140)
	{
		player_item_name[id] = "Luminescent Fungi"
		player_item_id[id] = rannum
		player_b_ninjaitem[id] = 1
		set_user_health(id,get_user_health(id)+80)
		client_cmd(id,"weapon_knife")
		show_hudmessage(id, "Znalazles przedmiot: %s :: Dostajesz 80 HP jestes niewidzialny i masz tylko noz",player_item_name[id])
	}
	if (rannum == 141)
	{
		player_item_name[id] = "Essence Of Achievement"
		player_item_id[id] = rannum
		player_b_essence[id] = 1
		show_hudmessage(id, "Znalazles przedmiot: %s :: Gdy trafisz przeciwnika nie moze on uzyc swojego itemu w rundzie",player_item_name[id])
	}
	if (rannum == 142)
	{
		player_item_name[id] = "Ecru Citrine"
		player_item_id[id] = rannum
		player_b_ecrucitrine[id] = random_num(2,7)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz 1\%i szans na odwrocenie ekranu przeciwnika na 3 sekundy",player_item_name[id],player_b_ecrucitrine[id])
	}
	if (rannum == 143)
	{
		player_item_name[id] = "Scrapper`s Compendium"
		player_item_id[id] = rannum
		player_b_scrapper[id] = random_num(200,3000)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Mozesz sie odepchnac z sila %i jednostek",player_item_name[id],player_b_scrapper[id])
	}
	if (rannum == 144)
	{
		player_item_name[id] = "Scroll Of Transcendence"
		player_item_id[id] = rannum
		player_b_transcendence[id] = random_num(1,2)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz 1\%i szans na zabranie kamizelki wroga",player_item_name[id],player_b_transcendence[id])
	}	
	if (rannum == 145)
	{
		player_item_name[id] = "Commodity Deed Worth"
		player_item_id[id] = rannum
		player_b_commodity[id] = random_num(1,3)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Przez %i sekund masz natychmiastowe zabicie ze wszystkich broni",player_item_name[id],player_b_commodity[id])
	}
	if (rannum == 146)
	{
		player_item_name[id] = "Skystone Shard"
		player_item_id[id] = rannum
		player_b_shard[id] = random_num(1,3)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz 1\%i szans na zwiekszenie grawitacji wroga",player_item_name[id],player_b_shard[id])
	}
	if (rannum == 147)
	{
		player_item_name[id] = "Mesanna Roulette"
		player_item_id[id] = rannum
		player_b_instantxm1014[id] = random_num(2,8)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz 1\%i szans na natychmiastowe zabici z XM1014",player_item_name[id],player_b_instantxm1014[id])
	}
	if (rannum == 148)
	{
		player_item_name[id] = "Stolen Bottles Of Liquor"
		player_item_id[id] = rannum
		player_b_instantak47[id] = random_num(3,7)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz 1\%i szans na natychmiastowe zabici z AK47",player_item_name[id],player_b_instantak47[id])
	}
	if (rannum == 149)
	{
		player_item_name[id] = "Stern Anchor Of The Bmv Ararat"
		player_item_id[id] = rannum
		player_b_instantm4a1[id] = random_num(3,7)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz 1\%i szans na natychmiastowe zabicie z M4A1",player_item_name[id],player_b_instantm4a1[id])
	}
	if (rannum == 150)
	{
		player_item_name[id] = "Shroud Of Tal`keesh"
		player_item_id[id] = rannum
		player_b_instantjuki[id] = random_num(5,16)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz 1\%i szans na natychmiastowe zabici z kazdej broni",player_item_name[id],player_b_instantjuki[id])
	}
	if (rannum == 151)
	{
		player_item_name[id] = "Proof Of A Completed Assignment"
		player_item_id[id] = rannum
		player_b_assignment[id] = random_num(5,20)
		player_b_jumpx[id] = 8
		set_user_health(id,get_user_health(id)+player_b_assignment[id])
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz 8 podskokow i dodatkowo %i Hp",player_item_name[id],player_b_assignment[id])
	}
	if (rannum == 152)
	{
		player_item_name[id] = "Staff Of The Magi"
		player_item_id[id] = rannum
		player_b_themagi[id] = random_num(5,25)
		set_user_health(id,get_user_health(id)/2)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Tracisz polowe hp, zadajesz +%i wiecej dmg",player_item_name[id],player_b_themagi[id])
	}
	if (rannum == 153)
	{
		player_item_name[id] = "Crystalline Blackrock"
		player_item_id[id] = rannum
		player_b_blackrock[id] = random_num(3,9)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Masz 1\%i szans na natychmiastowe zabicie z MAC10 lub TMP",player_item_name[id],player_b_blackrock[id])
	}
	if (rannum == 154)
	{
		player_item_name[id] = "Tome Of Necromantic Ensorcelment"
		player_item_id[id] = rannum
		player_b_tome[id] = random_num(1,18)
		show_hudmessage(id, "Znalazles przedmiot: %s :: Item testowy",player_item_name[id],player_b_tome[id])
	}
	//Set durability, make this item dependant?
	item_durability[id] = 250
	
	
	return PLUGIN_CONTINUE
}

/* UNIQUE ITEMS ============================================================================================ */
//Names are generated from an array

public award_unique_item(id)
{
	new Unique_names_Suffix[10][100]
	new Unique_names_Prefix[10][100]
	
	Unique_names_Suffix[1] = "Swiety Amulet "
	Unique_names_Suffix[2] = "Swiety Miecz "
	Unique_names_Suffix[3] = "Mala Rozdzka "
	Unique_names_Suffix[4] = "Jasna Linia "
	Unique_names_Suffix[5] = "Lsniace Berlo "
	
	Unique_names_Prefix[1] = "gwiazd"
	Unique_names_Prefix[2] = "wladzy"
	Unique_names_Prefix[3] = "inteligencji"
	Unique_names_Prefix[4] = "zycia"
	Unique_names_Prefix[5] = "slonca"
	
	//Generate the items name
	
	new roll_1 = random_num(1,4)
	new roll_2 = random_num(1,4)
	
	new Unique_name[100]
	add(Unique_name,99,Unique_names_Suffix[roll_1])
	add(Unique_name,99,Unique_names_Prefix[roll_2])
	
	player_item_name[id] = Unique_name
	player_item_id[id] = 100				
	
	//Generate and apply the stats
	
	if (roll_1 == 1) player_b_damage[id] = random_num(1,5)
	if (roll_1 == 2) player_b_vampire[id] = random_num(1,5)
	if (roll_1 == 3) player_b_money[id] = random_num(2500,5000)
	if (roll_1 == 4) player_b_reduceH[id] = random_num(20,50)
	if (roll_1 == 5) player_b_blind[id] = random_num(3,5)
	
	
	
	if (roll_2 == 1) player_b_grenade[id] = random_num(1,4)
	if (roll_2 == 2) player_b_respawn[id] = random_num(2,4)
	if (roll_2 == 3) player_b_explode[id] = random_num(150,400)
	if (roll_2 == 4) player_b_redirect[id] = random_num(5,10)
	if (roll_2 == 5) player_b_heal[id] = random_num(1,15)
	
	item_durability[id] = 350
	
	set_hudmessage(220, 115, 70, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
	show_hudmessage(id, "Znalazles niespotykany item: %s", Unique_name)
	
}
/* EFFECTS ================================================================================================= */
public add_szkielet_bonus(id,damage,attacker_id)
{
	if (szkielet_damage[attacker_id] > 0)
	{
		if (get_user_health(id) > szkielet_damage[attacker_id])
		{
			set_user_health(id,get_user_health(id) - szkielet_damage[attacker_id]-player_intelligence[id]/2-player_powerint[id]/2)
			
			if (random_num(1,2) == 1) Effect_Bleed(id,248)
		} 
		else 
		{
			set_user_health(id,random_num(1,5))
		}
	}
}
/* ==================================================================================================== */

public add_oven_bonus(id,damage,attacker_id)
{
	if (player_b_oven[attacker_id] > 0)
	{
		if (get_user_health(id) > player_b_oven[attacker_id])
		{
			set_user_health(id,get_user_health(id) - player_b_oven[attacker_id]-player_intelligence[id]-player_powerint[id])
			
			if (random_num(1,2) == 1) Effect_Bleed(id,248)
		} 
		else 
		{
			set_user_health(id,random_num(1,5))
		}
	}
}
/* ==================================================================================================== */

public add_silverdamage_bonus(id,damage,attacker_id)
{
	if (player_b_silver[attacker_id] > 0)
	{
		if (get_user_health(id) > player_b_silver[attacker_id])
		{
			set_user_health(id,get_user_health(id) - player_b_silver[attacker_id])
			
			if (random_num(1,2) == 1) Effect_Bleed(id,248)
		} 
		else 
		{
			set_user_health(id,random_num(1,5))
		}
	}
}
/* ==================================================================================================== */

public add_themagidamage_bonus(id,damage,attacker_id)
{
	if (player_b_themagi[attacker_id] > 0)
	{
		if (get_user_health(id) > 100)
		{
			set_user_health(id,get_user_health(id) - player_b_themagi[attacker_id])
			
			if (random_num(1,2) == 1) Effect_Bleed(id,248)
		} 
		else 
		{
			set_user_health(id,random_num(1,5))
		}
	}
}
/* ==================================================================================================== */

public add_damage_bonus(id,damage,attacker_id)
{
	if (player_b_damage[attacker_id] > 0)
	{
		if (get_user_health(id) > player_b_damage[attacker_id])
		{
			set_user_health(id,get_user_health(id) - player_b_damage[attacker_id])
			
			if (random_num(1,2) == 1) Effect_Bleed(id,248)
		} 
		else 
		{
			set_user_health(id,random_num(1,5))
		}
	}
}

/* ==================================================================================================== */

public add_vampire_bonus(id,damage,attacker_id)
{
	if (player_b_vampire[attacker_id] > 0)
	{
		new maxhealth = 100+player_strength[attacker_id]*2
		
		
		if (get_user_health(attacker_id)+player_b_vampire[attacker_id] <= maxhealth)
		{
			set_user_health(attacker_id,get_user_health(attacker_id)+player_b_vampire[attacker_id])
		} 
		else 
		{
			set_user_health(attacker_id,maxhealth)
		}
	}
}

/* ==================================================================================================== */

public add_money_bonus(id)
{
	if (player_b_money[id] > 0)
	{
		if (cs_get_user_money(id) < 16000 - player_b_money[id]+player_intelligence[id]*50+player_powerint[id]*50) 
		{
			cs_set_user_money(id,cs_get_user_money(id)+ player_b_money[id]+player_intelligence[id]*50+player_powerint[id]*50) 
		} 
		else 
		{
			cs_set_user_money(id,16000)
		}
	}
}

/* ==================================================================================================== */

public add_gravity_bonus(id)
{
	if (player_b_gravity[id] > 0)
	{
		if (player_b_gravity[id] > 6)
			set_user_gravity(id,0.8)		
		if (player_b_gravity[id] > 4)
		{
			set_user_gravity(id,0.6)		
		}
		if (player_b_gravity[id] >= 1)
		{
			set_user_gravity(id,0.4)		
		}
	}
}
/* ==================================================================================================== */

public add_terathan_bonus(id,attacker_id,weapon)
{
	if (player_class[attacker_id] == TERATHAN && get_user_team(attacker_id) != get_user_team(id) && weapon == CSW_HEGRENADE && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)	//Fireshield check
	{
		
		set_user_health(id, 0)
		message_begin( MSG_ALL, gmsgDeathMsg,{0,0,0},0) 
		write_byte(attacker_id) 
		write_byte(id) 
		write_byte(0) 
		write_string("grenade") 
		message_end() 
		set_user_frags(attacker_id, get_user_frags(attacker_id)+1) 
		set_user_frags(id, get_user_frags(id)+1)
		cs_set_user_money(attacker_id, cs_get_user_money(attacker_id)+150) 
		
	}
}
/* ==================================================================================================== */

public add_grenade_bonus(id,attacker_id,weapon)
{
	if (player_b_grenade[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && weapon == CSW_HEGRENADE && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)	//Fireshield check
	{
		new roll = random_num(1,player_b_grenade[attacker_id])
		if (roll == 1)
		{
			set_user_health(id, 0)
			message_begin( MSG_ALL, gmsgDeathMsg,{0,0,0},0) 
			write_byte(attacker_id) 
			write_byte(id) 
			write_byte(0) 
			write_string("grenade") 
			message_end() 
			set_user_frags(attacker_id, get_user_frags(attacker_id)+1) 
			set_user_frags(id, get_user_frags(id)+1)
			cs_set_user_money(attacker_id, cs_get_user_money(attacker_id)+150) 
		}
	}
}

/* ==================================================================================================== */

public add_redhealth_bonus(id)
{
	if (player_b_reduceH[id] > 0)
		set_user_health(id,100-player_b_reduceH[id])
}

/* ==================================================================================================== */

public add_theif_bonus(id,attacker_id)
{
	if (player_b_theif[attacker_id] > 0)
	{
		new roll1 = random_num(1,5)
		if (roll1 == 1)
		{
			if (cs_get_user_money(id) > player_b_theif[attacker_id])
			{
				cs_set_user_money(id,cs_get_user_money(id)-player_b_theif[attacker_id])
				if (cs_get_user_money(attacker_id) + player_b_theif[attacker_id] <= 16000)
				{
					cs_set_user_money(attacker_id,cs_get_user_money(id)+player_b_theif[attacker_id])		
				}
			}
			else
			{
				new allthatsleft = cs_get_user_money(id)
				cs_set_user_money(id,0)
				if (cs_get_user_money(attacker_id) + allthatsleft <= 16000)
				{
					cs_set_user_money(attacker_id,cs_get_user_money(attacker_id) + allthatsleft)			
				}
			}
		}
	}
}

/* ==================================================================================================== */
public add_respawn_lizardmen(id)
{
	if (player_class[id] == LIZARDMEN)
	{
		new svIndex[32] 
		num_to_str(id,svIndex,32)
		new roll = random_num(1,2)
		if (roll == 1)
		{
			new maxpl,players[32]
			get_players(players, maxpl) 
			if (maxpl > 2)
			{
				cs_set_user_money(id,cs_get_user_money(id)+4000)
				set_task(0.5,"respawn",0,svIndex,32) 		
			}
			else
			{
				set_hudmessage(220, 115, 70, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
				show_hudmessage(id, "Minimum 2 graczy na poprawny respawn")	
			}
			
		}
	}
}
public add_respawn_bonus(id)
{
	if (player_b_respawn[id] > 0)
	{
		new svIndex[32] 
		num_to_str(id,svIndex,32)
		new roll = random_num(1,player_b_respawn[id])
		if (roll == 1)
		{
			new maxpl,players[32]
			get_players(players, maxpl) 
			if (maxpl > 2)
			{
				cs_set_user_money(id,cs_get_user_money(id)+4000)
				set_task(0.5,"respawn",0,svIndex,32) 		
			}
			else
			{
				set_hudmessage(220, 115, 70, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
				show_hudmessage(id, "Minimum 2 graczy na poprawny respawn")	
			}
			
		}
	}
}

public respawn(svIndex[]) 
{ 
	new vIndex = str_to_num(svIndex) 
	spawn(vIndex);
}

/* ==================================================================================================== */

public add_bonus_explode(id)
{
	if (player_b_explode[id] > 0)
	{
		
		new origin[3] 
		get_user_origin(id,origin) 
		explode(origin,id,0)
		
		
		for(new a = 0; a < MAX; a++) 
		{ 
			if (!is_user_connected(a) || !is_user_alive(a) || player_b_fireshield[a] != 0 || player_class[a] == DRAGONAN || get_user_team(a) == get_user_team(id))
				continue	
			
			new origin1[3]
			get_user_origin(a,origin1) 
			
			if(get_distance(origin,origin1) < player_b_explode[id] + player_intelligence[id]*2+player_powerint[id])
			{
				new dam = 75-(player_dextery[a]*2)
				
				if (get_user_health(a) - dam < 5)
					UTIL_Kill(id,a,"grenade")	
				else
				{
					set_user_health(a,get_user_health(a)-dam)
					Display_Fade(id,2600,2600,0,255,0,0,15)
				}
			}
		}
	}
}

public explode(vec1[3],playerid, trigger)
{ 
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec1) 
	write_byte( 21 ) 
	write_coord(vec1[0]) 
	write_coord(vec1[1]) 
	write_coord(vec1[2] + 32) 
	write_coord(vec1[0]) 
	write_coord(vec1[1]) 
	write_coord(vec1[2] + 1000)
	write_short( sprite_white ) 
	write_byte( 0 ) 
	write_byte( 0 ) 
	write_byte( 3 ) 
	write_byte( 10 ) 
	write_byte( 0 ) 
	write_byte( 188 ) 
	write_byte( 220 ) 
	write_byte( 255 ) 
	write_byte( 255 ) 
	write_byte( 0 ) 
	message_end() 
	
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY) 
	write_byte( 12 ) 
	write_coord(vec1[0]) 
	write_coord(vec1[1]) 
	write_coord(vec1[2]) 
	write_byte( 188 ) 
	write_byte( 10 ) 
	message_end() 
	
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec1) 
	write_byte( 3 ) 
	write_coord(vec1[0]) 
	write_coord(vec1[1]) 
	write_coord(vec1[2]) 
	write_short( sprite_fire ) 
	write_byte( 65 ) 
	write_byte( 10 ) 
	write_byte( 0 ) 
	message_end() 
	
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY,{0,0,0},playerid) 
	write_byte(107) 
	write_coord(vec1[0]) 
	write_coord(vec1[1]) 
	write_coord(vec1[2]) 
	write_coord(175) 
	write_short (sprite_gibs) 
	write_short (25)  
	write_byte (10) 
	message_end() 
	if (trigger == 1)
	{
		set_user_rendering(playerid,kRenderFxNone, 0,0,0, kRenderTransAdd,0) 
	}
}

/* ==================================================================================================== */

public add_bonus_gamble(id)
{	
	if (player_b_gamble[id] > 0 && is_user_alive(id))
	{
		reset_item_skills(id)
		set_hudmessage(220, 115, 70, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
		new roll = random_num(1,player_b_gamble[id])
		if (roll == 1)
		{
			show_hudmessage(id, "Round bonus: +5 damage")
			player_b_damage[id] = 5
		}
		if (roll == 2)
		{
			show_hudmessage(id, "Round bonus: +5 Gravity bonus")
			player_b_gravity[id] = 5
		}
		if (roll == 3)
		{
			show_hudmessage(id, "Round bonus: +5 vampyric damage")
			player_b_vampire[id] = 5
		}
		if (roll == 4)
		{
			show_hudmessage(id, "Round bonus: +10 Heal bonus every 5 seconds")
			player_b_heal[id] = 10
		}
		if (roll == 5)
		{
			show_hudmessage(id, "Round bonus: 1/3 chance to instant HE kill")
			player_b_grenade[id] = 3
		}
	}
}

/* ==================================================================================================== */

public add_bonus_blind(id,attacker_id,weapon,damage)
{
	if (player_b_blind[attacker_id] > 0 && weapon != 4)
	{
		new roll = random_num(1,player_b_blind[attacker_id])
		if (roll == 1)
		{
			message_begin(MSG_ONE,gmsgFade,{0,0,0},id)
			write_short( 1<<14 ) 
			write_short( 1<<14 ) 
			write_short( 1<<16 ) 
			write_byte( 255 ) 
			write_byte( 155 ) 
			write_byte( 50 ) 
			write_byte( 230 ) 
			message_end()
		}
		
	}
}

/* ==================================================================================================== */

public item_c4fake(id)
{ 
	if (c4state[id] > 1)
	{
		hudmsg(id,2.0,"Meekestone mozesz uzyc raz na runde")
		return PLUGIN_CONTINUE 
	}
	
	if (player_b_meekstone[id] > 0 && c4state[id] == 1 && is_user_alive(id) == 1 && freeze_ended == true)
	{
		explode(c4bombc[id],id,0)
		
		for(new a = 0; a < MAX; a++) 
		{ 
			if (is_user_connected(a) && is_user_alive(a))
			{			
				new origin1[3]
				get_user_origin(a,origin1) 
				
				if(get_distance(c4bombc[id],origin1) < 300 && get_user_team(a) != get_user_team(id))
				{
					UTIL_Kill(id,a,"grenade")
				}
			}
		}
		
		c4state[id] = 2
		remove_entity(c4fake[id])
		c4fake[id] = 0 
	}
	
	if (player_b_meekstone[id] > 0 && c4state[id] == 0 && c4fake[id] == 0 && is_user_alive(id) == 1 && freeze_ended == true)
	{
		new Float:pOrigin[3]
		entity_get_vector(id,EV_VEC_origin, pOrigin)
		c4fake[id] = create_entity("info_target")
		
		entity_set_model(c4fake[id],"models/w_backpack.mdl")
		entity_set_origin(c4fake[id],pOrigin)
		entity_set_string(c4fake[id],EV_SZ_classname,"fakec4")
		entity_set_edict(c4fake[id],EV_ENT_owner,id)
		entity_set_int(c4fake[id],EV_INT_movetype,6)
		
		
		new Float:aOrigin[3]
		entity_get_vector(c4fake[id],EV_VEC_origin, aOrigin)
		c4bombc[id][0] = floatround(aOrigin[0])
		c4bombc[id][1] = floatround(aOrigin[1])
		c4bombc[id][2] = floatround(aOrigin[2])
		c4state[id] = 1
	}
	
	return PLUGIN_CONTINUE 
}
/* ==================================================================================================== */

public item_fireball(id)
{
	if (fired[id] > 0)
	{
		hudmsg(id,2.0,"Mozesz uzyc jednego fireballa na runde!")
		return PLUGIN_HANDLED
	}
	
	if (fired[id] == 0 && player_b_fireball[id] > 0 || player_class[id] == SORC && is_user_alive(id) == 1)
	{
		fired[id] = 1
		new Float:vOrigin[3]
		new fEntity
		entity_get_vector(id,EV_VEC_origin, vOrigin)
		fEntity = create_entity("info_target")
		entity_set_model(fEntity, "models/rpgrocket.mdl")
		entity_set_origin(fEntity, vOrigin)
		entity_set_int(fEntity,EV_INT_effects,64)
		entity_set_string(fEntity,EV_SZ_classname,"fireball")
		entity_set_int(fEntity,EV_INT_movetype,5)
		entity_set_edict(fEntity,EV_ENT_owner,id)
		
		//Send forward
		new Float:fl_iNewVelocity[3]
		VelocityByAim(id, 900, fl_iNewVelocity)
		entity_set_vector(fEntity, EV_VEC_velocity, fl_iNewVelocity)
		
		
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY) 
		write_byte(22) 
		write_short(fEntity) 
		write_short(sprite_beam) 
		write_byte(45) 
		write_byte(4) 
		write_byte(255) 
		write_byte(0) 
		write_byte(0) 
		write_byte(40)
		message_end() 
	}	
	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

public add_bonus_redirect(id)
{
	if (player_b_redirect[id] > 0)
	{
		if (get_user_health(id)+player_b_redirect[id] <= 100)
		{
			set_user_health(id,get_user_health(id)+player_b_redirect[id])
		}
		
	}
}
/* ==================================================================================================== */

public add_bonus_wizard(id)
{
	if (player_b_wizard[id] > 0)
	{
		if (get_user_health(id)+get_user_health(id)/2 <= 100)
		{
			set_user_health(id,get_user_health(id)+get_user_health(id)/2)
		}
		
	}
}
/* ==================================================================================================== */

public item_ghost(id)
{
	if (ghoststate[id] == 0 && player_b_ghost[id] > 0 && is_user_alive(id) && !ghost_check)
	{
		set_user_noclip(id,1)
		ghoststate[id] = 2
		ghosttime[id] = floatround(halflife_time())
		ghost_check = true
		
		message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id ) 
		write_byte( player_b_ghost[id]+1 ) 
		write_byte( 0 ) 
		message_end() 
	}
	else
	{
		hudmsg(id,3.0,"Tylko jeden gracz moze skorzystac z mozliwosci przechodzenia przez sciany w jednym czasie")
	}
}

/* ==================================================================================================== */

public add_strength_bonus(id)
{
	set_user_health(id,100+player_strength[id]*2)
}

/* ==================================================================================================== */

public add_bonus_darksteel(attacker,id,damage)
{
	if (player_b_darksteel[attacker] > 0)
	{
		if (UTIL_In_FOV(attacker,id) && !UTIL_In_FOV(id,attacker))
		{
			
			new dam = floatround (15+player_strength[id]*2*player_b_darksteel[id]/10.0)
			
			Effect_Bleed(id,248)
			Hurt_Entity(attacker,id,dam+0.0)
		}
	}
}

/* ==================================================================================================== */

public item_eye(id)
{
	if (player_b_eye[id] == -1)
	{
		//place camera
		new Float:playerOrigin[3]
		entity_get_vector(id,EV_VEC_origin,playerOrigin)
		new ent = create_entity("info_target") 
		entity_set_string(ent, EV_SZ_classname, "PlayerCamera") 
		entity_set_int(ent, EV_INT_movetype, MOVETYPE_NOCLIP) 
		entity_set_int(ent, EV_INT_solid, SOLID_NOT) 
		entity_set_edict(ent, EV_ENT_owner, id)
		entity_set_model(ent, "models/rpgrocket.mdl")  				//Just something
		entity_set_origin(ent,playerOrigin)
		entity_set_int(ent,EV_INT_iuser1,0)		//Viewing through this camera						
		set_rendering (ent,kRenderFxNone, 0,0,0, kRenderTransTexture,0)
		entity_set_float(ent,EV_FL_nextthink,halflife_time() + 0.01) 
		player_b_eye[id] = ent
	}
	else
	{
		//view through camera or stop viewing
		new ent = player_b_eye[id]
		if (!is_valid_ent(ent))
		{
			attach_view(id,id)
			return PLUGIN_HANDLED
		}
		new viewing = entity_get_int(ent,EV_INT_iuser1)
		
		if (viewing) 
		{	
			entity_set_int(ent,EV_INT_iuser1,0)
			attach_view(id,id)
		}	
		else 
		{
			entity_set_int(ent,EV_INT_iuser1,1)
			attach_view(id,ent)
		}
	}
	
	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

//Called when PlayerCamera thinks
public Think_PlayerCamera(ent)
{
	new id = entity_get_edict(ent,EV_ENT_owner)
	
	//Check if player is still having the item and is still online
	if (!is_valid_ent(id) || player_b_eye[id] == 0 || !is_user_connected(id))
	{
		//remove entity
		if (is_valid_ent(id) && is_user_connected(id)) attach_view(id,id)
		remove_entity(ent)
	}
	else
	{
		//Dont use cpu when not alive anyway or not viewing
		if (!is_user_alive(id))
		{
			entity_set_float(ent,EV_FL_nextthink,halflife_time() + 3.0) 
			return PLUGIN_HANDLED
		}
		
		if (!entity_get_int(ent,EV_INT_iuser1))
		{
			entity_set_float(ent,EV_FL_nextthink,halflife_time() + 0.5) 
			return PLUGIN_HANDLED
		}
		
		entity_set_float(ent,EV_FL_nextthink,halflife_time() + 0.01) 
		
		//Find nearest player to camera
		new Float:pOrigin[3],Float:plOrigin[3],Float:ret[3]
		entity_get_vector(ent,EV_VEC_origin,plOrigin)
		new Float:distrec = 2000.0, winent = -1
		
		for (new i=0; i<MAX; i++) 
		{
			if (is_user_connected(i) && is_user_alive(i))
			{
				entity_get_vector(i,EV_VEC_origin,pOrigin)
				pOrigin[2]+=10.0
				if (trace_line ( 0, plOrigin, pOrigin, ret ) == i && vector_distance(pOrigin,plOrigin) < distrec)
				{
					winent = i
					distrec = vector_distance(pOrigin,plOrigin)
				}
			}	
		}
		
		//Traceline and updown is still revresed
		if (winent > -1)
		{
			new Float:toplayer[3], Float:ideal[3],Float:pOrigin[3]
			entity_get_vector(winent,EV_VEC_origin,pOrigin)
			pOrigin[2]+=10.0
			toplayer[0] = pOrigin[0]-plOrigin[0]
			toplayer[1] = pOrigin[1]-plOrigin[1]
			toplayer[2] = pOrigin[2]-plOrigin[2]
			vector_to_angle ( toplayer, ideal ) 
			ideal[0] = ideal[0]*-1
			entity_set_vector(ent,EV_VEC_angles,ideal)
		}
	}
	
	return PLUGIN_CONTINUE
}

public Create_Line(id,origin1[3],origin2[3],bool:draw)
{
	if (draw)
	{
		message_begin(MSG_ONE,SVC_TEMPENTITY,{0,0,0},id)
		write_byte(0)
		write_coord(origin1[0])	// starting pos
		write_coord(origin1[1])
		write_coord(origin1[2])
		write_coord(origin2[0])	// ending pos
		write_coord(origin2[1])
		write_coord(origin2[2])
		write_short(sprite_line)	// sprite index
		write_byte(1)		// starting frame
		write_byte(5)		// frame rate
		write_byte(2)		// life
		write_byte(3)		// line width
		write_byte(0)		// noise
		write_byte(255)	// RED
		write_byte(50)	// GREEN
		write_byte(50)	// BLUE					
		write_byte(155)		// brightness
		write_byte(5)		// scroll speed
		message_end()
	}
	
	new Float:ret[3],Float:fOrigin1[3],Float:fOrigin2[3]
	//So we dont hit ourself
	origin1[2]+=50
	IVecFVec(origin1,fOrigin1)
	IVecFVec(origin2,fOrigin2)
	new hit = trace_line ( 0, fOrigin1, fOrigin2, ret )
	return hit
	
}

/* ==================================================================================================== */

public Prethink_Blink(id)
{
	if( get_user_button(id) & IN_ATTACK2 && !(get_user_oldbutton(id) & IN_ATTACK2) && is_user_alive(id)) 
	{			
		new clip, ammo
		new weapon = get_user_weapon(id,clip,ammo)
		
		if (weapon == CSW_KNIFE)
		{
			if (halflife_time()-player_b_blink[id] <= 3) return PLUGIN_HANDLED		
			player_b_blink[id] = floatround(halflife_time())	
			UTIL_Teleport(id,300+15*player_intelligence[id]+player_powerint[id]*15)			
		}
	}
	return PLUGIN_CONTINUE
}

/* ==================================================================================================== */


//Called on end or mapchange -- Save items for players
public plugin_end() 
{
	new Datafile[64], amxbasedir[64]
	//build_path(Datafile,63,"$basedir/diablo/datafile.txt") 
	
	get_basedir(amxbasedir,63)
	format(Datafile,63,"%s/diablo/datafile.txt",amxbasedir)
	
	if(file_exists(Datafile)) delete_file(Datafile)
	
	//Write name and item for each player
	for (new i=0; i < MAX; i++)
	{
		if (player_dc_item[i] > 0 && player_dc_item[i] != 100) //unique
		{
			new data[100]
			format(data,99,"%s^"%i^"",player_dc_name[i],player_dc_item[i])
			write_file(Datafile,data)
		}
	}
}

/* ==================================================================================================== */

public handle_mapchange(id)
{
	if (!itemrestore) 
		return PLUGIN_HANDLED
	
	if (!updatedtable)
		updateitemtable()
	
	new currentname[32]
	get_user_name(id,currentname,31)
	
	for (new i=0; i < MAX; i++)
	{
		if (player_c_item[i] > 0)
		{
			if (equal(currentname,player_c_name[i]))
				award_item(id,player_c_item[i])
		}
	}
	
	return PLUGIN_CONTINUE
}

/* ==================================================================================================== */

public DisableItemRestore()
{
	itemrestore = false
}

/* ==================================================================================================== */

public updateitemtable()
{
	if (get_cvar_num("diablo_saveitems") == 0)
		return PLUGIN_HANDLED
	
	new Datafile[64], amxbasedir[64]
	
	get_basedir(amxbasedir,63)
	format(Datafile,63,"%s/diablo/datafile.txt",amxbasedir)
	
	
	if(file_exists(Datafile)) 
	{
		new linenum = 0
		new linedata[100]
		new readlen = 0
		while (read_file ( Datafile, linenum, linedata, 99, readlen ) != 0)
		{
			linenum++
			
			if (linenum > MAX+1)
			{
				//More entries than players, abort
				log_amx("More than %i entries in Datafile, aborting table update",linenum)
				return PLUGIN_HANDLED
			}
			
			new linebreak = contain ( linedata, "^"" )
			
			if (strlen(linedata) < linebreak+1)
				continue
			
			new itembreak = contain (linedata[linebreak+1], "^"")
			
			if (linebreak > -1 && itembreak > -1)
			{
				
				new name[50]
				new item[50]
				
				copyc ( name, linebreak, linedata, '"' ) 
				copyc ( item, itembreak, linedata[linebreak+1],'"')
				
				player_c_name[linenum-1] = name
				player_c_item[linenum-1] = str_to_num(item)	
			}
		}
		
		updatedtable = true
	}
	
	return PLUGIN_CONTINUE
}

/* ==================================================================================================== */

public item_convertmoney(id)
{
	new maxhealth = 100+player_strength[id]*2
	
	if (cs_get_user_money(id) < 1000)
		hudmsg(id,2.0,"Nie masz tyle pieniedzy aby zamienic je na zycie")
	else if (get_user_health(id) == maxhealth)
		hudmsg(id,2.0,"Masz maksymalne zycie")
	else
	{
		cs_set_user_money(id,cs_get_user_money(id)-1000)
		
		if (get_user_health(id)+15<= maxhealth)
			set_user_health(id,get_user_health(id)+15)
		else 
			set_user_health(id,maxhealth)	
		
		Display_Fade(id,2600,2600,0,0,255,0,15)
	}
}

public item_windwalk(id)
{
	//First time this round
	if (player_b_usingwind[id] == 0)
	{
		new szId[10]
		num_to_str(id,szId,9)
		player_b_usingwind[id] = 1
		set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,75)
		engclient_cmd(id,"weapon_knife") 
		set_user_maxspeed(id,500.0)
		
		new Float:val = player_b_windwalk[id] + 0.0
		set_task(val,"resetwindwalk",0,szId,32) 
		
		message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id ) 
		write_byte( player_b_windwalk[id]) 
		write_byte( 0 ) 
		message_end() 
	}
	
	//Disable again
	else if (player_b_usingwind[id] == 1)
	{
		set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,255)
		player_b_usingwind[id] = 2
		set_user_maxspeed(id,270.0)
		message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id ) 
		write_byte( 0) 
		write_byte( 0 ) 
		message_end() 
	}
	
	//Already used
	else if (player_b_usingwind[id] == 2)
	{
		set_hudmessage(220, 30, 30, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
		show_hudmessage(id, "You can only use this item once a turn") 
	}
	
}

public resetwindwalk(szId[])
{
	new id = str_to_num(szId)
	if (id < 0 || id > MAX)
	{
		log_amx("Error in resetwindwalk, id: %i out of bounds", id)
	}
	
	if (player_b_usingwind[id] == 1)
	{
		player_b_usingwind[id] = 2
		set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,255)	
		set_user_maxspeed(id,270.0)
		message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id ) 
		write_byte( 0) 
		write_byte( 0 ) 
		message_end() 
	}
	
}

/* ==================================================================================================== */

public Prethink_usingwind(id)
{
	
	if( get_user_button(id) & IN_ATTACK && is_user_alive(id))
	{
		new buttons = pev(id,pev_button)
		set_pev(id,pev_button,(buttons & ~IN_ATTACK));
		return FMRES_HANDLED;	
	}
	
	if( get_user_button(id) & IN_ATTACK2 && is_user_alive(id))
	{
		new buttons = pev(id,pev_button)
		set_pev(id,pev_button,(buttons & ~IN_ATTACK2));
		return FMRES_HANDLED;	
	}
	
	return PLUGIN_CONTINUE
}
/* ==================================================================================================== */
public add_bonus_toxic(attacker_id,id)
{
	if(player_b_toxic[attacker_id] > 0 && (random_num(1,player_b_toxic[attacker_id]) == 1) && get_user_team(attacker_id) != get_user_team(id) && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{
		
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		NE_ULT_Entangle(id)
		zatakowany[id] = 1
		
	}
	return PLUGIN_HANDLED
}
stock Create_TE_BEAMFOLLOW(entity, iSprite, life, width, red, green, blue, alpha){
	
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
	write_byte( TE_BEAMFOLLOW )
	write_short( entity )                   // entity
	write_short( iSprite )                  // model
	write_byte( life )                              // life
	write_byte( width )                             // width
	write_byte( red )                               // red
	write_byte( green )                             // green
	write_byte( blue )                              // blue
	write_byte( alpha )                             // brightness
	message_end()
}
public Create_TE_BE(start[3], end[3],startFrame, frameRate, life, width, noise, red, green, blue, alpha, spid,sprite){
	
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
	write_byte( TE_BEAMPOINTS )
	write_coord( start[0] )
	write_coord( start[1] )
	write_coord( start[2] )
	write_coord( end[0] )
	write_coord( end[1] )
	write_coord( end[2] )
	write_short( sprite )                   // model
	write_byte( startFrame )                // start frame
	write_byte( frameRate )                 // framerate
	write_byte( life )                              // life
	write_byte( width )                             // width
	write_byte( noise )                             // noise
	write_byte( red )                               // red
	write_byte( green )                             // green
	write_byte( blue )                              // blue
	write_byte( alpha )                             // brightness
	write_byte( spid )                              // speed
	message_end()
}
public NE_ULT_Entangle(iEnemy )
{
	
	// Follow the user until they stop moving...
	Create_TE_BEAMFOLLOW( iEnemy, sprite_white, 5, 5, 250, 15, 15, 255 );
	new parm[4];
	parm[0] = iEnemy;
	parm[1] = 0;
	parm[2] = 0;
	parm[3] = 0;
	_NE_ULT_EntangleWait( parm );
	
}

// Wait for the user to stop moving
public _NE_ULT_EntangleWait( parm[4] )
{
	
	new id = parm[0];
	
	new vOrigin[3];
	get_user_origin( id, vOrigin );
	
	// Checking to see if the user has actually stopped yet?
	if ( vOrigin[0] == parm[1] && vOrigin[1] == parm[2] && vOrigin[2] == parm[3] )
	{
		NE_ULT_EntangleEffect( id )
	}
	else
	{
		parm[1] = vOrigin[0];
		parm[2] = vOrigin[1];
		parm[3] = vOrigin[2];
		
		set_task( 0.1, "_NE_ULT_EntangleWait", TASK_ENTANGLEWAIT + id, parm, 4 );
	}
	return;
}

public NE_ULT_EntangleEffect( id )
{
	if(!is_user_alive(id)) return 1;
	
	totemstop[id] = 1
	CurWeapon(id)
	set_task( 5.0, "off_zamroz",TASK_ENTANGLEWAIT + id)
	// Get the user's origin
	new vOrigin[3];
	get_user_origin( id, vOrigin );
	
	new iStart[3], iEnd[3], iHeight;
	new iRadius     = 20, iCounter = 0;
	new x1, y1, x2, y2;
	
	// Some sweet crap that I don't understand courtesy of SpaceDude - draws the "cylinder" around the player
	while ( iCounter <= 7 )
	{
		if ( iCounter == 0 || iCounter == 8 )
			x1 = -iRadius;
		else if ( iCounter == 1 || iCounter == 7 )
			x1 = -iRadius * 100/141;
		else if ( iCounter == 2 || iCounter == 6 )
			x1 = 0;
		else if ( iCounter == 3 || iCounter == 5 )
			x1 = iRadius*100/141
		else if ( iCounter == 4 )
			x1 = iRadius
		
		if ( iCounter <= 4 )
			y1 = sqroot( iRadius*iRadius-x1*x1 );
		else
			y1 = -sqroot( iRadius*iRadius-x1*x1 );
		
		++iCounter;
		
		if ( iCounter == 0 || iCounter == 8 )
			x2 = -iRadius;
		else if ( iCounter == 1 || iCounter==7 )
			x2 = -iRadius*100/141;
		else if ( iCounter == 2 || iCounter==6 )
			x2 = 0;
		else if ( iCounter == 3 || iCounter==5 )
			x2 = iRadius*100/141;
		else if ( iCounter == 4 )
			x2 = iRadius;
		
		if ( iCounter <= 4 )
			y2 = sqroot( iRadius*iRadius-x2*x2 );
		else
			y2 = -sqroot( iRadius*iRadius-x2*x2 );
		
		iHeight = 16 + 2 * iCounter;
		
		while ( iHeight > -40 )
		{
			
			iStart[0]       = vOrigin[0] + x1;
			iStart[1]       = vOrigin[1] + y1;
			iStart[2]       = vOrigin[2] + iHeight;
			iEnd[0]         = vOrigin[0] + x2;
			iEnd[1]         = vOrigin[1] + y2;
			iEnd[2]         = vOrigin[2] + iHeight + 2;
			
			Create_TE_BE( iStart, iEnd, 0, 0, 100, 10, 5, 10, 108, 23, 255, 0 ,sprite_beam);
			
			iHeight -= 16;
		}
	}
	
	return 0;
}
public off_zamroz(pid)
{
	pid -=TASK_ENTANGLEWAIT
	totemstop[pid] = 0
	zatakowany[pid] = 0
	set_user_maxspeed(pid,251.0+player_dextery[pid])
	CurWeapon(pid)
}
/* ==================================================================================================== */

public add_bonus_confuse(id,attacker_id)
{
	if (player_b_reverse[attacker_id] > 0 && !is_user_bot(id) && player_b_oldsen[id] == 0.0)
	{
		if (random_num(1,player_b_reverse[attacker_id]) == 1)
		{
			//Confuse the victim
			query_client_cvar(id, "sensitivity", "cvar_result_func"); 
			
			
			message_begin( MSG_ONE, get_user_msgid("StatusIcon"), {0,0,0}, id ) 
			write_byte( 1 )     
			write_string( "dmg_chem") 
			write_byte( 100 ) // red 
			write_byte( 100 ) // green 
			write_byte( 100 ) // blue 
			message_end()  
			
		}
		
	}
}

public cvar_result_func(id, const cvar[], const value[]) 
{ 
	player_b_oldsen[id] = str_to_float(value)
	new svIndex[32] 
	num_to_str(id,svIndex,32)
	set_task(2.5,"resetsens",0,svIndex,32) 		
	
	
}

public resetsens(svIndex[]) 
{ 
	new id = str_to_num(svIndex) 
	
	if (player_b_oldsen[id] > 0.0)
	{
		client_cmd(id,"sensitivity %f",player_b_oldsen[id])
		player_b_oldsen[id] = 0.0
	}
	
	message_begin( MSG_ONE, get_user_msgid("StatusIcon"), {0,0,0}, id ) 
	write_byte( 0 )     
	write_string( "dmg_chem") 
	write_byte( 100 ) // red 
	write_byte( 100 ) // green 
	write_byte( 100 ) // blue 
	message_end()  
	
	
} 


/* ==================================================================================================== */

public Prethink_confuseme(id)
{
	if (player_b_oldsen[id] > 0.0)
		client_cmd(id,"sensitivity %f", 25.0)
	
}

/* ==================================================================================================== */

public Findleader()
{
	//Finds a leader for both teams
	new numCT, numT, IDSCT[MAX], IDST[MAX]
	
	for (new i=0; i < MAX; i++)
	{
		if (is_user_connected(i) && is_user_alive(i))
		{
			new team[32]
			get_user_team(i,team,31)
			if (equal(team,"TERRORIST"))
			{
				IDST[numT] = i
				numT++
			}
			else if (equal(team,"CT"))
			{
				IDSCT[numCT] = i
				numCT++
			}
		}
	}
	
	LeaderCT = IDSCT[random_num(0,numCT)]
	LeaderT = IDST[random_num(0,numT)]
	
	//PowerUp system takes Position from leader as basic
	if (is_user_connected(LeaderCT) && is_user_connected(LeaderT))
	{
		get_user_origin(LeaderCT,CTstart,0)
		get_user_origin(LeaderT,Tstart,0)
		spawnset = true
	}
	
	set_hudmessage(60, 100, 25, -1.0, 0.25, 0, 1.0, 2.0, 0.1, 0.2, 2)
	show_hudmessage(LeaderCT, "Zostales wybrany jako lider. Ty i twoj team dostanie extra xp jesli przezyjesz") 
	show_hudmessage(LeaderT, "Zostales wybrany jako lider. Ty i twoj team dostanie extra xp jesli przezyjesz") 
	
}

/* ==================================================================================================== */

public Bot_Setup()
{
	for (new id=0; id < MAX; id++)
	{
		if (is_user_connected(id) && is_user_bot(id))
		{
			if (random_num(1,3) == 1 && player_item_id[id] > 0)
				client_cmd(id,"say /dropitem")
			
			while (player_point[id] > 0)
			{
				player_point[id]--
				switch(random_num(1,4))
				{
					case 1: {
						player_agility[id]++
					}
					case 2: {
						player_strength[id]++
					}
					case 3: {
						player_intelligence[id]++
					}
					case 4: {
						player_dextery[id]++
					}
				}
			}
		}
	}
}

/* ==================================================================================================== */

public host_killed(id)
{
	if (player_lvl[id] > 1)
	{
		hudmsg(id,2.0,"Straciles doswiadczenie za zabicie zakladnika!")
		
		if (player_xp[id]-get_cvar_num("diablo_xpbonus") < LevelXP[player_lvl[id]]-1)
			player_xp[id] = LevelXP[player_lvl[id]]-1
		else
			player_xp[id]-=get_cvar_num("diablo_xpbonus")
	}
	
}


/* ==================================================================================================== */
public showmenu(id)
{
	new menu = menu_create("\dOpcje", "option_menu")
	menu_additem(menu, "Informacje o Itemie")
	menu_additem(menu, "Wyrzuc Item")
	menu_additem(menu, "Pokaz Pomoc")
	menu_additem(menu, "Uzyj mocy Itemu")
	menu_additem(menu, "Kup Rune")
	menu_additem(menu, "Informacje o umiejetnosciach")	
	menu_additem(menu, "Pokaz liste itemow")
	menu_display(id, menu)
}

public option_menu(id, menu, item)
{
	switch(item)
	{
		case 0:	iteminfo(id)
			case 1: dropitem(id)
			case 2: helpme(id)
			case 3: Use_Spell(id)
			case 4: buyrune(id)
			case 5: showskills(id)
			case 6: showlistitems(id)
		}
	return PLUGIN_HANDLED
}
public showlistitems(id) client_cmd(id,"say /itemy")
public Prethink_froglegs(id)
{
	if (get_user_button(id) & IN_DUCK)
	{
		//start holding down button here, set to halflife time
		if (player_b_froglegs[id] == 1) 
		{
			player_b_froglegs[id] = floatround(halflife_time())
		}
		else
		{
			if (floatround(halflife_time())-player_b_froglegs[id] >= 2.0)
			{
				new Float:fl_iNewVelocity[3]
				VelocityByAim(id, 1000, fl_iNewVelocity)
				fl_iNewVelocity[2] = 210.0
				entity_set_vector(id, EV_VEC_velocity, fl_iNewVelocity)
				player_b_froglegs[id] = 1
			}
		}
	}
	else
	{
		player_b_froglegs[id] = 1
	}
}

/* ==================================================================================================== */
public select_class(id)
{
	new menu = menu_create("\dWybierz zespol", "wybierz_zespol")
	menu_additem(menu, "\rPremium")
	menu_additem(menu, "\wNormalne")
	menu_display(id, menu)
}
public wybierz_zespol(id, menu, item)
{
	switch(item)
	{
		case 0:  select_class_premium(id)
			case 1: select_class2(id)
		}
	return PLUGIN_HANDLED
}

public select_class_premium(id)
{
	new menu = menu_create("\dWybierz premium", "wybierz_premium")
	menu_additem(menu, "\yAriel")
	menu_additem(menu, "\yArachnid")
	menu_additem(menu, "\dInformacje o premium")
	menu_display(id, menu)
}
public wybierz_premium(id, menu, item)
{
	switch(item)
	{
		case 0: 
		{
			if(!(get_user_flags(id) & ADMIN_LEVEL_H))
			{
				client_print(id, print_chat, "[Diablo V9] Nie masz uprawnien, aby uzywac tej klasy.")
				select_class2(id)
				return PLUGIN_HANDLED;
			}
			player_class[id] = ARIEL
			return PLUGIN_CONTINUE;
		}
		case 1: 
		{
			if(!(get_user_flags(id) & ADMIN_LEVEL_H))
			{
				client_print(id, print_chat, "[Diablo V9] Nie masz uprawnien, aby uzywac tej klasy.")
				select_class2(id)
				return PLUGIN_HANDLED;
			}
			player_class[id] = ARACHNID
			set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,35)
			return PLUGIN_CONTINUE;	
		}
		case 2:
		{
			client_print(id,print_chat,"Ariel, tylko noz niewidzialny i szybki")
			client_print(id,print_chat,"Arachnid, mniej widoczny 1\1 z AWP")
			select_class2(id)
		}
	}
	return PLUGIN_HANDLED
}
public select_class2(id)
{
	new menu = menu_create("\dWybierz klase", "wybierz_klase")
	menu_additem(menu, "Sorcerer \r[\dWieksze obrazenia itemami, Posiada Fireball\r]")
	menu_additem(menu, "Paladin \r[\dBonus do Hp\r]")
	menu_additem(menu, "Monk \r[\dDostaje wiecej doswiadczenia\r]")
	menu_additem(menu, "Assassin \r[\dSzybki, nie slychac jego krokow\r]")
	menu_additem(menu, "Barbarian \r[\dZwraca Hp po zabiciu\r]")
	menu_additem(menu, "Necromancer \r[\dZwraca zadane mu obrazenia. Potrafi wskrzeszac\r]")	
	menu_additem(menu, "Ninja \r[\dNiewidzialny, ma tylko noz\r]")
	menu_additem(menu, "Amazonka \r[\dMa kusze\r]")
	menu_additem(menu, "Mefisto \r[\dMa dlugi noz, mniejsza widocznosc,+10hp\r]")
	menu_additem(menu, "Diablo \r[\dDostaje Losowa bron na start\r]")
	menu_additem(menu, "Szkielet \r[\dMa obrazenia zalezne od inteligence\r]")
	menu_additem(menu, "Dragonan \r[\dOdporny przed natychmiastowym zabiciem przez itemy\r]")
	menu_additem(menu, "Duchowny \r[\d5-35hp,1/2 z AWP, Malo widoczny\r]")
	menu_additem(menu, "Lizardmen \r[\dMa 1/2 Szans na respawn\r]")
	menu_additem(menu, "Juka \r[\dMa 1/10 z kazdej broni\r]")
	menu_additem(menu, "Savages \r[\dMoze teleportowac sie nozem, int zwiesza odleglosc\r]")
	menu_additem(menu, "Meer \r[\dMultijump zalezny od inteligencji, posiada totem leczacy\r]")
	menu_additem(menu, "Terathan \r[\dNatychmiastowe zabicie z HE, bonus do inteligencji, kevlar na start\r]")
	menu_additem(menu, "Ophidian \r[\dZa przezycie ma 5000$ i losowy item, jesli go nie ma\r]")
	menu_display(id, menu)
}

public wybierz_klase(id, menu, item)
{
	switch(item)
	{
		case 0:   
		{
			player_class[id] = SORC
			player_powerint[id] = 35
		}
		case 1: 
		{
			player_class[id] = PALADIN
			if (is_user_alive(id))
				set_user_health(id,get_user_health(id)+30)
		}
		case 2: player_class[id] = MONK
			case 3: player_class[id] = ASSASSIN
			case 4: player_class[id] = BARBARIAN
			case 5: player_class[id] = NECROMANCER
			case 6: 
		{
			player_class[id] = NINJA
			set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,9)
			set_user_health(id,get_user_health(id) +70)
			client_cmd(id,"weapon_knife")
		}
		case 7: 
		{
			player_class[id] = AMAZONKA
			ilosc_beltow[id] = 5+player_intelligence[id]/2;
		}
		case 8:
		{
			player_class[id] = MEFISTO
			if (is_user_alive(id))
				set_user_health(id,get_user_health(id)+10)
		}
		case 9:
		{
			player_class[id] = DIABLO
		}
		case 10:
		{
			player_class[id] = SZKIELET
			szkielet_damage[id] = 2
			if (is_user_alive(id))
				set_user_health(id,get_user_health(id)-5)
		}
		case 11: player_class[id] = DRAGONAN
			case 12:
		{
			player_class[id] = DUCHOWNY
			duchownyrandomhp[id] = random_num(5,35)
			duchownyrandominv[id] = random_num(25,50)
			if (is_user_alive(id))
			{
				set_user_health(id,duchownyrandomhp[id])
				set_user_rendering(id,kRenderFxNone, 0,0,0, kRenderTransTexture,duchownyrandominv[id])
				give_item(id, "weapon_awp")
				give_item(id, "weapon_awp")
				give_item(id, "weapon_awp")
			}
		}
		case 13: 
		{
			player_class[id] = LIZARDMEN
			if (is_user_alive(id))
				set_user_health(id,get_user_health(id)+5)
		}
		case 14: 
		{
			player_class[id] = JUKA
		}
		case 15: 
		{
			player_class[id] = SAVAGES
		}
		case 16: 
		{
			player_class[id] = MEER
		}
		case 17: 
		{
			player_class[id] = TERATHAN
			player_powerint[id] = 15
			cs_set_user_armor(id, 100, CS_ARMOR_VESTHELM) 
			
		}
		case 18: 
		{
			player_class[id] = OPHIDIAN
		}
	}
	if (player_class[id] == 0) select_class(id)
	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

public add_barbarian_bonus(id)
{
	if (player_class[id] == BARBARIAN)
	{	
		new maxhealth = 100+player_strength[id]*2
		
		
		if (get_user_health(id)+50 <= maxhealth)
		{
			set_user_health(id,get_user_health(id)+50)
		} 
		else 
		{
			set_user_health(id,maxhealth)
		}
	}
}

/* ==================================================================================================== */

public add_bonus_necromancer(attacker_id,id)
{
	if (player_class[attacker_id] == NECROMANCER)
	{
		if (get_user_health(id) - 10 <= 0)
		{
			set_user_health(id,random_num(1,3))
		}
		else
		{
			set_user_health(id,get_user_health(id)-10)
		}
	}
}

/* ==================================================================================================== */

//What modules are required
public plugin_modules()
{
	require_module("engine")
	require_module("cstrike")
	require_module("fun")
	require_module("fakemeta")
	require_module("fakemeta_util")
	require_module("nvault")
	require_module("hamsandwich")
	require_module("xs")
}
/* ==================================================================================================== */

//Find the nearest alive opponent in our view
public UTIL_FindNearestOpponent(id,maxdist)
{
	new best = 99999
	new entfound = -1
	new MyOrigin[3]
	get_user_origin(id,MyOrigin)
	
	for (new i=1; i < MAX; i++)
	{
		if (i == id || !is_user_connected(i) || !is_user_alive(i) || get_user_team(id) == get_user_team(i))
			continue
		
		new TempOrigin[3],Float:fTempOrigin[3]
		get_user_origin(i,TempOrigin)
		IVecFVec(TempOrigin,fTempOrigin)
		
		if (!UTIL_IsInView(id,i))
			continue
		
		
		new dist = get_distance ( MyOrigin,TempOrigin ) 
		
		if ( dist < maxdist && dist < best)
		{
			best = dist
			entfound = i
		}		
	}
	
	return entfound
}

/* ==================================================================================================== */

//Basicly see's if we can draw a straight line to the target without interference
public bool:UTIL_IsInView(id,target)
{
	new Float:IdOrigin[3], Float:TargetOrigin[3], Float:ret[3] 
	new iIdOrigin[3], iTargetOrigin[3]
	
	get_user_origin(id,iIdOrigin,1)
	get_user_origin(target,iTargetOrigin,1)
	
	IVecFVec(iIdOrigin,IdOrigin)
	IVecFVec(iTargetOrigin, TargetOrigin)
	
	if ( trace_line ( 1, IdOrigin, TargetOrigin, ret ) == target)
		return true
	
	if ( get_distance_f(TargetOrigin,ret) < 10.0)
		return true
	
	return false
	
}
/* ==================================================================================================== */

public item_dagon(id)
{
	if (player_b_dagfired[id])
	{
		set_hudmessage(220, 30, 30, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
		show_hudmessage(id, "You can only use this item once a turn") 
		return PLUGIN_HANDLED
	}
	//Target nearest non-friendly player
	new target = UTIL_FindNearestOpponent(id,600+player_intelligence[id]*20+player_powerint[id]*20)
	
	if (target == -1) 
		return PLUGIN_HANDLED
	
	new DagonDamage = 0
	new Red = 0
	
	if (player_b_dagon[id] == 1)
	{
		DagonDamage = 20
		Red = 175
	}
	else if (player_b_dagon[id] == 2)
	{
		DagonDamage = 35
		Red = 225
	}
	else if (player_b_dagon[id] == 3)
	{
		DagonDamage = 50
		Red = 255
	}
	
	//Dagon damage done is reduced by the targets dextery
	DagonDamage-=player_dextery[target]*2
	
	if (DagonDamage < 0)
		DagonDamage = 0
	
	
	new Hit[3]
	get_user_origin(target,Hit)
	
	//Create Lightning
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(1) // TE_BEAMENTPOINT
	write_short(id)
	write_coord(Hit[0])
	write_coord(Hit[1])
	write_coord(Hit[2])
	write_short(sprite_lgt)
	write_byte(0)
	write_byte(1)
	write_byte(3)
	write_byte(10)	//WITD
	write_byte(60)
	write_byte(Red)
	write_byte(0)
	write_byte(0)
	write_byte(100)	//BRIGT
	write_byte(0)
	message_end()
	
	player_b_dagfired[id] = true
	
	//Apply damage
	if (get_user_health(target) - DagonDamage <= 0)
		UTIL_Kill(id,target,"world")
	else
	{
		set_user_health(target,get_user_health(target)-DagonDamage)
		Display_Fade(target,2600,2600,0,255,0,0,15)
		hudmsg(id,2.0,"Twoj dragon zadal %i, %i pochlonol", DagonDamage, player_dextery[target]*2)
	}
	
	
	return PLUGIN_HANDLED
	
	
}

/* ==================================================================================================== */

public UTIL_Kill(attacker,id,weapon[])
{
	
	if(get_user_team(attacker)!=get_user_team(id))
		set_user_frags(attacker,get_user_frags(attacker) +1);
	if(get_user_team(attacker)==get_user_team(id))
		set_user_frags(attacker,get_user_frags(attacker) -1);
	
	if (cs_get_user_money(attacker) + 150 <= 16000)
		cs_set_user_money(attacker,cs_get_user_money(attacker)+150)
	else
		cs_set_user_money(attacker,16000)
	
	award_kill(attacker,id)
	user_kill(id,1) 
	message_begin( MSG_ALL, gmsgDeathMsg,{0,0,0},0) 
	write_byte(attacker) 
	write_byte(id) 
	write_byte(0) 
	write_string(weapon) 
	message_end() 
	
	message_begin(MSG_ALL,gmsgScoreInfo) 
	write_byte(attacker) 
	write_short(get_user_frags(attacker)) 
	write_short(get_user_deaths(attacker)) 
	write_short(0) 
	write_short(get_user_team(attacker)) 
	message_end() 
	
	message_begin(MSG_ALL,gmsgScoreInfo) 
	write_byte(id) 
	write_short(get_user_frags(id)) 
	write_short(get_user_deaths(id)) 
	write_short(0) 
	write_short(get_user_team(id)) 
	message_end() 
	
	new kname[32], vname[32], kauthid[32], vauthid[32], kteam[10], vteam[10];
	
	get_user_name(attacker, kname, 31);
	get_user_team(attacker, kteam, 9);
	get_user_authid(attacker, kauthid, 31);
	
	get_user_name(id, vname, 31);
	get_user_team(id, vteam, 9);
	get_user_authid(id, vauthid, 31);
	
	log_message("^"%s<%d><%s><%s>^" killed ^"%s<%d><%s><%s>^" with ^"%s^"", 
	kname, get_user_userid(attacker), kauthid, kteam, 
	vname, get_user_userid(id), vauthid, vteam, weapon);
	
	
}

/* ==================================================================================================== */

//Will return 1 if user has amount of money and then substract
public bool:UTIL_Buyformoney(id,amount)
{
	if (cs_get_user_money(id) >= amount)
	{
		cs_set_user_money(id,cs_get_user_money(id)-amount)
		return true
	}
	else
	{
		hudmsg(id,2.0,"Nie masz tyle pieniedzy")
		return false
	}
	
	return false
}
public buyrune(id)
{
	new menu = menu_create("\dWybierz rune", "select_rune_menu")
	menu_additem(menu, "Tir [Can boost Dagon to Level III] - \r$7000")
	menu_additem(menu, "Vex [Can boost Point Booster] - \r$5000")
	menu_additem(menu, "Eth [Can Upgrade Air Booster] \r$6500")
	menu_additem(menu, "Ral [Can Upgrade Gold Amplifier] \r$7000")
	menu_additem(menu, "Sol [You get an item] \r$5000")
	menu_additem(menu, "Zal [You get 50 xp] \r$4500")	
	menu_display(id, menu)
}

public select_rune_menu(id, menu, item)
{
	switch(item)
	{
		case 0:    
		{
			//Tir rune
			if (player_b_dagon[id] > 0 && player_b_dagon[id] < 3)
			{
				if (!UTIL_Buyformoney(id,7000))
					return PLUGIN_HANDLED
				
				player_b_dagon[id]++
				if (player_b_dagon[id] == 2) player_item_name[id] = "Dagon II"
				else if (player_b_dagon[id] == 3) player_item_name[id] = "Dagon III"	
					
				set_hudmessage(100, 200, 55, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
				show_hudmessage(id, "Dagon ulepszony")
			}
		}
		case 1: 
		{
			//Vex - Point BOoster
			if (item_boosted[id] == 0 && player_item_id[id] == 51)
			{
				if (!UTIL_Buyformoney(id,5000))
					return PLUGIN_HANDLED
				
				item_boosted[id]++
				player_item_name[id] = "Vitality Booster"
				
				//Reset stas
				SubtractStats(id,player_b_extrastats[id])
				player_b_extrastats[id]+=2
				BoostStats(id,player_b_extrastats[id])
				set_hudmessage(100, 200, 55, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
				show_hudmessage(id, "Point Booster Ulepszony")
			}
		}
		case 2: 
		{
			if (item_boosted[id] == 0 && player_item_id[id] == 49)
			{
				if (!UTIL_Buyformoney(id,6500))
					return PLUGIN_HANDLED
				
				item_boosted[id]++
				player_item_name[id] = "Elemental Booster"
				player_b_jumpx[id]++
				set_hudmessage(100, 200, 55, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
				show_hudmessage(id, "Air Booster Ulepszony")
			}
		}
		case 3: 
		{
			if (item_boosted[id] == 0 && player_item_id[id] == 3)
			{
				if (!UTIL_Buyformoney(id,7000))
					return PLUGIN_HANDLED
				
				item_boosted[id]++
				player_item_name[id] = "Diamond Amplifier"
				player_b_damage[id]+=random_num(5,8)
				set_hudmessage(100, 200, 55, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
				show_hudmessage(id, "Gold Amplifier Ulepszony")
			}
		}
		case 4: 
		{	
			if (!UTIL_Buyformoney(id,5000))
				return PLUGIN_HANDLED
			award_item(id,0)
			return PLUGIN_HANDLED
		}
		case 5: 
		{
			if (!UTIL_Buyformoney(id,4500))
				return PLUGIN_HANDLED
			Give_Xp(id,50)
			return PLUGIN_HANDLED
		}
		
	}
	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

//Blocks fullupdate (can reset hud)
public fullupdate(id) 
{
	return PLUGIN_HANDLED
}
/* ==================================================================================================== */
public add_bonus_knifedamage(attacker_id,id,weapon)
{
	if (player_b_knife[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && weapon == CSW_KNIFE)
	{
		
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if (random_num(1,player_b_knife[attacker_id]) == 1)
			UTIL_Kill(attacker_id,id,"knife")
		
	}
	
	return PLUGIN_HANDLED
}
/* ==================================================================================================== */

public add_bonus_glock(attacker_id,id,weapon)
{
	if (player_b_glock[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if ((random_num(1,player_b_glock[attacker_id]) == 1))
		{
			if (weapon == CSW_GLOCK18) UTIL_Kill(attacker_id,id,"glock18")
			if (weapon == CSW_USP) UTIL_Kill(attacker_id,id,"usp")
		}
	}
	return PLUGIN_HANDLED
}
/* ==================================================================================================== */

public add_bonus_deagledamage(attacker_id,id,weapon)
{
	if (player_b_deagle[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && weapon == CSW_DEAGLE && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if (random_num(1,player_b_deagle[attacker_id]) == 1)
			UTIL_Kill(attacker_id,id,"deagle")
	}
	
	return PLUGIN_HANDLED
}
/* ==================================================================================================== */

public add_bonus_awpdamage(attacker_id,id,weapon)
{
	if ((player_b_awp[attacker_id] > 0 || player_class[attacker_id] == ARACHNID) && get_user_team(attacker_id) != get_user_team(id) && weapon == CSW_AWP && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{	
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if ((random_num(1,player_b_awp[attacker_id]) == 1) && (player_class[attacker_id] != ARACHNID))
			UTIL_Kill(attacker_id,id,"awp")
		
		if (random_num(1,2) == 1 && (player_class[attacker_id] == ARACHNID))
			UTIL_Kill(attacker_id,id,"awp")	
	}
	
	return PLUGIN_HANDLED
}
/* ==================================================================================================== */
public add_bonus_mefisto(id,attacker_id,weapon,damage)
{
	if ((player_class[attacker_id] == MEFISTO) && (get_user_button(attacker_id) & IN_ATTACK2) && get_user_team(attacker_id) != get_user_team(id) && weapon == CSW_KNIFE && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		//new Float:damage = float(damage)
		
		//SetHamParamFloat(4, damage)
		
		new Float:vec[3], Float:oldvelo[3]
		get_user_velocity(id, oldvelo)
		create_velocity_vector(id , attacker_id , vec)
		vec[0] += oldvelo[0]
		vec[1] += oldvelo[1]
		set_user_velocity(id , vec)	
	}
	
	return PLUGIN_HANDLED
}
/* ==================================================================================================== */
public add_bonus_coinitems(id,attacker_id,weapon,damage)
{
	if ((player_b_commemorative[attacker_id] > 0) && (get_user_button(attacker_id) & IN_ATTACK2) && get_user_team(attacker_id) != get_user_team(id) && weapon == CSW_KNIFE && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN && player_class[attacker_id] != MEFISTO)
	{
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		//new Float:damage = float(damage)
		
		//SetHamParamFloat(4, damage)
		
		new Float:vec[3], Float:oldvelo[3]
		get_user_velocity(id, oldvelo)
		create_velocity_vector(id , attacker_id , vec)
		vec[0] += oldvelo[0]
		vec[1] += oldvelo[1]
		set_user_velocity(id , vec)	
	}
	
	return PLUGIN_HANDLED
}
/* ==================================================================================================== */

public add_bonus_duchownydamage(attacker_id,id,weapon)
{
	if (player_class[id] == DUCHOWNY && get_user_team(attacker_id) != get_user_team(id) && weapon == CSW_AWP && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{	
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if (random_num(1,2))
			UTIL_Kill(attacker_id,id,"awp")
	}
	
	return PLUGIN_HANDLED
}
/* ==================================================================================================== */

public add_bonus_scoutdmglight(attacker_id,id,weapon)
{
	if (player_b_conjurg[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && weapon == CSW_SCOUT && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if ((random_num(1,player_b_conjurg[attacker_id]) == 1))
			UTIL_Kill(attacker_id,id,"scout")	
	}
	
	return PLUGIN_HANDLED
}
public add_bonus_slow(attacker_id,id)
{
	if(player_b_bless[id] > 0)
	{
		if((random_num(1,player_b_bless[id]) == 1) && get_user_team(attacker_id) != get_user_team(id))
		{
			static Float:originF[3]
			pev(id, pev_origin, originF)
			Effects(originF)
			slow_make(id,7)
		}
	}
}
Effects(const Float:originF3[3])
{
	// Largest ring
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, originF3, 0)
	write_byte(TE_BEAMCYLINDER) // TE id
	engfunc(EngFunc_WriteCoord, originF3[0]) // x
	engfunc(EngFunc_WriteCoord, originF3[1]) // y
	engfunc(EngFunc_WriteCoord, originF3[2]) // z
	engfunc(EngFunc_WriteCoord, originF3[0]) // x axis
	engfunc(EngFunc_WriteCoord, originF3[1]) // y axis
	engfunc(EngFunc_WriteCoord, originF3[2]+100.0) // z axis
	write_short(g_Explosion) // sprite
	write_byte(0) // startframe
	write_byte(0) // framerate
	write_byte(4) // life
	write_byte(60) // width
	write_byte(0) // noise
	write_byte(41) // red
	write_byte(138) // green
	write_byte(255) // blue
	write_byte(200) // brightness
	write_byte(0) // speed
	message_end()
}
/* ==================================================================================================== */
public add_bonus_humilitydamage(attacker_id,id,damage)
{
	if (player_b_humility[id] > 0 && get_user_team(attacker_id) != get_user_team(id))
	{
		
		if (!(is_user_alive(id) && (get_user_health(id) < damage)))
			return PLUGIN_HANDLED
		
		if(g_god[id] == 0) 
		{
			fm_set_user_health(id, 1)
			Effect_Bleed(id,248)
			g_god[id] = 4
			g_killer[id] = attacker_id
			invul(id+8465)
		}
		
	}
	
	return PLUGIN_HANDLED
}

public invul(id)
{
	id -= 8465
	if(!is_user_connected(id) || g_god[id] == 0)
		return
	
	new Float:secdeath = float(player_b_humility[id])
	
	g_god[id]--
	fm_set_user_health(id, 1)
	set_user_godmode(id,1)
	if(g_god[id] > 0) client_print(id, print_center, "Zginiesz za: %d", g_god[id])
	else if(!is_user_connected(g_killer[id])) user_kill(id, 1)
		else UTIL_Kill(g_killer[id],id,"world")
	set_task(secdeath, "invul", id+8465)
}
/* ==================================================================================================== */

stock slow_make(id,seconds)
{		
	new ent = Spawn_Ent("info_target")
	set_pev(ent,pev_classname,"Effect_Slow")
	set_pev(ent,pev_owner,id)
	set_pev(ent,pev_ltime, halflife_time() + seconds + 0.1)
	set_pev(ent,pev_solid,SOLID_NOT)
	set_pev(ent,pev_nextthink, halflife_time() + 0.1)			
}
public Set_Slow_Think(ent)
{
	new id = pev(ent,pev_owner)
	if (pev(ent,pev_ltime) < halflife_time() || !is_user_alive(id))
	{
		Display_Icon(id,255,0,0,"dmg_chem",0)	
		set_user_maxspeed(id,252.0+player_dextery[id])
		remove_entity(ent)
		return PLUGIN_CONTINUE
	}
	
	set_user_maxspeed(id,245.0-230)
	Display_Icon(id,255,0,0,"dmg_chem",1)	
	set_pev(ent,pev_nextthink, halflife_time() + 1.0)
	return PLUGIN_CONTINUE
}
/* ==================================================================================================== */

public add_bonus_rosedamage(attacker_id,id)
{
	if (player_b_rose[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{	
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if (random_num(1,player_b_rose[id]) == 1)
		{
			cs_set_user_money(id,cs_get_user_money(id)-player_b_rosemoney[attacker_id])
			cs_set_user_money(attacker_id,cs_get_user_money(attacker_id)+player_b_rosemoney[attacker_id])
		}
	}
	
	return PLUGIN_HANDLED
}
/* ==================================================================================================== */

public add_bonus_essencedamage(attacker_id,id)
{
	if (player_b_essence[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{	
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if (!used_item[id]) client_print(id,print_center,"Przeciwnik odebral ci moc uzywania itemow w tej rundzie")
		used_item[id] = true;
	}
	
	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

public add_bonus_ecrucitdamage(attacker_id,id)
{
	if (player_b_ecrucitrine[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{	
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if ((random_num(1,player_b_ecrucitrine[attacker_id]) == 1))
		{
			atakowanymir[id] = true;
		}
	}
	
	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

public add_bonus_transcendencedamage(attacker_id,id)
{
	if (player_b_transcendence[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{	
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if ((random_num(1,player_b_transcendence[attacker_id]) == 1))
		{
			new kevlargid = get_user_armor(id)
			set_user_armor(id,0)
			set_user_armor(attacker_id,get_user_armor(id)+kevlargid)
		}
	}
	
	return PLUGIN_HANDLED
}
/* ==================================================================================================== */

public add_bonus_commodity(attacker_id,id)
{
	if (player_b_commodity[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{	
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if (has_commodity[attacker_id] > 0)
			UTIL_Kill(attacker_id,id,"world")	
	}
	
	return PLUGIN_HANDLED
}
/* ==================================================================================================== */

public add_bonus_sharddamage(attacker_id,id)
{
	if (player_b_shard[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{	
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if ((random_num(1,player_b_shard[attacker_id]) == 1))
		{
			entity_set_float(id, EV_FL_gravity, 9999.0/800.0);	
			set_task(5.0,"gravitys_has_default",id);
		}
	}
	
	return PLUGIN_HANDLED
}
public gravitys_has_default(id)
{
	if (player_class[id] != NINJA)
		entity_set_float(id, EV_FL_gravity, 800.0/800.0);
	else entity_set_float(id, EV_FL_gravity, 280.0/800.0);
}
/* ==================================================================================================== */

public add_bonus_instantxm1014damage(attacker_id,id,weapon)
{
	if (player_b_instantxm1014[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && weapon == CSW_XM1014 && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{	
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if ((random_num(1,player_b_instantxm1014[attacker_id]) == 1))
			UTIL_Kill(attacker_id,id,"xm1014")	
	}
	
	return PLUGIN_HANDLED
}
/* ==================================================================================================== */

public add_bonus_instantak47damage(attacker_id,id,weapon)
{
	if (player_b_instantak47[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && weapon == CSW_AK47 && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{	
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if ((random_num(1,player_b_instantak47[attacker_id]) == 1))
			UTIL_Kill(attacker_id,id,"ak47")	
	}
	
	return PLUGIN_HANDLED
}
/* ==================================================================================================== */

public add_bonus_instantm4a1damage(attacker_id,id,weapon)
{
	if (player_b_instantm4a1[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && weapon == CSW_M4A1 && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{	
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if ((random_num(1,player_b_instantm4a1[attacker_id]) == 1))
			UTIL_Kill(attacker_id,id,"m4a1")	
	}
	
	return PLUGIN_HANDLED
}
/* ==================================================================================================== */

public add_bonus_instantjukidamage(attacker_id,id)
{
	if (player_b_instantjuki[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{	
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if ((random_num(1,player_b_instantjuki[attacker_id]) == 1))
			UTIL_Kill(attacker_id,id, "world")	
	}
	
	return PLUGIN_HANDLED
}
public add_bonus_blackrockdamage(attacker_id,id,weapon)
{
	if (player_b_blackrock[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{	
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if ((random_num(1,player_b_blackrock[attacker_id]) == 1))
		{
			if (weapon == CSW_MAC10) UTIL_Kill(attacker_id,id,"mac10")	
			if (weapon == CSW_TMP) UTIL_Kill(attacker_id,id,"tmp")	
		}
	}
	
	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

public add_bonus_scoutdamage(attacker_id,id,weapon)
{
	if (player_b_sniper[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && weapon == CSW_SCOUT && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{	
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if ((random_num(1,player_b_sniper[attacker_id]) == 1))
			UTIL_Kill(attacker_id,id,"scout")	
	}
	
	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

public add_bonus_newmoondamage(attacker_id,id)
{
	if (player_b_newmoon[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{	
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if (random_num(1,player_b_newmoon[attacker_id]) == 1)
		{
			if(task_exists(id+2936))
				remove_task(id+2936);
			palenie_gracza[id] = 40;
			set_task(0.5, "burning_flame", id+2936, _, _, "b");
		}
	}
	
	return PLUGIN_HANDLED
}
public burning_flame(taskid)
{
	new id = (taskid-2936)
	
	if(!is_user_alive(id))
	{
		palenie_gracza[id] = 0
		return PLUGIN_CONTINUE;
	}
	
	new origin[3], flags = pev(id, pev_flags)
	get_user_origin(id, origin)
	
	if(flags & FL_INWATER || palenie_gracza[id] < 1)
	{
		message_begin(MSG_PVS, SVC_TEMPENTITY, origin)
		write_byte(TE_SMOKE)
		write_coord(origin[0])
		write_coord(origin[1])
		write_coord(origin[2]-50)
		write_short(sprite_smoke)
		write_byte(random_num(15,20))
		write_byte(random_num(10,20))
		message_end()
		
		remove_task(taskid);
		return PLUGIN_CONTINUE;
	}
	
	if(flags & FL_ONGROUND)
	{
		static Float:velocity[3]
		pev(id, pev_velocity, velocity)
		xs_vec_mul_scalar(velocity, 0.5, velocity)
		set_pev(id, pev_velocity, velocity)
	}
	
	if(get_user_health(id)-1 > 0)
		fm_set_user_health(id, get_user_health(id)-1)
	
	message_begin(MSG_PVS, SVC_TEMPENTITY, origin)
	write_byte(TE_SPRITE)
	write_coord(origin[0]+random_num(-5,5))
	write_coord(origin[1]+random_num(-5,5))
	write_coord(origin[2]+random_num(-10,10))
	write_short(sprite_fire)
	write_byte(random_num(5,10))
	write_byte(200)
	message_end()
	
	palenie_gracza[id]--
	return PLUGIN_CONTINUE;
}
/* ==================================================================================================== */

public add_bonus_bloodmossdamage(attacker_id,id)
{
	if (player_b_bloodmoss[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{	
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if (random_num(1,player_b_bloodmoss[attacker_id]) == 1)
		{
			client_cmd(id,"default_fov 20")
			
			message_begin( MSG_ONE, gmsg_SetFOV, { 0, 0, 0 }, id )
			write_byte( 180 )
			message_end( )
			
			remove_task( id );
			
			set_task( 8.0 , "backToNormal" , id )
		}
	}
	
	return PLUGIN_HANDLED
}

public backToNormal( id )
{
	client_cmd(id,"default_fov 90")
	
	message_begin( MSG_ONE, gmsg_SetFOV, { 0, 0, 0 }, id )
	write_byte( 90 )
	message_end( )
}

/* ==================================================================================================== */

public add_bonus_jukadamage(attacker_id,id)
{
	if (player_class[id] == JUKA && get_user_team(attacker_id) != get_user_team(id) && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{
		
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if ((random_num(1,10) == 1) && (player_class[id] == JUKA))
			UTIL_Kill(attacker_id,id,"world")
		
	}
	
	return PLUGIN_HANDLED
}


/* ==================================================================================================== */

public add_bonus_candelabradamage(attacker_id,id,weapon)
{
	if (player_b_candelabra[attacker_id] > 0 && get_user_team(attacker_id) != get_user_team(id) && weapon == CSW_SCOUT && player_b_fireshield[id] == 0 && player_class[id] != DRAGONAN)
	{
		
		if (!is_user_alive(id))
			return PLUGIN_HANDLED
		
		if (random_num(1,2))
			UTIL_Kill(attacker_id,id,"scout")	
	}
	
	return PLUGIN_HANDLED
}
/* ==================================================================================================== */

public add_bonus_illusion(attacker_id,id,weapon)
{
	if(HasFlag(id,Flag_Illusion))
	{
		new weaponname[32]
		get_weaponname( weapon, weaponname, 31 ) 
		replace(weaponname, 31, "weapon_", "")
		UTIL_Kill(attacker_id,id,weaponname)
	}
}

/* ==================================================================================================== */

public item_take_damage(id,damage)
{
	new itemdamage = get_cvar_num("diablo_durability")
	
	if (player_item_id[id] > 0 && item_durability[id] > 0 && itemdamage> 0 && damage > 5)
	{
		//Make item take damage
		if (item_durability[id] - itemdamage <= 0)
		{
			item_durability[id]-=itemdamage
			dropitem(id)
		}
		else
		{
			item_durability[id]-=itemdamage
		}
		
	}
}

/* ==================================================================================================== */

//From twistedeuphoria plugin
public Prethink_Doublejump(id)
{
	if(!is_user_alive(id)) 
		return PLUGIN_HANDLED
	
	if((get_user_button(id) & IN_JUMP) && !(get_entity_flags(id) & FL_ONGROUND) && !(get_user_oldbutton(id) & IN_JUMP))
	{
		if((jumps[id] < player_b_jumpx[id]) || (player_class[id] == MEER && jumps[id] < 1+player_intelligence[id]/4+player_powerint[id]/4))
		{
			dojump[id] = true
			jumps[id]++
			return PLUGIN_HANDLED
		}
	}
	if((get_user_button(id) & IN_JUMP) && (get_entity_flags(id) & FL_ONGROUND))
	{
		jumps[id] = 0
		return PLUGIN_CONTINUE
	}
	
	return PLUGIN_HANDLED
}

public Postthink_Doubeljump(id)
{
	if(!is_user_alive(id)) 
		return PLUGIN_HANDLED
	
	if(dojump[id] == true)
	{
		new Float:velocity[3]	
		entity_get_vector(id,EV_VEC_velocity,velocity)
		velocity[2] = random_float(265.0,285.0)
		entity_set_vector(id,EV_VEC_velocity,velocity)
		dojump[id] = false
		return PLUGIN_CONTINUE
	}
	
	return PLUGIN_HANDLED
}

/* ==================================================================================================== */

public spawn_powerup(Float:sOrigin[3])
{
	new ent = create_entity("info_target") 
	entity_set_string(ent, EV_SZ_classname, "PowerUp") 
	entity_set_int(ent, EV_INT_movetype, MOVETYPE_TOSS) 
	entity_set_int(ent, EV_INT_solid, SOLID_BBOX) 
	entity_set_model(ent, "models/bag.mdl")  			
	set_rendering(ent, kRenderFxGlowShell, 0,0,0, kRenderNormal, 255)
	entity_set_origin(ent,sOrigin)
	entity_set_int(ent,EV_INT_iuser1,0)	//Amount of color glow
	new Float:maxs[3] = {16.0,16.0,6.0} 
	new Float:mins[3] = {-16.0,-16.0,-6.0} 
	entity_set_size(ent,mins,maxs) 
	powerup_taken = false
	entity_set_float(ent,EV_FL_nextthink,halflife_time() + 0.01) 
	
}

public award_powerup(id)
{
	if (is_user_connected(id) && is_user_alive(id) && !powerup_taken)
	{
		if (random_num(1,2) == 1)
		{
			if (cs_get_user_money(id) < 5000)
				cs_set_user_money(id,5000)
			else if (cs_get_user_money(id) < 10000)
				cs_set_user_money(id,10000)
			else if (cs_get_user_money(id) < 16000)
				cs_set_user_money(id,16000)
			
			set_hudmessage(100, 200, 55, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
			show_hudmessage(id, "Powerup: Pieniadze")
		}
		else
		{
			if (player_item_id[id] <= 0)
			{
				award_item(id,0)
				set_hudmessage(100, 200, 55, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
				show_hudmessage(id, "Powerup: Item  %s",player_item_name[id])
			}
			else
			{
				Give_Xp(id,get_cvar_num("diablo_xpbonus")*2)
				set_hudmessage(100, 200, 55, -1.0, 0.40, 0, 3.0, 2.0, 0.2, 0.3, 5)
				show_hudmessage(id, "Powerup: Doswiadczenie")
			}
		}
		
		powerup_taken = true
	}
}

public Think_PowerUp(ent)
{
	//If set to delete
	if (entity_get_int(ent,EV_INT_iuser2) == 1)
	{
		remove_entity(ent)
		return PLUGIN_HANDLED
	}
	
	new glow = entity_get_int(ent,EV_INT_iuser1)
	
	if (glow < 255)
	{
		glow++
		entity_set_int(ent,EV_INT_iuser1,glow)
	}
	
	set_rendering(ent, kRenderFxGlowShell, 0,glow,0, kRenderNormal, 255)
	entity_set_float(ent,EV_FL_nextthink,halflife_time() + 0.5) 
	
	return PLUGIN_CONTINUE
}

/* ==================================================================================================== */

public register_place(kid)
{
	if (!spawnset)
		return PLUGIN_HANDLED
	
	new Place[3]
	get_user_origin(kid,Place,0)
	
	new distCTstart = get_distance(Place,CTstart) 
	new distTstart = get_distance(Place,Tstart)
	
	if (distCTstart > 300 && distTstart > 300 && abs(distCTstart - distTstart) < 150)
	{
		if (havespawn)
		{
			if (random_num(1,3) == 3)
				NextPowerup = Place
		}
		else
		{
			havespawn = true
			NextPowerup = Place
		}
		
	}
	
	return PLUGIN_CONTINUE
	
	
}

/* ==================================================================================================== */

public SpawnPowerup()
{
	if (!spawnset || !havespawn)
		return PLUGIN_HANDLED
	
	new chance = get_cvar_num("diablo_spawnchance")
	
	if (random_num(1,chance) == 1)
	{	
		
		//Dont spawn if one is already there
		if (find_ent_by_class(-1,"PowerUp") > 0)
			return PLUGIN_HANDLED
		
		//Spawn powerup
		new Float:spawnplace[3]
		IVecFVec(NextPowerup,spawnplace)
		spawn_powerup(spawnplace)
	}
	
	return PLUGIN_CONTINUE
	
	
}

/* ==================================================================================================== */

public eventGrenade(id) 
{
	new id = read_data(1)
	if (player_b_grenade[id] > 0 || player_b_smokehit[id] > 0)
	{
		set_task(0.1, "makeGlow", id)
	}
}

public makeGlow(id) 
{
	new grenade
	new greModel[100]
	grenade = get_grenade(id) 
	
	if( grenade ) 
	{	
		entity_get_string(grenade, EV_SZ_model, greModel, 99)
		
		if(equali(greModel, "models/w_hegrenade.mdl" ) && player_b_grenade[id] > 0 )	
			set_rendering(grenade, kRenderFxGlowShell, 255,0,0, kRenderNormal, 255)
		
		if(equali(greModel, "models/w_smokegrenade.mdl" ) && player_b_smokehit[id] > 0 )	
		{
			set_rendering(grenade, kRenderFxGlowShell, 0,255,255, kRenderNormal, 255)
		}
	}
}

/* ==================================================================================================== */

public BoostStats(id,amount)
{
	player_strength[id]+=amount
	player_dextery[id]+=amount
	player_agility[id]+=amount
	player_intelligence[id]+=amount
}

public SubtractStats(id,amount)
{
	player_strength[id]-=amount
	player_dextery[id]-=amount
	player_agility[id]-=amount
	player_intelligence[id]-=amount
}

/* ==================================================================================================== */

public SelectBotRace(id)
{
	if (!is_user_bot(id))
		return PLUGIN_HANDLED
	
	if (player_class[id] == 0)
		player_class[id] = random_num(1,14)
	
	return PLUGIN_CONTINUE
}

/* ==================================================================================================== */

public showskills(id)
{
	new Skillsinfo[768]
	format(Skillsinfo,767,"You have %i strength - this give you %i extra hitpoints<br><br>You have %i Dextery - this give a speed boost of %i% and reduce magic damage taken with %i%%<br><br>You have %i Agility - Helps to find unique items and reduce damage from normal attacks by %0.0f%%<br><br>You have %i intelligence - this will make the USE items more efficient<br>",
	player_strength[id],
	player_strength[id]*2,
	player_dextery[id],
	player_dextery[id],
	player_dextery[id]*3,
	player_agility[id],
	player_damreduction[id]*100,
	player_intelligence[id])
	
	showitem(id,"Skills","Brak","Brak", Skillsinfo)
}

/* ==================================================================================================== */

public UTIL_Teleport(id,distance)
{	
	Set_Origin_Forward(id,distance)
	
	new origin[3]
	get_user_origin(id,origin)
	
	//Particle burst ie. teleport effect	
	message_begin(MSG_BROADCAST ,SVC_TEMPENTITY) //message begin
	write_byte(TE_PARTICLEBURST )
	write_coord(origin[0]) // origin
	write_coord(origin[1]) // origin
	write_coord(origin[2]) // origin
	write_short(20) // radius
	write_byte(1) // particle color
	write_byte(4) // duration * 10 will be randomized a bit
	message_end()
	
	
}

stock Set_Origin_Forward(id, distance) 
{
	new Float:origin[3]
	new Float:angles[3]
	new Float:teleport[3]
	new Float:heightplus = 10.0
	new Float:playerheight = 64.0
	new bool:recalculate = false
	new bool:foundheight = false
	pev(id,pev_origin,origin)
	pev(id,pev_angles,angles)
	
	teleport[0] = origin[0] + distance * floatcos(angles[1],degrees) * floatabs(floatcos(angles[0],degrees));
	teleport[1] = origin[1] + distance * floatsin(angles[1],degrees) * floatabs(floatcos(angles[0],degrees));
	teleport[2] = origin[2]+heightplus
	
	while (!Can_Trace_Line_Origin(origin,teleport) || Is_Point_Stuck(teleport,48.0))
	{	
		if (distance < 10)
			break;
		
		//First see if we can raise the height to MAX playerheight, if we can, it's a hill and we can teleport there	
		for (new i=1; i < playerheight+20.0; i++)
		{
			teleport[2]+=i
			if (Can_Trace_Line_Origin(origin,teleport) && !Is_Point_Stuck(teleport,48.0))
			{
				foundheight = true
				heightplus += i
				break
			}
			
			teleport[2]-=i
		}
		
		if (foundheight)
			break
		
		recalculate = true
		distance-=10
		teleport[0] = origin[0] + (distance+32) * floatcos(angles[1],degrees) * floatabs(floatcos(angles[0],degrees));
		teleport[1] = origin[1] + (distance+32) * floatsin(angles[1],degrees) * floatabs(floatcos(angles[0],degrees));
		teleport[2] = origin[2]+heightplus
	}
	
	if (!recalculate)
	{
		set_pev(id,pev_origin,teleport)
		return PLUGIN_CONTINUE
	}
	
	teleport[0] = origin[0] + distance * floatcos(angles[1],degrees) * floatabs(floatcos(angles[0],degrees));
	teleport[1] = origin[1] + distance * floatsin(angles[1],degrees) * floatabs(floatcos(angles[0],degrees));
	teleport[2] = origin[2]+heightplus
	set_pev(id,pev_origin,teleport)
	
	return PLUGIN_CONTINUE
}

stock bool:Can_Trace_Line_Origin(Float:origin1[3], Float:origin2[3])
{	
	new Float:Origin_Return[3]	
	new Float:temp1[3]
	new Float:temp2[3]
	
	temp1[x] = origin1[x]
	temp1[y] = origin1[y]
	temp1[z] = origin1[z]-30
	
	temp2[x] = origin2[x]
	temp2[y] = origin2[y]
	temp2[z] = origin2[z]-30
	
	trace_line(-1, temp1, temp2, Origin_Return) 
	
	if (get_distance_f(Origin_Return,temp2) < 1.0)
		return true
	
	return false
}

stock bool:Is_Point_Stuck(Float:Origin[3], Float:hullsize)
{
	new Float:temp[3]
	new Float:iterator = hullsize/3
	
	temp[2] = Origin[2]
	
	for (new Float:i=Origin[0]-hullsize; i < Origin[0]+hullsize; i+=iterator)
	{
		for (new Float:j=Origin[1]-hullsize; j < Origin[1]+hullsize; j+=iterator)
		{
			//72 mod 6 = 0
			for (new Float:k=Origin[2]-CS_PLAYER_HEIGHT; k < Origin[2]+CS_PLAYER_HEIGHT; k+=6) 
			{
				temp[0] = i
				temp[1] = j
				temp[2] = k
				
				if (point_contents(temp) != -1)
					return true
			}
		}
	}
	
	return false
}

stock Effect_Bleed(id,color)
{
	new origin[3]
	get_user_origin(id,origin)
	
	new dx, dy, dz
	
	for(new i = 0; i < 3; i++) 
	{
		dx = random_num(-15,15)
		dy = random_num(-15,15)
		dz = random_num(-20,25)
		
		for(new j = 0; j < 2; j++) 
		{
			message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
			write_byte(TE_BLOODSPRITE)
			write_coord(origin[0]+(dx*j))
			write_coord(origin[1]+(dy*j))
			write_coord(origin[2]+(dz*j))
			write_short(sprite_blood_spray)
			write_short(sprite_blood_drop)
			write_byte(color) // color index
			write_byte(8) // size
			message_end()
		}
	}
}

/* ==================================================================================================== */

public Use_Spell(id)
{
	if (player_global_cooldown[id] + GLOBAL_COOLDOWN >= halflife_time())
		return PLUGIN_CONTINUE
	else
		player_global_cooldown[id] = halflife_time()
	
	if (player_b_spawnuse[id] > 0) item_usespawn(id)
	
	if (!is_user_alive(id) || !freeze_ended)
		return PLUGIN_CONTINUE
	
	/*See if USE button is used for anything else..
	1) Close to bomb
	2) Close to hostage
	3) Close to switch
	4) Close to door
	*/
	
	new Float:origin[3]
	pev(id, pev_origin, origin)
	
	//Func door and func door rotating
	new aimid, body
	get_user_aiming ( id, aimid, body ) 
	
	if (aimid > 0)
	{
		new classname[32]
		pev(aimid,pev_classname,classname,31)
		
		if (equal(classname,"func_door_rotating") || equal(classname,"func_door") || equal(classname,"func_button"))
		{
			new Float:doororigin[3]
			pev(aimid, pev_origin, doororigin)
			
			if (get_distance_f(origin, doororigin) < 70 && UTIL_In_FOV(id,aimid))
				return PLUGIN_CONTINUE
		}
		
	}
	
	//Bomb condition
	new bomb
	if ((bomb = find_ent_by_model(-1, "grenade", "models/w_c4.mdl"))) 
	{
		new Float:bombpos[3]
		pev(bomb, pev_origin, bombpos)
		
		//We are near the bomb and have it in FOV.
		if (get_distance_f(origin, bombpos) < 100 && UTIL_In_FOV(id,bomb))
			return PLUGIN_CONTINUE
	}
	
	
	//Hostage
	new hostage = engfunc(EngFunc_FindEntityByString, -1,"classname", "hostage_entity")
	
	while (hostage)
	{
		new Float:hospos[3]
		pev(hostage, pev_origin, hospos)
		if (get_distance_f(origin, hospos) < 70 && UTIL_In_FOV(id,hostage))
			return PLUGIN_CONTINUE
		
		hostage = engfunc(EngFunc_FindEntityByString, hostage,"classname", "hostage_entity")
	}
	
	check_magic(id)
	
	
	return PLUGIN_CONTINUE
}

/* ==================================================================================================== */

//Angle to all targets in fov
stock Float:Find_Angle(Core,Target,Float:dist)
{
	new Float:vec2LOS[2]
	new Float:flDot	
	new Float:CoreOrigin[3]
	new Float:TargetOrigin[3]
	new Float:CoreAngles[3]
	
	pev(Core,pev_origin,CoreOrigin)
	pev(Target,pev_origin,TargetOrigin)
	
	if (get_distance_f(CoreOrigin,TargetOrigin) > dist)
		return 0.0
	
	pev(Core,pev_angles, CoreAngles)
	
	for ( new i = 0; i < 2; i++ )
		vec2LOS[i] = TargetOrigin[i] - CoreOrigin[i]
	
	new Float:veclength = Vec2DLength(vec2LOS)
	
	//Normalize V2LOS
	if (veclength <= 0.0)
	{
		vec2LOS[x] = 0.0
		vec2LOS[y] = 0.0
	}
	else
	{
		new Float:flLen = 1.0 / veclength;
		vec2LOS[x] = vec2LOS[x]*flLen
		vec2LOS[y] = vec2LOS[y]*flLen
	}
	
	//Do a makevector to make v_forward right
	engfunc(EngFunc_MakeVectors,CoreAngles)
	
	new Float:v_forward[3]
	new Float:v_forward2D[2]
	get_global_vector(GL_v_forward, v_forward)
	
	v_forward2D[x] = v_forward[x]
	v_forward2D[y] = v_forward[y]
	
	flDot = vec2LOS[x]*v_forward2D[x]+vec2LOS[y]*v_forward2D[y]
	
	if ( flDot > 0.5 )
	{
		return flDot
	}
	
	return 0.0	
}

stock Float:Vec2DLength( Float:Vec[2] )  
{ 
	return floatsqroot(Vec[x]*Vec[x] + Vec[y]*Vec[y] )
}

stock bool:UTIL_In_FOV(id,target)
{
	if (Find_Angle(id,target,9999.9) > 0.0)
		return true
	
	return false
}

/* ==================================================================================================== */

public Greet_Player(id)
{
	id-=TASK_GREET
	new name[32]
	get_user_name(id,name,31)
	client_print(id,print_chat, "Witaj %s w Diablo Mod v. %00.0f Napisz /help by zobaczyc jak grac", name, version)
}

/* ==================================================================================================== */

stock Display_Fade(id,duration,holdtime,fadetype,red,green,blue,alpha)
{
	message_begin( MSG_ONE,get_user_msgid("ScreenFade"),{0,0,0},id )
	write_short( duration )	// Duration of fadeout
	write_short( holdtime )	// Hold time of color
	write_short( fadetype )	// Fade type
	write_byte ( red )		// Red
	write_byte ( green )		// Green
	write_byte ( blue )		// Blue
	write_byte ( alpha )	// Alpha
	message_end()
}

/* ==================================================================================================== */

public changerace(id)
{
	set_user_health(id,0)
	if (player_item_id[id] != 0) 
	{ 
		dropitem(id)
	} 
	
	client_connect(id)
	if (player_class[id] == 0 && (!(get_user_flags(id) & ADMIN_LEVEL_H))) select_class2(id)
	else select_class(id)
}

/* ==================================================================================================== */

//Disable autohelp messages and display our own.
public FW_WriteString(string[])
{
	if (equal(string,""))
		return FMRES_IGNORED
	
	//Disable autohelp
	if (equal(string,"#Hint_press_buy_to_purchase") || equal(string,"#Hint_press_buy_to_purchase "))
	{
		write_string( "" );
		return FMRES_SUPERCEDE
	}
	
	if (equal(string, "#Hint_spotted_a_friend") || equal(string, "#Hint_you_have_the_bomb"))
	{
		write_string( "" );
		return FMRES_SUPERCEDE
	}
	
	return FMRES_IGNORED
	
}

stock hudmsg(id,Float:display_time,const fmt[], {Float,Sql,Result,_}:...)
{	
	if (player_huddelay[id] >= 0.03*4)
		return PLUGIN_CONTINUE
	
	new buffer[512]
	vformat(buffer, 511, fmt, 4)
	
	set_hudmessage ( 255, 0, 0, -1.0, 0.4 + player_huddelay[id], 0, display_time/2, display_time, 0.1, 0.2, -1 ) 	
	show_hudmessage(id, buffer)
	
	player_huddelay[id]+=0.03
	
	remove_task(id+TASK_HUD)
	set_task(display_time, "hudmsg_clear", id+TASK_HUD, "", 0, "a", 3)
	
	
	return PLUGIN_CONTINUE
	
}

public hudmsg_clear(id)
{
	new pid = id-TASK_HUD
	player_huddelay[pid]=0.0
}

/* ==================================================================================================== */

public item_firetotem(id)
{
	if (used_item[id])
	{
		hudmsg(id,2.0,"Mozesz uzyc jeden Fire Totem na runde")
	}
	else
	{
		used_item[id] = true
		Effect_Ignite_Totem(id,7)
	}
}

stock Effect_Ignite_Totem(id,seconds)
{
	new origin[3]
	pev(id,pev_origin,origin)
	
	new ent = Spawn_Ent("info_target")
	set_pev(ent,pev_classname,"Effect_Ignite_Totem")
	set_pev(ent,pev_owner,id)
	set_pev(ent,pev_solid,SOLID_TRIGGER)
	set_pev(ent,pev_origin,origin)
	set_pev(ent,pev_ltime, halflife_time() + seconds + 0.1)
	
	engfunc(EngFunc_SetModel, ent, "addons/amxmodx/diablo/totem_ignite.mdl")  	
	set_rendering ( ent, kRenderFxGlowShell, 250,150,0, kRenderFxNone, 255 ) 	
	engfunc(EngFunc_DropToFloor,ent)
	
	set_pev(ent,pev_euser3,0)
	set_pev(ent,pev_nextthink, halflife_time() + 0.1)
}

public Effect_Ignite_Totem_Think(ent)
{
	//Safe check because effect on death
	if (!freeze_ended)
		remove_entity(ent)
	
	if (!is_valid_ent(ent))
		return PLUGIN_CONTINUE
	
	new id = pev(ent,pev_owner)
	
	//Apply and destroy
	if (pev(ent,pev_euser3) == 1)
	{
		new entlist[513]
		new numfound = find_sphere_class(ent,"player",player_b_firetotem[id]+0.0,entlist,512)
		
		for (new i=0; i < numfound; i++)
		{		
			new pid = entlist[i]
			
			//This totem can hit the caster
			if (pid == id && is_user_alive(id))
			{
				Effect_Ignite(pid,id,4)
				hudmsg(pid,3.0,"Palisz sie! Strzel do wroga aby przestac sie palic.")
				continue
			}
			
			if (!is_user_alive(pid) || get_user_team(id) == get_user_team(pid))
				continue
			
			//Dextery makes the fire damage less
			if (player_dextery[pid] > 20)
				Effect_Ignite(pid,id,1)
			else if (player_dextery[pid] > 15)
				Effect_Ignite(pid,id,2)
			else if (player_dextery[pid] > 10)
				Effect_Ignite(pid,id,3)
			else
				Effect_Ignite(pid,id,4)
			
			hudmsg(pid,3.0,"Palisz sie! Strzel do wroga aby przestac sie palic.")
		}
		
		remove_entity(ent)
		return PLUGIN_CONTINUE
	}
	
	
	
	//Entity should be destroyed because livetime is over
	if (pev(ent,pev_ltime) < halflife_time())
	{
		set_pev(ent,pev_euser3,1)
		
		//Show animation and die
		
		new Float:forigin[3], origin[3]
		pev(ent,pev_origin,forigin)	
		FVecIVec(forigin,origin)
		
		//Find people near and give them health
		message_begin( MSG_BROADCAST, SVC_TEMPENTITY, origin );
		write_byte( TE_BEAMCYLINDER );
		write_coord( origin[0] );
		write_coord( origin[1] );
		write_coord( origin[2] );
		write_coord( origin[0] );
		write_coord( origin[1] + player_b_firetotem[id]);
		write_coord( origin[2] + player_b_firetotem[id]);
		write_short( sprite_white );
		write_byte( 0 ); // startframe
		write_byte( 0 ); // framerate
		write_byte( 10 ); // life
		write_byte( 10 ); // width
		write_byte( 255 ); // noise
		write_byte( 150 ); // r, g, b
		write_byte( 150 ); // r, g, b
		write_byte( 0 ); // r, g, b
		write_byte( 128 ); // brightness
		write_byte( 5 ); // speed
		message_end();
		
		set_pev(ent,pev_nextthink, halflife_time() + 0.2)
		
	}
	else	
	{
		set_pev(ent,pev_nextthink, halflife_time() + 1.5)
	}
	
	return PLUGIN_CONTINUE
}

stock Spawn_Ent(const classname[]) 
{
	new ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, classname))
	set_pev(ent, pev_origin, {0.0, 0.0, 0.0})    
	dllfunc(DLLFunc_Spawn, ent)
	return ent
}

stock Effect_Ignite(id,attacker,damage)
{
	new ent = Spawn_Ent("info_target")
	set_pev(ent,pev_classname,"Effect_Ignite")
	set_pev(ent,pev_owner,id)
	set_pev(ent,pev_ltime, halflife_time() + 99 + 0.1)
	set_pev(ent,pev_solid,SOLID_NOT)
	set_pev(ent,pev_euser1,attacker)
	set_pev(ent,pev_euser2,damage)
	set_pev(ent,pev_nextthink, halflife_time() + 0.1)	
	
	AddFlag(id,Flag_Ignite)
}

//euser3 = destroy and apply effect
public Effect_Ignite_Think(ent)
{
	new id = pev(ent,pev_owner)
	new attacker = pev(ent,pev_euser1)
	new damage = pev(ent,pev_euser2)
	
	if (pev(ent,pev_ltime) < halflife_time() || !is_user_alive(id) || !HasFlag(id,Flag_Ignite))
	{
		RemoveFlag(id,Flag_Ignite)
		Remove_All_Tents(id)
		Display_Icon(id,200,0,0,"dmg_heat",0)
		remove_entity(ent)		
		return PLUGIN_CONTINUE
	}
	
	
	//Display ignite tent and icon
	Display_Tent(id,sprite_ignite,2)
	Display_Icon(id,200,0,0,"dmg_heat",1)
	
	new origin[3]
	get_user_origin(id,origin)
	
	//Make some burning effects
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte( TE_SMOKE ) // 5
	write_coord(origin[0])
	write_coord(origin[1])
	write_coord(origin[2])
	write_short( sprite_smoke )
	write_byte( 22 )  // 10
	write_byte( 10 )  // 10
	message_end()
	
	//Decals
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte( TE_GUNSHOTDECAL ) // decal and ricochet sound
	write_coord( origin[0] ) //pos
	write_coord( origin[1] )
	write_coord( origin[2] )
	write_short (0) // I have no idea what thats supposed to be
	write_byte (random_num(199,201)) //decal
	message_end()
	
	
	//Do the actual damage
	Hurt_Entity(attacker,id,damage+0.0)
	
	set_pev(ent,pev_nextthink, halflife_time() + 1.5)
	
	
	return PLUGIN_CONTINUE
}

stock AddFlag(id,flag)
{
	afflicted[id][flag] = 1	
}

stock RemoveFlag(id,flag)
{
	afflicted[id][flag] = 0
}

stock bool:HasFlag(id,flag)
{
	if (afflicted[id][flag])
		return true
	
	return false
}

stock Display_Tent(id,sprite, seconds)
{
	message_begin(MSG_ALL,SVC_TEMPENTITY)
	write_byte(TE_PLAYERATTACHMENT)
	write_byte(id)
	write_coord(40) //Offset
	write_short(sprite)
	write_short(seconds*10)
	message_end()
}

stock Remove_All_Tents(id)
{
	message_begin(MSG_ALL ,SVC_TEMPENTITY) //message begin
	write_byte(TE_KILLPLAYERATTACHMENTS)
	write_byte(id) // entity index of player
	message_end()
}

stock Display_Icon(id,red,green,blue,name[], enable)
{
	if (!pev_valid(id))
	{
		return PLUGIN_HANDLED
	}
	
	message_begin( MSG_ONE, get_user_msgid("StatusIcon"), {0,0,0}, id ) 
	write_byte( enable ) 	
	write_string( name ) 
	write_byte( red ) // red 
	write_byte( green ) // green 
	write_byte( blue ) // blue 
	message_end()
	
	return PLUGIN_CONTINUE
}

stock Hurt_Entity(attacker,victim,Float:amount)
{
	if (get_user_health(victim)-amount <= 1)
	{
		UTIL_Kill(attacker,victim,"world")
	}
	else
	{
		fakedamage(victim,"player",amount,DMG_ENERGYBEAM)
	}
}

stock Find_Best_Angle(id,Float:dist, same_team = false)
{
	new Float:bestangle = 0.0
	new winner = -1
	
	for (new i=0; i < MAX; i++)
	{
		if (!is_user_alive(i) || i == id || (get_user_team(i) == get_user_team(id) && !same_team))
			continue
		
		if (get_user_team(i) != get_user_team(id) && same_team)
			continue
		
		//User has spell immunity, don't target
		
		new Float:c_angle = Find_Angle(id,i,dist)
		
		if (c_angle > bestangle && Can_Trace_Line(id,i))
		{
			winner = i
			bestangle = c_angle
		}
		
	}
	
	return winner
}

//This is an interpolation. We make tree lines with different height as to make sure
stock bool:Can_Trace_Line(id, target)
{	
	for (new i=-35; i < 60; i+=35)
	{		
		new Float:Origin_Id[3]
		new Float:Origin_Target[3]
		new Float:Origin_Return[3]
		
		pev(id,pev_origin,Origin_Id)
		pev(target,pev_origin,Origin_Target)
		
		Origin_Id[z] = Origin_Id[z] + i
		Origin_Target[z] = Origin_Target[z] + i
		
		trace_line(-1, Origin_Id, Origin_Target, Origin_Return) 
		
		if (get_distance_f(Origin_Return,Origin_Target) < 25.0)
			return true
		
	}
	
	return false
}

public item_hook(id)
{
	if (used_item[id])
	{
		hudmsg(id,2.0,"Hak mozesz uzyc raz na runde")
		return PLUGIN_CONTINUE	
	}
	
	new target = Find_Best_Angle(id,1000.0,false)
	
	if (!is_valid_ent(target))
	{
		hudmsg(id,2.0,"Brak celu w zasiegu haka")
		return PLUGIN_CONTINUE
	}
	
	AddFlag(id,Flag_Hooking)
	
	set_user_gravity(target,0.0)
	set_task(0.1,"hook_prethink",id+TASK_HOOK,"",0,"b")
	hooked[id] = target
	hook_prethink(id+TASK_HOOK)
	emit_sound(id,CHAN_VOICE,"weapons/xbow_hit2.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	
	used_item[id] = true	
	return PLUGIN_HANDLED
	
}

public hook_prethink(id)
{
	id -= TASK_HOOK
	if(!is_user_alive(id) || !is_user_alive(hooked[id])) 
	{
		RemoveFlag(id,Flag_Hooking)
		return PLUGIN_HANDLED
	}
	if (get_user_button(id) & ~IN_USE)
	{
		RemoveFlag(id,Flag_Hooking)
		return PLUGIN_HANDLED	
	}
	if(!HasFlag(id,Flag_Hooking))
	{
		if (is_user_alive(hooked[id]))
			set_user_gravity(id,1.0)
		remove_task(id+TASK_HOOK)
		return PLUGIN_HANDLED
	}
	
	//Get Id's origin
	static origin1[3]
	get_user_origin(id,origin1)
	
	static origin2[3]
	get_user_origin(hooked[id],origin2)
	
	//Create blue beam
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte(1)		//TE_BEAMENTPOINT
	write_short(id)		// start entity
	write_coord(origin2[0])
	write_coord(origin2[1])
	write_coord(origin2[2])
	write_short(sprite_line)
	write_byte(1)		// framestart
	write_byte(1)		// framerate
	write_byte(2)		// life in 0.1's
	write_byte(5)		// width
	write_byte(0)		// noise
	write_byte(0)		// red
	write_byte(0)		// green
	write_byte(255)		// blue
	write_byte(200)		// brightness
	write_byte(0)		// speed
	message_end()
	
	//Calculate Velocity
	new Float:velocity[3]
	velocity[0] = (float(origin1[0]) - float(origin2[0])) * 3.0
	velocity[1] = (float(origin1[1]) - float(origin2[1])) * 3.0
	velocity[2] = (float(origin1[2]) - float(origin2[2])) * 3.0
	
	new Float:dy
	dy = velocity[0]*velocity[0] + velocity[1]*velocity[1] + velocity[2]*velocity[2]
	
	new Float:dx
	dx = (4+player_intelligence[id]/2+player_powerint[id]/2) * 120.0 / floatsqroot(dy)
	
	velocity[0] *= dx
	velocity[1] *= dx
	velocity[2] *= dx
	
	set_pev(hooked[id],pev_velocity,velocity)
	
	return PLUGIN_CONTINUE
}

/* ==================================================================================================== */

public item_gravitybomb(id)
{	
	if (pev(id,pev_flags) & FL_ONGROUND) 
	{
		hudmsg(id,2.0,"Musisz byc w powietrzu!")
		return PLUGIN_CONTINUE
	}
	
	if (halflife_time()-gravitytimer[id] <= 3)
	{
		hudmsg(id,2.0,"Ta umiejetnosc mozesz uzywac co 3 sekundy")
		return PLUGIN_CONTINUE
	}
	
	gravitytimer[id] = floatround(halflife_time())
	
	new origin[3]
	get_user_origin(id,origin)
	
	if (origin[2] == 0)
		earthstomp[id] = 1
	else
		earthstomp[id] = origin[2]
	
	set_user_gravity(id,5.0)
	falling[id] = true
	
	
	return PLUGIN_CONTINUE
	
}

public add_bonus_stomp(id)
{
	add_gravity_bonus(id)
	
	new origin[3]
	get_user_origin(id,origin)
	
	new dam = earthstomp[id]-origin[2]
	
	earthstomp[id] = 0
	
	//If jump is is high enough, apply some shake effect and deal damage, 300 = down from BOMB A in dust2
	if (dam < 80)
		return PLUGIN_CONTINUE
	
	dam = dam-80
	
	message_begin(MSG_ONE , get_user_msgid("ScreenShake") , {0,0,0} ,id)
	write_short( 1<<14 );
	write_short( 1<<12 );
	write_short( 1<<14 );
	message_end();
	
	new entlist[513]
	new numfound = find_sphere_class(id,"player",230.0+player_strength[id]*2,entlist,512)
	
	
	for (new i=0; i < numfound; i++)
	{		
		new pid = entlist[i]
		
		if (pid == id || !is_user_alive(pid))
			continue
		
		if (get_user_team(id) == get_user_team(pid))
			continue
		
		new Float:id_origin[3]
		new Float:pid_origin[3]
		new Float:delta_vec[3]
		
		pev(id,pev_origin,id_origin)
		pev(pid,pev_origin,pid_origin)
		
		
		delta_vec[x] = (pid_origin[x]-id_origin[x])+10
		delta_vec[y] = (pid_origin[y]-id_origin[y])+10
		delta_vec[z] = (pid_origin[z]-id_origin[z])+200
		
		set_pev(pid,pev_velocity,delta_vec)
		
		message_begin(MSG_ONE , get_user_msgid("ScreenShake") , {0,0,0} ,pid)
		write_short( 1<<14 );
		write_short( 1<<12 );
		write_short( 1<<14 );
		message_end();
		
		if (get_user_health(pid) - dam <= 0)
			UTIL_Kill(id,pid,"world")
		else
			set_user_health(pid,get_user_health(pid)-dam)
		
		
		
	}
	
	return PLUGIN_CONTINUE
}

/* ==================================================================================================== */

public item_rot(id)
{
	if (used_item[id])
	{
		RemoveFlag(id,Flag_Rot)
		used_item[id] = false
	}
	else
	{
		if (find_ent_by_owner(-1,"Effect_Rot",id) > 0)
			return PLUGIN_CONTINUE
		
		Create_Rot(id)
		used_item[id] = true
	}
	
	return PLUGIN_CONTINUE
}

public Create_Rot(id)
{		
	new ent = Spawn_Ent("info_target")
	set_pev(ent,pev_classname,"Effect_Rot")
	set_pev(ent,pev_owner,id)
	set_pev(ent,pev_solid,SOLID_NOT)
	AddFlag(id,Flag_Rot)
	set_pev(ent,pev_nextthink, halflife_time() + 0.1)	
	
}

public Effect_Rot_Think(ent)
{
	new id = pev(ent,pev_owner)
	if (!is_user_alive(id) || !HasFlag(id,Flag_Rot) || !freeze_ended)
	{
		Display_Icon(id,255,255,0,"dmg_bio",0)	
		set_user_maxspeed(id,245.0+player_dextery[id])
		set_user_rendering(id,kRenderFxGlowShell,0,0,0,kRenderNormal,16)  
		remove_entity(ent)
		return PLUGIN_CONTINUE
	}
	
	set_user_maxspeed(id,252.0+player_dextery[id]+15)
	Display_Icon(id,255,150,0,"dmg_bio",1)	
	set_rendering ( id, kRenderFxGlowShell, 255,255,0, kRenderFxNone, 10 ) 
	
	new entlist[513]
	new numfound = find_sphere_class(id,"player",250.0,entlist,512)
	
	for (new i=0; i < numfound; i++)
	{		
		new pid = entlist[i]
		
		if (pid == id || !is_user_alive(pid))
			continue
		
		if (get_user_team(id) == get_user_team(pid))
			continue
		
		//Rot him!
		if (random_num(1,2) == 1)
		{
			message_begin(MSG_ONE,gmsgFade,{0,0,0},pid)
			write_short( 1<<14 ) 
			write_short( 1<<14 ) 
			write_short( 1<<16 ) 
			write_byte( 255 ) 
			write_byte( 155 ) 
			write_byte( 50 ) 
			write_byte( 230 ) 
			message_end()
		}
		
		Hurt_Entity(id,pid,45.0)
		Effect_Bleed(pid,100)
		Create_Slow(pid,3)
		
	}
	
	if (get_user_health(id)-10 <= 0)
		UTIL_Kill(id,id,"world")
	else
		set_user_health(id,get_user_health(id)-10)
	
	set_pev(ent,pev_nextthink, halflife_time() + 0.8)
	return PLUGIN_CONTINUE
}

/* ==================================================================================================== */

//Daze player
stock Create_Slow(id,seconds)
{		
	new ent = Spawn_Ent("info_target")
	set_pev(ent,pev_classname,"Effect_Slow")
	set_pev(ent,pev_owner,id)
	set_pev(ent,pev_ltime, halflife_time() + seconds + 0.1)
	set_pev(ent,pev_solid,SOLID_NOT)
	set_pev(ent,pev_nextthink, halflife_time() + 0.1)	
	
	AddFlag(id,Flag_Dazed)
}

public Effect_Slow_Think(ent)
{
	new id = pev(ent,pev_owner)
	if (pev(ent,pev_ltime) < halflife_time() || !is_user_alive(id))
	{
		Display_Icon(id,255,255,0,"dmg_heat",0)	
		RemoveFlag(id,Flag_Dazed)
		set_user_maxspeed(id,245.0+player_agility[id])
		remove_entity(ent)
		return PLUGIN_CONTINUE
	}
	
	set_user_maxspeed(id,245.0-50)
	Display_Icon(id,255,255,0,"dmg_heat",1)	
	set_pev(ent,pev_nextthink, halflife_time() + 1.0)
	return PLUGIN_CONTINUE
}

/* ==================================================================================================== */

stock AddTimedFlag(id,flag,seconds)
{		
	new ent = Spawn_Ent("info_target")
	set_pev(ent,pev_classname,"Effect_Timedflag")
	set_pev(ent,pev_owner,id)
	set_pev(ent,pev_ltime, halflife_time() + seconds + 0.1)
	set_pev(ent,pev_solid,SOLID_NOT)
	set_pev(ent,pev_euser3,flag)			
	AddFlag(id,flag)	
	set_pev(ent,pev_nextthink, halflife_time() + 0.1)
}

public Effect_Timedflag_Think(ent)
{
	new id = pev(ent,pev_owner)
	if (pev(ent,pev_ltime) < halflife_time() || !is_user_alive(id))
	{
		RemoveFlag(id,pev(ent,pev_euser3))
		remove_entity(ent)
		return PLUGIN_CONTINUE
	}
	
	set_pev(ent,pev_nextthink, halflife_time() + 1.0)
	return PLUGIN_CONTINUE
}

/* ==================================================================================================== */

public item_illusion(id)
{
	if (used_item[id])
	{
		hudmsg(id,2.0,"%s mozesz uzyc raz na runde",player_item_name[id])
		return PLUGIN_CONTINUE
	}
	
	AddTimedFlag(id,Flag_Illusion,7)
	message_begin( MSG_ONE, gmsgBartimer, {0,0,0}, id ) 
	write_byte( 7) 
	write_byte( 0 ) 
	message_end() 
	used_item[id] = true
	use_addtofullpack = true
	return PLUGIN_CONTINUE
	
}

/* ==================================================================================================== */

public item_money_shield(id)
{
	if (used_item[id])
	{
		RemoveFlag(id,Flag_Moneyshield)
		used_item[id] = false
	}
	else
	{
		if (find_ent_by_owner(-1,"Effect_MShield",id) > 0)
			return PLUGIN_CONTINUE
		
		new ent = Spawn_Ent("info_target")
		set_pev(ent,pev_classname,"Effect_MShield")
		set_pev(ent,pev_owner,id)
		set_pev(ent,pev_solid,SOLID_NOT)		
		AddFlag(id,Flag_Moneyshield)	
		set_pev(ent,pev_nextthink, halflife_time() + 0.1)
		used_item[id] = true
	}
	
	return PLUGIN_CONTINUE
}

public Effect_MShield_Think(ent)
{
	new id = pev(ent,pev_owner)
	if (!is_user_alive(id) || cs_get_user_money(id) <= 0 || !HasFlag(id,Flag_Moneyshield) || !freeze_ended)
	{
		RemoveFlag(id,Flag_Moneyshield)
		set_user_rendering(id,kRenderFxGlowShell,0,0,0,kRenderNormal,16)  
		Display_Icon(id,255,255,255,"suithelmet_empty",0)
		remove_entity(ent)
		return PLUGIN_CONTINUE
	}
	
	if (cs_get_user_money(id)-250 < 0)
		cs_set_user_money(id,0)
	else
		cs_set_user_money(id,cs_get_user_money(id)-250)
	
	set_rendering ( id, kRenderFxGlowShell, 255,255,255, kRenderFxNone, 10 ) 
	Display_Icon(id,255,255,255,"suithelmet_empty",1)
	
	set_pev(ent,pev_nextthink, halflife_time() + 1.0)
	return PLUGIN_CONTINUE
}

/* ==================================================================================================== */

public item_mine(id)
{
	new count = 0
	new ents = -1
	ents = find_ent_by_owner(ents,"Mine",id)
	while (ents > 0)
	{
		count++
		ents = find_ent_by_owner(ents,"Mine",id)
	}
	
	if (count > 2)
	{
		hudmsg(id,2.0,"Maksimum 3 miny na runde")
		return PLUGIN_CONTINUE
	}
	
	
	new origin[3]
	pev(id,pev_origin,origin)
	
	new ent = Spawn_Ent("info_target")
	set_pev(ent,pev_classname,"Mine")
	set_pev(ent,pev_owner,id)
	set_pev(ent,pev_movetype,MOVETYPE_TOSS)
	set_pev(ent,pev_origin,origin)
	set_pev(ent,pev_solid,SOLID_BBOX)
	
	engfunc(EngFunc_SetModel, ent, "addons/amxmodx/diablo/mine.mdl")  
	engfunc(EngFunc_SetSize,ent,Float:{-16.0,-16.0,0.0},Float:{16.0,16.0,2.0})
	
	drop_to_floor(ent)
	
	entity_set_float(ent,EV_FL_nextthink,halflife_time() + 0.01) 
	
	use_addtofullpack = true
	
	return PLUGIN_CONTINUE
}

public Mine_Think(ent)
{
	if (!freeze_ended)
		remove_entity(ent)
	else
		entity_set_float(ent,EV_FL_nextthink,halflife_time() + 1.0) 
}

/* ==================================================================================================== */

public item_teamshield(id)
{
	if (used_item[id])
	{
		RemoveFlag(id,Flag_Teamshield)
		used_item[id] = false
	}
	else
	{
		new target = Find_Best_Angle(id,1000.0,true)
		
		if (!is_valid_ent(target))
		{
			hudmsg(id,2.0,"Brak celu w zasiegu tarczy")
			return PLUGIN_CONTINUE
		}
		
		if (pev(target,pev_rendermode) == kRenderTransTexture || player_item_id[target] == 17)
		{
			hudmsg(id,2.0,"Nie mozesz uzyc tego na niewidzialnych graczach!")
			return PLUGIN_CONTINUE
		}
		
		if (find_ent_by_owner(-1,"Effect_Teamshield",id) > 0)
			return PLUGIN_CONTINUE
		
		new ent = Spawn_Ent("info_target")
		set_pev(ent,pev_classname,"Effect_Teamshield")
		set_pev(ent,pev_owner,id)
		set_pev(ent,pev_solid,SOLID_NOT)
		set_pev(ent,pev_nextthink, halflife_time() + 0.1)	
		set_pev(ent,pev_euser2, target)	
		
		AddFlag(id,Flag_Teamshield)
		AddFlag(target,Flag_Teamshield_Target)
		used_item[id] = true
	}
	
	return PLUGIN_CONTINUE
}

public Effect_Teamshield_Think(ent)
{
	new id = pev(ent,pev_owner)
	new victim = pev(ent,pev_euser2)
	new target = Find_Best_Angle(id,750.0,true)
	
	
	if (!is_valid_ent(target) || !is_user_alive(id) || !is_user_alive(victim) || !Can_Trace_Line(id,victim) || !UTIL_In_FOV(id,victim) || !HasFlag(id,Flag_Teamshield) || !freeze_ended)
	{
		set_rendering (victim, kRenderFxNone, 0,0,0, kRenderFxNone, 0 ) 
		RemoveFlag(id,Flag_Teamshield)
		RemoveFlag(victim,Flag_Teamshield_Target)
		remove_entity(ent)
		return PLUGIN_CONTINUE
	}
	else		
		set_pev(ent,pev_nextthink, halflife_time() + 0.3)
	
	new origin1[3]
	new origin2[3]
	
	get_user_origin(id,origin1)
	get_user_origin(victim,origin2)
	
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY) 
	write_byte (TE_BEAMPOINTS)
	write_coord(origin1[0])
	write_coord(origin1[1])
	write_coord(origin1[2]+8)
	write_coord(origin2[0])
	write_coord(origin2[1])
	write_coord(origin2[2]+8)
	write_short(sprite_laser);
	write_byte(1) // framestart 
	write_byte(1) // framerate 
	write_byte(3) // life 
	write_byte(5) // width 
	write_byte(10) // noise 
	write_byte(0) // r, g, b (red)
	write_byte(255) // r, g, b (green)
	write_byte(0) // r, g, b (blue)
	write_byte(45) // brightness 
	write_byte(5) // speed 
	message_end()    
	
	set_rendering ( victim, kRenderFxGlowShell, 0,200,0, kRenderFxNone, 0 ) 
	
	return PLUGIN_CONTINUE
}

/* ==================================================================================================== */	

//Find the owner that has target as target and the specific classname
public find_owner_by_euser(target,classname[])
{
	new ent = -1
	ent = find_ent_by_class(ent,classname)
	
	while (ent > 0)
	{
		if (pev(ent,pev_euser2) == target)
			return pev(ent,pev_owner)
		ent = find_ent_by_class(ent,classname)
	}
	
	return -1
}
/* ==================================================================================================== */

public item_usespawn(id)
{
	if (used_item[id])
	{
		hudmsg(id,2.0,"Mozesz uzyc jeden Spawn na runde")
	}
	else 
	{
		if(!is_user_alive(id))
		{
			spawn(id);
			spawn(id);
			used_item[id] = true
			
		}
		else client_print(id, print_center, "Nie mozesz uzyc spawnu kiedy zyjesz")
	}
}

/* ==================================================================================================== */

public item_totemheal(id)
{
	if (used_item[id])
	{
		hudmsg(id,2.0,"Mozesz polozyc tylko jeden Totem na runde")
		return PLUGIN_CONTINUE
	}
	
	used_item[id] = true
	
	new origin[3]
	pev(id,pev_origin,origin)
	
	new ent = Spawn_Ent("info_target")
	set_pev(ent,pev_classname,"Effect_Healing_Totem")
	set_pev(ent,pev_owner,id)
	set_pev(ent,pev_solid,SOLID_TRIGGER)
	set_pev(ent,pev_origin,origin)
	set_pev(ent,pev_ltime, halflife_time() + 7 + 0.1)
	
	engfunc(EngFunc_SetModel, ent, "addons/amxmodx/diablo/totem_heal.mdl")  	
	set_rendering ( ent, kRenderFxGlowShell, 255,0,0, kRenderFxNone, 255 ) 	
	engfunc(EngFunc_DropToFloor,ent)
	
	set_pev(ent,pev_nextthink, halflife_time() + 0.1)
	
	return PLUGIN_CONTINUE	
}

public Effect_Healing_Totem_Think(ent)
{
	new id = pev(ent,pev_owner)
	new amount_healed
	new totem_dist = 300+player_intelligence[id]+player_powerint[id]
	if (player_b_heal[id] > 0) amount_healed = player_b_heal[id]
	if (player_class[id] == MEER) amount_healed = 10+player_intelligence[id]*2+player_powerint[id]*2
	
	//We have emitted beam. Apply effect (this is delayed)
	if (pev(ent,pev_euser2) == 1)
	{		
		new Float:forigin[3], origin[3]
		pev(ent,pev_origin,forigin)	
		FVecIVec(forigin,origin)
		
		//Find people near and damage them
		new entlist[513]
		new numfound = find_sphere_class(0,"player",totem_dist+0.0,entlist,512,forigin)
		
		for (new i=0; i < numfound; i++)
		{		
			new pid = entlist[i]
			
			if (get_user_team(pid) != get_user_team(id))
				continue
			
			
			if (is_user_alive(pid) && get_user_health(pid) + amount_healed < 100+player_strength[pid]*2)
				set_user_health(pid,get_user_health(pid)+amount_healed)
			else
				set_user_health(pid,100+player_strength[pid]*2)				
		}
		
		
		set_pev(ent,pev_euser2,0)
		set_pev(ent,pev_nextthink, halflife_time() + 1.5)
		
		return PLUGIN_CONTINUE
	}
	
	
	//Entity should be destroyed because livetime is over
	if (pev(ent,pev_ltime) < halflife_time() || !is_user_alive(id))
	{
		remove_entity(ent)
		return PLUGIN_CONTINUE
	}
	
	
	
	//If this object is almost dead, apply some render to make it fade out
	if (pev(ent,pev_ltime)-2.0 < halflife_time())
		set_rendering ( ent, kRenderFxNone, 255,255,255, kRenderTransAlpha, 100 ) 
	
	
	
	new Float:forigin[3], origin[3]
	pev(ent,pev_origin,forigin)	
	FVecIVec(forigin,origin)
	
	
	
	//Find people near and give them health
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY, origin );
	write_byte( TE_BEAMCYLINDER );
	write_coord( origin[0] );
	write_coord( origin[1] );
	write_coord( origin[2] );
	write_coord( origin[0] );
	write_coord( origin[1] + totem_dist );
	write_coord( origin[2] + totem_dist );
	write_short( sprite_white );
	write_byte( 0 ); // startframe
	write_byte( 0 ); // framerate
	write_byte( 10 ); // life
	write_byte( 10 ); // width
	write_byte( 255 ); // noise
	write_byte( 255 ); // r, g, b
	write_byte( 100 ); // r, g, b
	write_byte( 100 ); // r, g, b
	write_byte( 128 ); // brightness
	write_byte( 5 ); // speed
	message_end();
	
	//Time till we apply totems effect
	
	set_pev(ent,pev_euser2,1)
	set_pev(ent,pev_nextthink, halflife_time() + 0.5)
	
	
	return PLUGIN_CONTINUE
	
}
